# MySQL-Front 3.2  (Build 10.27)

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES */;

/*!40101 SET NAMES cp1251 */;
/*!40103 SET TIME_ZONE='SYSTEM' */;

# Host: localhost    Database: aplite1_7
# ------------------------------------------------------
# Server version 5.0.51a-community-nt

#
# Table structure for table admins
#

CREATE TABLE `admins` (
  `Admin_Id` int(11) NOT NULL auto_increment,
  `Name` varchar(255) default NULL,
  `Login` varchar(32) default NULL,
  `Pass` varchar(32) default NULL,
  `IsAdmin` tinyint(1) default NULL,
  `IsWebmaster` tinyint(1) default NULL,
  `IsStaticsEditor` tinyint(1) default NULL,
  PRIMARY KEY  (`Admin_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;


#
# Table structure for table fb_inquirer
#

CREATE TABLE `fb_inquirer` (
  `Inquirer_Id` int(11) NOT NULL auto_increment,
  `Identifier` varchar(255) default NULL,
  `Title` varchar(255) default NULL,
  `Dat` date NOT NULL default '0000-00-00',
  `IsActive` tinyint(1) NOT NULL default '0',
  `WasActive` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`Inquirer_Id`)
) ENGINE=MyISAM AUTO_INCREMENT=4 DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;


#
# Table structure for table fb_inquirer_answer
#

CREATE TABLE `fb_inquirer_answer` (
  `Answer_Id` int(11) NOT NULL auto_increment,
  `Question_Id` int(11) NOT NULL default '0',
  `Title` varchar(255) default NULL,
  `Count` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`Answer_Id`),
  KEY `question_answer_FK` (`Question_Id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;


#
# Table structure for table fb_inquirer_question
#

CREATE TABLE `fb_inquirer_question` (
  `Question_Id` int(11) NOT NULL auto_increment,
  `Inquirer_Id` int(11) NOT NULL default '0',
  `Title` varchar(255) default NULL,
  `Kind` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`Question_Id`),
  KEY `inquirer_question_FK` (`Inquirer_Id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=cp1251 ROW_FORMAT=DYNAMIC;


#
# Table structure for table forms
#

CREATE TABLE `forms` (
  `Form_Id` int(11) NOT NULL auto_increment,
  `Ie_Id` int(11) default NULL,
  `Identifier` varchar(255) default NULL,
  `Title` varchar(255) default NULL,
  `Body` text,
  PRIMARY KEY  (`Form_Id`),
  KEY `ie_form_FK` (`Ie_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table ie1
#

CREATE TABLE `ie1` (
  `Id` int(11) NOT NULL auto_increment,
  `Modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `Admin_Creator_Id` int(11) NOT NULL default '0',
  `Admin_Lastmodif_Id` int(11) NOT NULL default '0',
  `TXT` text NOT NULL,
  PRIMARY KEY  (`Id`),
  FULLTEXT KEY `FT_TXT` (`TXT`)
) ENGINE=MyISAM AUTO_INCREMENT=36 DEFAULT CHARSET=cp1251 COMMENT=' ';


#
# Table structure for table ie10
#

CREATE TABLE `ie10` (
  `Id` int(11) NOT NULL auto_increment,
  `Modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `Admin_Creator_Id` int(11) NOT NULL default '0',
  `Admin_Lastmodif_Id` int(11) NOT NULL default '0',
  `NICK` varchar(255) NOT NULL default '',
  `NAME` varchar(255) NOT NULL default '',
  `SIRNAME` varchar(255) NOT NULL default '',
  `LOGIN` varchar(255) NOT NULL default '',
  `PASS` varchar(255) NOT NULL default '',
  `LICENSE_AGREE` tinyint(1) NOT NULL default '0',
  `EMAIL_CONF` tinyint(1) NOT NULL default '0',
  `DISABLED` tinyint(1) NOT NULL default '0',
  `DELETED` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`Id`),
  FULLTEXT KEY `FT_NICK` (`NICK`),
  FULLTEXT KEY `FT_NAME` (`NAME`),
  FULLTEXT KEY `FT_SIRNAME` (`SIRNAME`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=cp1251 COMMENT='';


#
# Table structure for table ie11
#

CREATE TABLE `ie11` (
  `Id` int(11) NOT NULL auto_increment,
  `Modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `Admin_Creator_Id` int(11) NOT NULL default '0',
  `Admin_Lastmodif_Id` int(11) NOT NULL default '0',
  `TITLE` varchar(255) NOT NULL default '',
  `DATESTART` date default NULL,
  `DATESTOP` date default NULL,
  `TXT` text NOT NULL,
  PRIMARY KEY  (`Id`),
  FULLTEXT KEY `FT_TITLE` (`TITLE`),
  FULLTEXT KEY `FT_TXT` (`TXT`)
) ENGINE=MyISAM AUTO_INCREMENT=543 DEFAULT CHARSET=cp1251 COMMENT='';


#
# Table structure for table ie8
#

CREATE TABLE `ie8` (
  `Id` int(11) NOT NULL auto_increment,
  `Modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `Admin_Creator_Id` int(11) NOT NULL default '0',
  `Admin_Lastmodif_Id` int(11) NOT NULL default '0',
  `TITLE` varchar(255) NOT NULL default '',
  `DATE` date default NULL,
  `TXT` text NOT NULL,
  `ANONS` text NOT NULL,
  `FIELD_60` decimal(10,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`Id`),
  KEY `I_FIELD_60` (`FIELD_60`),
  FULLTEXT KEY `FT_TITLE` (`TITLE`),
  FULLTEXT KEY `FT_TXT` (`TXT`),
  FULLTEXT KEY `FT_ANONS` (`ANONS`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251 COMMENT='';


#
# Table structure for table ie9
#

CREATE TABLE `ie9` (
  `Id` int(11) NOT NULL auto_increment,
  `Modified` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `Admin_Creator_Id` int(11) NOT NULL default '0',
  `Admin_Lastmodif_Id` int(11) NOT NULL default '0',
  `TITLE` varchar(255) NOT NULL default '',
  `TXT` text NOT NULL,
  `SHORT` varchar(255) NOT NULL default '',
  `URL` text NOT NULL,
  `TAGS` text NOT NULL,
  `USERIE` text NOT NULL,
  `FIELD_59` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`Id`),
  FULLTEXT KEY `FT_TITLE` (`TITLE`),
  FULLTEXT KEY `FT_TXT` (`TXT`),
  FULLTEXT KEY `FT_SHORT` (`SHORT`),
  FULLTEXT KEY `FT_URL` (`URL`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=cp1251 COMMENT='';


#
# Table structure for table ie_fields
#

CREATE TABLE `ie_fields` (
  `Field_Id` int(11) NOT NULL auto_increment,
  `Ie_Id` int(11) default NULL,
  `Identifier` varchar(100) NOT NULL default '',
  `Kind` varchar(100) default NULL,
  `Title` varchar(255) default NULL,
  `Ord` int(11) default '0',
  `For_Sort` int(11) default NULL,
  `ShowPreview` tinyint(1) default NULL,
  `Properties_I` bigint(20) default NULL,
  `Properties` varchar(255) default NULL,
  PRIMARY KEY  (`Field_Id`),
  KEY `Ie_Field_FK` (`Ie_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=65 DEFAULT CHARSET=cp1251;


#
# Table structure for table ie_files
#

CREATE TABLE `ie_files` (
  `File_Id` int(11) NOT NULL auto_increment,
  `Filename` varchar(255) default NULL,
  PRIMARY KEY  (`File_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table ie_groups
#

CREATE TABLE `ie_groups` (
  `Ie_Group_Id` int(11) NOT NULL auto_increment,
  `Identifier` varchar(100) NOT NULL default '',
  `Title` varchar(255) NOT NULL default '',
  `Ord` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`Ie_Group_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;


#
# Table structure for table ie_ie
#

CREATE TABLE `ie_ie` (
  `P_Ie` int(11) NOT NULL default '0',
  `P_Ie_Id` int(11) NOT NULL default '0',
  `Field_Id` int(11) NOT NULL default '0',
  `C_Ie` int(11) NOT NULL default '0',
  `C_Ie_Id` int(11) NOT NULL default '0',
  `Ord` int(11) NOT NULL default '1',
  `DT` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (`P_Ie`,`P_Ie_Id`,`Field_Id`,`C_Ie`,`C_Ie_Id`),
  KEY `P_Ie_Id` (`P_Ie`,`P_Ie_Id`),
  KEY `C_Ie_Id` (`C_Ie`,`C_Ie_Id`),
  KEY `Field` (`Field_Id`),
  KEY `Ie_Field` (`Field_Id`,`P_Ie_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251 COMMENT=' ';


#
# Table structure for table ie_permissions
#

CREATE TABLE `ie_permissions` (
  `Admin_Id` int(11) NOT NULL default '0',
  `Ie_Id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`Admin_Id`,`Ie_Id`),
  KEY `ie_permissions_FK` (`Admin_Id`),
  KEY `ie_permissions2_FK` (`Ie_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table ie_selects
#

CREATE TABLE `ie_selects` (
  `Select_Id` int(11) NOT NULL auto_increment,
  `Field_Id` int(11) default NULL,
  `Identifier` varchar(100) NOT NULL default '',
  `Title` varchar(255) default NULL,
  PRIMARY KEY  (`Select_Id`),
  KEY `Field_Select_FK` (`Field_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=cp1251;


#
# Table structure for table ie_templates
#

CREATE TABLE `ie_templates` (
  `Template_Id` int(11) NOT NULL auto_increment,
  `Ie_Id` int(11) default NULL,
  `Identifier` varchar(100) NOT NULL default '',
  `Title` varchar(255) default NULL,
  `Body` text,
  PRIMARY KEY  (`Template_Id`),
  UNIQUE KEY `Ident_Ie` (`Ie_Id`,`Identifier`),
  KEY `Ie_Template_FK` (`Ie_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=cp1251;


#
# Table structure for table ierub_fieldrestrictions
#

CREATE TABLE `ierub_fieldrestrictions` (
  `Restriction_Id` int(11) NOT NULL auto_increment,
  `Field_Id` int(11) default NULL,
  `Kind` varchar(32) default NULL,
  `Properties_I` int(11) default NULL,
  `Properties` varchar(255) default NULL,
  PRIMARY KEY  (`Restriction_Id`),
  KEY `fields_restrictions_FK` (`Field_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table ies
#

CREATE TABLE `ies` (
  `Ie_Id` int(11) NOT NULL auto_increment,
  `Ie_Group_Id` int(11) default NULL,
  `Group_Id` int(11) default NULL,
  `Identifier` varchar(100) NOT NULL default '',
  `Title` varchar(255) NOT NULL default '',
  `Ord` smallint(6) NOT NULL default '0',
  `Flags` bigint(20) default '0',
  PRIMARY KEY  (`Ie_Id`),
  KEY `Relationship_15_FK` (`Group_Id`),
  KEY `Ie_group_FK` (`Ie_Group_Id`),
  KEY `Identifier` (`Identifier`)
) ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=cp1251;


#
# Table structure for table image_groups
#

CREATE TABLE `image_groups` (
  `Image_Group_Id` int(11) NOT NULL auto_increment,
  `Parent_Id` int(11) default NULL,
  `Title` varchar(255) default NULL,
  PRIMARY KEY  (`Image_Group_Id`),
  KEY `Parent_Id_FK` (`Parent_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;


#
# Table structure for table images
#

CREATE TABLE `images` (
  `Image_Id` int(11) NOT NULL auto_increment,
  `Image_Group_Id` int(11) default NULL,
  `FileName` varchar(255) default NULL,
  `Full_FileName` varchar(255) default NULL,
  PRIMARY KEY  (`Image_Id`),
  KEY `Images_Groups_FK` (`Image_Group_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;


#
# Table structure for table mod_permissions
#

CREATE TABLE `mod_permissions` (
  `Admin_Id` int(11) NOT NULL default '0',
  `Mod_Id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`Admin_Id`,`Mod_Id`),
  KEY `mod_permissions_FK` (`Admin_Id`),
  KEY `mod_permissions2_FK` (`Mod_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table mods
#

CREATE TABLE `mods` (
  `Mod_Id` int(11) NOT NULL auto_increment,
  `Identifier` varchar(255) default NULL,
  `Title` varchar(255) default NULL,
  `Ord` int(11) default NULL,
  `State` tinyint(1) default NULL,
  PRIMARY KEY  (`Mod_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;


#
# Table structure for table publish_permissions
#

CREATE TABLE `publish_permissions` (
  `Rub_Id` int(11) NOT NULL default '0',
  `Admin_Id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`Rub_Id`,`Admin_Id`),
  KEY `publish_permissions_FK` (`Rub_Id`),
  KEY `publish_permissions2_FK` (`Admin_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table restruct_permissions
#

CREATE TABLE `restruct_permissions` (
  `Admin_Id` int(11) NOT NULL default '0',
  `Group_Id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`Admin_Id`,`Group_Id`),
  KEY `restruct_permissions_FK` (`Admin_Id`),
  KEY `restruct_permissions2_FK` (`Group_Id`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table rub_groups
#

CREATE TABLE `rub_groups` (
  `Group_Id` int(11) NOT NULL auto_increment,
  `Identifier` varchar(100) NOT NULL default '',
  `Title` varchar(255) default NULL,
  `Rub_Levels_Max` smallint(6) default NULL,
  PRIMARY KEY  (`Group_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;


#
# Table structure for table rub_ie
#

CREATE TABLE `rub_ie` (
  `Rub` int(11) NOT NULL default '0',
  `Ie` int(11) NOT NULL default '0',
  `Ie_Table` int(11) NOT NULL default '0',
  `Admin_Id` int(11) NOT NULL default '0',
  `Pub_Date` datetime NOT NULL default '0000-00-00 00:00:00',
  `Ord` int(11) default NULL,
  `Sort_String` varchar(255) default NULL,
  PRIMARY KEY  (`Rub`,`Ie`,`Ie_Table`),
  KEY `publication_admin_FK` (`Admin_Id`),
  KEY `Rubric` (`Rub`),
  KEY `Rub_Ie` (`Rub`,`Ie_Table`),
  KEY `IE` (`Ie_Table`,`Ie`)
) ENGINE=InnoDB DEFAULT CHARSET=cp1251;


#
# Table structure for table rubs
#

CREATE TABLE `rubs` (
  `Rub_Id` int(11) NOT NULL auto_increment,
  `Group_Id` int(11) default NULL,
  `Rub_Parent` int(11) NOT NULL default '0',
  `Ord` int(11) NOT NULL default '0',
  `Identifier` varchar(100) NOT NULL default '',
  `Title` varchar(255) default NULL,
  `Ie_Data_Id` int(11) default NULL,
  `SortType` smallint(6) default NULL,
  `Flags` bigint(20) default '0',
  PRIMARY KEY  (`Rub_Id`),
  KEY `Rub_Group_FK` (`Group_Id`),
  KEY `Ident_Par_Gr` (`Group_Id`,`Rub_Parent`,`Identifier`)
) ENGINE=InnoDB AUTO_INCREMENT=36 DEFAULT CHARSET=cp1251;


#
# Table structure for table statics
#

CREATE TABLE `statics` (
  `Static_Id` int(11) NOT NULL auto_increment,
  `Admin_Id` int(11) default NULL,
  `Identifier` varchar(100) default NULL,
  `Title` varchar(255) default NULL,
  `Value` text,
  `Kind` varchar(100) default NULL,
  PRIMARY KEY  (`Static_Id`),
  KEY `static_admin_FK` (`Admin_Id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=cp1251;


#
#  Foreign keys for table forms
#

ALTER TABLE `forms`
  ADD FOREIGN KEY (`Ie_Id`) REFERENCES `ies` (`Ie_Id`);

#
#  Foreign keys for table ie_fields
#

ALTER TABLE `ie_fields`
  ADD FOREIGN KEY (`Ie_Id`) REFERENCES `ies` (`Ie_Id`);

#
#  Foreign keys for table ie_ie
#

ALTER TABLE `ie_ie`
  ADD FOREIGN KEY (`Field_Id`) REFERENCES `ie_fields` (`Field_Id`);

#
#  Foreign keys for table ie_permissions
#

ALTER TABLE `ie_permissions`
  ADD FOREIGN KEY (`Admin_Id`) REFERENCES `admins` (`Admin_Id`),
  ADD FOREIGN KEY (`Ie_Id`) REFERENCES `ies` (`Ie_Id`);

#
#  Foreign keys for table ie_selects
#

ALTER TABLE `ie_selects`
  ADD FOREIGN KEY (`Field_Id`) REFERENCES `ie_fields` (`Field_Id`);

#
#  Foreign keys for table ie_templates
#

ALTER TABLE `ie_templates`
  ADD FOREIGN KEY (`Ie_Id`) REFERENCES `ies` (`Ie_Id`);

#
#  Foreign keys for table ierub_fieldrestrictions
#

ALTER TABLE `ierub_fieldrestrictions`
  ADD FOREIGN KEY (`Field_Id`) REFERENCES `ie_fields` (`Field_Id`);

#
#  Foreign keys for table ies
#

ALTER TABLE `ies`
  ADD FOREIGN KEY (`Ie_Group_Id`) REFERENCES `ie_groups` (`Ie_Group_Id`),
  ADD FOREIGN KEY (`Group_Id`) REFERENCES `rub_groups` (`Group_Id`);

#
#  Foreign keys for table images
#

ALTER TABLE `images`
  ADD FOREIGN KEY (`Image_Group_Id`) REFERENCES `image_groups` (`Image_Group_Id`);

#
#  Foreign keys for table mod_permissions
#

ALTER TABLE `mod_permissions`
  ADD FOREIGN KEY (`Admin_Id`) REFERENCES `admins` (`Admin_Id`),
  ADD FOREIGN KEY (`Mod_Id`) REFERENCES `mods` (`Mod_Id`);

#
#  Foreign keys for table publish_permissions
#

ALTER TABLE `publish_permissions`
  ADD FOREIGN KEY (`Rub_Id`) REFERENCES `rubs` (`Rub_Id`),
  ADD FOREIGN KEY (`Admin_Id`) REFERENCES `admins` (`Admin_Id`);

#
#  Foreign keys for table restruct_permissions
#

ALTER TABLE `restruct_permissions`
  ADD FOREIGN KEY (`Admin_Id`) REFERENCES `admins` (`Admin_Id`),
  ADD FOREIGN KEY (`Group_Id`) REFERENCES `rub_groups` (`Group_Id`);

#
#  Foreign keys for table rub_ie
#

ALTER TABLE `rub_ie`
  ADD FOREIGN KEY (`Admin_Id`) REFERENCES `admins` (`Admin_Id`);

#
#  Foreign keys for table rubs
#

ALTER TABLE `rubs`
  ADD FOREIGN KEY (`Group_Id`) REFERENCES `rub_groups` (`Group_Id`);

#
#  Foreign keys for table statics
#

ALTER TABLE `statics`
  ADD FOREIGN KEY (`Admin_Id`) REFERENCES `admins` (`Admin_Id`);

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
