/*==============================================================*/
/* DBMS name:      MySQL 4.0                                    */
/* Created on:     19.07.2006 13:01:45                          */
/*==============================================================*/


drop index Relationship_13_FK on shop_catalog;

drop index Relationship_3_FK on shop_data;

drop index Relationship_4_FK on shop_data;

drop index Relationship_1_FK on shop_fields;

drop index Relationship_2_FK on shop_goods;

drop index Relationship_6_FK on shop_images;

/*==============================================================*/
/* Table: shop_catalog                                          */
/*==============================================================*/
create table shop_catalog
(
   Id                             int                            not null AUTO_INCREMENT,
   Par_Id                         int,
   Title                          varchar(255),
   Description                    text,
   Hidden                         tinyint(1),
   Ord                            int,
   primary key (Id)
);

/*==============================================================*/
/* Index: Relationship_13_FK                                    */
/*==============================================================*/
create index Relationship_13_FK on shop_catalog
(
   Par_Id
);

/*==============================================================*/
/* Table: shop_data                                             */
/*==============================================================*/
create table shop_data
(
   Id                             int                            not null AUTO_INCREMENT,
   Field_Id                       int,
   Goods_Id                       int,
   DataVarchar                    varchar(255),
   DataFloat                      float,
   primary key (Id)
);

/*==============================================================*/
/* Index: Relationship_3_FK                                     */
/*==============================================================*/
create index Relationship_3_FK on shop_data
(
   Goods_Id
);

/*==============================================================*/
/* Index: Relationship_4_FK                                     */
/*==============================================================*/
create index Relationship_4_FK on shop_data
(
   Field_Id
);

/*==============================================================*/
/* Table: shop_fields                                           */
/*==============================================================*/
create table shop_fields
(
   Id                             int                            not null AUTO_INCREMENT,
   Catalog_Id                     int,
   Title                          varchar(255),
   Kind                           varchar(100),
   Attr                           text,
   Ord                            int,
   primary key (Id)
);

/*==============================================================*/
/* Index: Relationship_1_FK                                     */
/*==============================================================*/
create index Relationship_1_FK on shop_fields
(
   Catalog_Id
);

/*==============================================================*/
/* Table: shop_goods                                            */
/*==============================================================*/
create table shop_goods
(
   Id                             int                            not null AUTO_INCREMENT,
   Catalog_Id                     int,
   Firm_Id                        int,
   Identifier                     varchar(255)                   not null,
   Title                          varchar(255),
   Price                          float(8,2),
   Description                    text,
   PreviewFilename                varchar(255),
   Hidden                         tinyint(1),
   GoodsStatus                    int,
   AddCatalog_Id                  int,
   primary key (Id)
);

/*==============================================================*/
/* Index: Relationship_2_FK                                     */
/*==============================================================*/
create index Relationship_2_FK on shop_goods
(
   Catalog_Id
);

/*==============================================================*/
/* Table: shop_images                                           */
/*==============================================================*/
create table shop_images
(
   Id                             int                            not null AUTO_INCREMENT,
   Goods_Id                       int,
   Filename                       varchar(255),
   Title                          varchar(255),
   primary key (Id)
);

/*==============================================================*/
/* Index: Relationship_6_FK                                     */
/*==============================================================*/
create index Relationship_6_FK on shop_images
(
   Goods_Id
);

/*==============================================================*/
/* Table: shop_users                                            */
/*==============================================================*/
create table shop_users
(
   Id                             int                            not null AUTO_INCREMENT,
   FirstName                      varchar(255),
   LastName                       varchar(255),
   Login                          varchar(32),
   Pass                           varchar(32),
   Email                          varchar(100),
   Phone                          varchar(255),
   Address                        text,
   AdminComments                  text,
   RegDate                        datetime,
   primary key (Id)
);

alter table shop_catalog add constraint FK_Relationship_11 foreign key (Par_Id)
      references shop_catalog (Id);

alter table shop_data add constraint FK_Relationship_3 foreign key (Goods_Id)
      references shop_goods (Id);

alter table shop_data add constraint FK_Relationship_4 foreign key (Field_Id)
      references shop_fields (Id);

alter table shop_fields add constraint FK_Relationship_1 foreign key (Catalog_Id)
      references shop_catalog (Id);

alter table shop_goods add constraint FK_Relationship_2 foreign key (Catalog_Id)
      references shop_catalog (Id);

alter table shop_images add constraint FK_Relationship_6 foreign key (Goods_Id)
      references shop_goods (Id);

