/*==============================================================*/
/* Database name:  ApLite_Physical                              */
/* DBMS name:      MySQL 3.23                                   */
/* Created on:     13.12.2005 12:48:10                          */
/*==============================================================*/


/*==============================================================*/
/* Table: stats_rub_groups                                      */
/*==============================================================*/
create table if not exists stats_rub_groups
(
   Group_Id                       int                            not null,
   Options                        smallint                       default 0,
   primary key (Group_Id)
);

/*==============================================================*/
/* Table: stats_rubs                                            */
/*==============================================================*/
create table if not exists stats_rubs
(
   Rub_Id                         int                            not null,
   Title                          varchar(255),
   Hits                           bigint                         default 0,
   primary key (Rub_Id)
);

/*==============================================================*/
/* Table: stats_visiters                                        */
/*==============================================================*/
create table if not exists stats_visiters
(
   Visiter_Id                     int                            not null AUTO_INCREMENT,
   Host_IP                        varchar(23)                    not null default '127.0.0.1',
   Host_Alpha                     varchar(255),
   Visits                         bigint                         default 0,
   primary key (Visiter_Id),
   unique (Host_IP)
);

/*==============================================================*/
/* Index: stats_visiters_AK                                     */
/*==============================================================*/
create unique index stats_visiters_AK on stats_visiters
(
   Host_IP
);

/*==============================================================*/
/* Table: stats_visits                                          */
/*==============================================================*/
create table if not exists stats_visits
(
   Visiter_Id                     int                            not null,
   Rub_Id                         int                            not null,
   Visit_DT                       datetime                       not null,
   Visit_Date                     date                           not null,
   Visit_Time                     time                           not null,
   HTTP_REFERER                   varchar(255)
);

/*==============================================================*/
/* Index: Hosts_Visits_FK                                       */
/*==============================================================*/
create index Hosts_Visits_FK on stats_visits
(
   Visiter_Id
);

/*==============================================================*/
/* Index: Rubs_Visits_FK                                        */
/*==============================================================*/
create index Rubs_Visits_FK on stats_visits
(
   Rub_Id
);

/*==============================================================*/
/* Index: Stats_Visit_Date                                      */
/*==============================================================*/
create index Stats_Visit_Date on stats_visits
(
   Visit_Date
);

