function fixDate(date) 
{
	var base = new Date(0);
	var skew = base.getTime();
	if (skew > 0) date.setTime(date.getTime() - skew);
}

function setCookie(name, value, expires, path, domain, secure) 
{
	var curCookie = name + "=" + escape(value) +
	((expires) ? "; expires=" + expires.toGMTString() : "") +
 	((path) ? "; path=" + path : "") +
 	((domain) ? "; domain=" + domain : "") +
 	((secure) ? "; secure" : "");
	document.cookie = curCookie;
}

function getCookie(name) 
{
	var dc = document.cookie;
	var prefix = name + "=";
	var begin = dc.indexOf("; " + prefix);
	if (begin == -1) 
	{
		begin = dc.indexOf(prefix);
	    if (begin != 0) return null;
	} 
	else begin += 2;
	var end = document.cookie.indexOf(";", begin);
	if (end == -1) end = dc.length;
	return unescape(dc.substring(begin + prefix.length, end));
}

function deleteCookie(name, path, domain) 
{
	if (getCookie(name)) 
	{
    	document.cookie = name + "=" + 
	    ((path) ? "; path=" + path : "") +
    	((domain) ? "; domain=" + domain : "") +
	    "; expires=Thu, 01-Jan-70 00:00:01 GMT";
	}
}

function tree_Show()
{
	var disp = this.openflag;
	var curlev = this.curlevel;
	var now = new Date();
	fixDate(now);
	
	var struct =  (tree_Show.arguments.length == 0) ? this.struct : tree_Show.arguments[0];
	for(var i=0; i<struct.length; i++)
	{
		var display = (this.level == 0 || disp) ?  "block" : "none";
		var img = this.img_plus.src;
		if (this.usecookie) if (getCookie("v6tree" + this.instance + struct[i]["nodenum"]) == "open")
		{
			display = "block";
			struct[i]["opened"] = true;
			img = this.img_minus.src;
		}
		
		if (this.level >= curlev && curlev != 0) 
		{
			display = "none";
		}
		else
		{
			this.curlevel = 0;
		}
		document.write('<div style="width:100%;display: ' + display + ';padding-left:' + this.level*18 + '" id="treenode' + this.instance + "_"  + struct[i]['nodenum'] + '" class="treenodeblock">');
		document.write('<table border="0" cellspacing="0" cellpadding="0" style="margin-left:2px;width:100%"><tr>');
		if (struct[i]['child'] != null)
		{
			document.write('<td id="nopad" valign="top" style="padding-top:3px;width:1px"><a href="javascript:' + this.instance + '.ShowHideNode(' + struct[i]['nodenum'] + ')"><img src="'+ img + '" name="treeimg' + this.instance + "_" + struct[i]['nodenum'] + '" width="14" height="14" alt="" border="0"></a></td>');
		}
		else
		{
			document.write('<td id="nopad" valign="top" style="padding-top:3px;width:1px"><img src="' + this.img_sp.src + '" width="14" height="14" alt="" border="0"></td>');
		}
		document.write('<td id="nopad">' + struct[i]['text'] + '</td>');
		document.write('</tr></table>');
		document.write('</div>');
		
		if (struct[i]['child'] != null)
		{
			this.openflag = struct[i]['opened'];
			this.level++;
			if (!struct[i]['opened']) this.curlevel = this.level;			
			this.Show(struct[i]['child']);
			this.openflag = false;
		}
	}
	this.level--;
}

function tree_GetNode(nodenum)
{
	var struct =  (tree_GetNode.arguments.length == 1) ? this.struct : tree_GetNode.arguments[1];
	var result = false;
	for(var i=0; i<struct.length; i++)
	{
		if (struct[i]['nodenum'] == nodenum) 
		{
			return struct[i];
		}
		if (struct[i]['child'] != null) 
		{
			result = this.GetNode(nodenum, struct[i]['child']);
			if (result != false) return result;
		}
	}
	return result;
}

function tree_HideNode(struct)
{
	for(var i=0; i<struct.length; i++)
	{
		eval("treenode" + this.instance + "_" + struct[i]["nodenum"] + ".style.display = 'none'");
		if (struct[i]['child'] != null) 
		{
			this.HideNode(struct[i]['child']);
		}
	}
}

function tree_ShowNode(struct, withoutchildren)
{
	for(var i=0; i<struct.length; i++)
	{
		eval("treenode" + this.instance + "_" + struct[i]["nodenum"] + ".style.display = 'block'");
		if (!withoutchildren && struct[i]['child'] != null && struct[i]['opened'])
		{
			this.ShowNode(struct[i]['child'], false);
		}
	}
}

function tree_OpenParent(nodenum)
{
	var struct = this.GetNode(nodenum);
	document.images['treeimg' + this.instance + "_" + struct["nodenum"]].src = this.img_minus.src;
	if (this.usecookie) setCookie("v6tree" + this.instance + struct["nodenum"], "open");
	struct['opened'] = true;
	if (struct['parent'] != null)
	{
		this.OpenParent(struct['parent']);
	}
	if (struct['child'] != null)
	{
		this.ShowNode(struct['child'], true);
	}
}

function tree_OpenNode(nodenum)
{
	var struct = this.GetNode(nodenum);
	if (struct['parent'] != null)
	{
		this.OpenParent(struct['parent']);
	}
}

function tree_ShowHideNode(nodenum)
{
	var struct = this.GetNode(nodenum);
	if (struct['opened'])
	{
		document.images['treeimg' + this.instance + "_" + struct["nodenum"]].src = this.img_plus.src;
		this.HideNode(struct["child"]);
		if (this.usecookie) deleteCookie("v6tree" + this.instance + struct["nodenum"]);
		struct['opened'] = false;
	}
	else
	{
		document.images['treeimg' + this.instance + "_" + struct["nodenum"]].src = this.img_minus.src;
		this.ShowNode(struct["child"], false);
		if (this.usecookie) setCookie("v6tree" + this.instance + struct["nodenum"], "open");
		struct['opened'] = true;
	}
}

function tree_AddNode(text, parnum)
{
	if (parnum == null)
	{
		var rootlength = this.struct.length;
		this.struct[rootlength] = new Array(5);
		this.struct[rootlength]['parent'] = null;
		this.struct[rootlength]['text'] = text;
		this.struct[rootlength]['nodenum'] = this.curnode;
		this.struct[rootlength]['child'] = null;
		this.struct[rootlength]['opened'] = false;
	}
	else
	{
		var struct = this.GetNode(parnum);
		var tmparr = new Array(5);
		tmparr['parent'] = parnum;
		tmparr['text'] = text;
		tmparr['nodenum'] = this.curnode;
		tmparr['child'] = null;		
		tmparr['opened'] = false;
		
		if (struct['child'] == null)
		{
			struct['child'] = new Array();
		}
		curlength =  struct['child'].length;
		struct['child'][curlength] = tmparr;
	}
	return this.curnode++;
}

function Tree(img_minus, img_plus, img_sp, instance)
{
	//  
	this.img_minus = new Image(); //  
	this.img_minus.src = img_minus; 
	this.img_plus = new Image(); //  
	this.img_plus.src = img_plus; 
	this.img_sp = new Image(); //  
	this.img_sp.src = img_sp; 
	this.instance = instance; //   	
	// Private 
	this.struct = new Array();
	this.curnode = 0; //   
	this.level = 0; //       
	this.openflag = false; //       ,   
	this.curlevel = 0; //       ,   
	// Public 
	this.usecookie = false; //     cookies
	// Private 
	this.ShowNode = tree_ShowNode;
	this.HideNode = tree_HideNode;
	this.GetNode = tree_GetNode;		
	this.OpenParent = tree_OpenParent;
	// Public 
	this.AddNode = tree_AddNode;
	this.Show = tree_Show;
	this.ShowHideNode = tree_ShowHideNode;
	this.OpenNode = tree_OpenNode;
}