function GetTag(tagname)
{
	var range = this.editor.selection.createRange();
	var curtag;
	
	if (this.editor.selection.type == "Control" && range(0).tagName.toLowerCase()==tagname)
	{ 
		return range(0); 
	}
	else
	{
		range = (this.editor.selection.type == "Control") ? range(0) : range.parentElement();
		while ((range.tagName.toLowerCase() != tagname) && (range.tagName.toLowerCase() != 'body'))
		{
			range = range.parentElement;
		}
		if (range.tagName.toLowerCase() == tagname)
		{
			curtag = range;
		}
		else
		{
			return false;
		}
	}
	return curtag;
}

function MakeTableMatrix(ct)
{
	var tm = new Array();
	for (i=0; i<ct.rows.length; i++) tm[i]=new Array();
	for (i=0; i<ct.rows.length; i++)
	{
		jr=0;
		for (j=0; j<ct.rows(i).cells.length;j++)
		{
			while (tm[i][jr] != undefined) jr++;
			for (jh=jr; jh<jr+(ct.rows(i).cells(j).colSpan?ct.rows(i).cells(j).colSpan:1);jh++)
			{
				for (jv=i; jv<i+(ct.rows(i).cells(j).rowSpan?ct.rows(i).cells(j).rowSpan:1);jv++)
				{
					if (jv==i)
					{
						tm[jv][jh]=ct.rows(i).cells(j).cellIndex;
					}
					else
					{
						tm[jv][jh]=-1;
					}
				}
			}
		}
	}
	return tm;
}

function SetTag(tagname)
{
	document.frames[this.name + "frame"].focus();
	var range = this.editor.selection.createRange();
	range.collapse();
	range.execCommand("formatBlock", false, "<" + tagname + ">");
	document.frames[this.name + "frame"].focus();
}

function SetCommand(command)
{
	document.frames[this.name + "frame"].focus();
	var range = this.editor.selection.createRange();
	range.execCommand(command);
	document.frames[this.name + "frame"].focus();
}

function Insert(txt)
{
	document.frames[this.name + "frame"].focus();
	var range = this.editor.selection.createRange();
	range.collapse();
	range.pasteHTML(txt);
	document.frames[this.name + "frame"].focus();
}

function SetImageProps(img, props)
{
	if (props["align"]!="") img.align = props["align"];
	else img.removeAttribute("align");
	img.width = props["width"];
	img.height = props["height"];
	img.alt = props["alt"];
	if (props["title"]!="") img.title = props["title"];
	else img.removeAttribute("title");
	img.src = props["src"];
	img.border = props["border"];
	img.style.marginLeft = props["marginleft"];
	img.style.marginRight = props["marginright"];
	img.style.marginTop = props["margintop"];
	img.style.marginBottom = props["marginbottom"];
	img.removeAttribute("hspace");
	img.removeAttribute("vspace");
}

function InsertImage()
{
	if (this.editor.selection.type != "Control")
	{
		var res = showModalDialog("visualeditor/interface/image_lib/index.php", null, 'dialogHeight:525px; dialogWidth:425px; scroll:no; resizable:no; status:no');
		if(res != null)
		{
			this.Insert(res);
		}
	}
	else
	{
		alert("    ");
	}
}

function ImageProperties()
{
	var range = this.editor.selection.createRange();
	if ((this.editor.selection.type != "Control") || (range(0).tagName.toLowerCase() != "img"))
	{
		alert("    ");
		return;
	}
	var img = range(0);
	var img_prop = {};
	img_prop.alt = img.alt;
	img_prop.src = img.src;
	img_prop.width = (img.style.width) ? img.style.width : img.width;
	img_prop.height = (img.style.height) ? img.style.height : img.height;
	img_prop.align = img.align;
	if (img.hspace)
	{
		img_prop.marginleft = img.hspace;
		img_prop.marginright = img.hspace;
	}
	else
	{
		img_prop.marginleft = img.style.marginLeft;
		img_prop.marginright = img.style.marginRight;
	}
	if (img.vspace)
	{
		img_prop.margintop = img.vspace;
		img_prop.marginbottom = img.vspace;
	}
	else
	{
		img_prop.margintop = img.style.marginTop;
		img_prop.marginbottom = img.style.marginBottom;
	}
	var res = showModalDialog("visualeditor/interface/image_lib/properties.php?src=" + img.src, img_prop, 'dialogHeight:190px; dialogWidth:370px; scroll:no; resizable:no; status:no');
	if(res != null)
	{
		//this.editor.selection.clear();
		//this.Insert(res);
		SetImageProps(img, res);
	}
}

function Format(preffix, txt, suffix)
{
	document.frames[this.name + "frame"].focus();
	var range = this.editor.selection.createRange();
	if (range.text.length == 0)
	{
		range.pasteHTML(preffix + txt + suffix);
	}
	else
	{
		range.pasteHTML(preffix + range.text + suffix)
	}
	document.frames[this.name + "frame"].focus();
}

function SetClass(classname)
{
	if (this.editor.selection.type == "Control") return;
	document.frames[this.name + "frame"].focus();
	var range = this.editor.selection.createRange();
	cur_range = range.parentElement();

	while((cur_range.tagName.toLowerCase() != 'span') && (cur_range.tagName.toLowerCase() != 'body'))
	{
		cur_range = cur_range.parentElement;
	}
	
	if (cur_range.tagName.toLowerCase() == 'span')
	{
		if (classname != '')
		{
			cur_range.className = classname;
		}
		else
		{
			cur_range.removeNode();
		}
	}
	else
	{
		if (range.text == "") return;
		//var signatura = "S=i!G=n!A=t!U=r!A";
		//cur_range.innerHTML = cur_range.innerHTML.replace(/<!--([^\}^>]*)-->/, signatura + "$1" + signatura);
		this.Format('<span class="' + classname + '">', '', '</span>');
		//var reg = new RegExp(signatura + "([^\}^>]*)" + signatura);
		//cur_range.innerHTML = cur_range.innerHTML.replace(reg,  "<!--$1-->");
	}
}

function SwapMode(flag)
{
	if (this.designmode ^ !flag) return;
	this.designmode = !this.designmode;
	if (this.designmode)
	{
		document.all[this.name + 'frame'].style.display = "inline";
		document.all[this.name + 'textarea'].style.display = "none";
		this.editor.body.innerHTML = document.forms[this.formname].elements[this.name + 'textarea'].value;
		document.frames[this.name + "frame"].focus();
		document.images[this.name + "html"].src = this.buttons['html'].src;
		document.images[this.name + "design"].src = this.buttons_dis['design'].src;
		document.all[this.name + "tools"].style.visibility = "visible";
	}
	else
	{
		document.all[this.name + 'frame'].style.display = "none";
		document.all[this.name + 'textarea'].style.display = "inline";
		document.forms[this.formname].elements[this.name + 'textarea'].value = this.editor.body.innerHTML;
		document.forms[this.formname].elements[this.name + 'textarea'].focus();
		document.images[this.name + "html"].src = this.buttons_dis['html'].src;
		document.images[this.name + "design"].src = this.buttons['design'].src;
		document.all[this.name + "tools"].style.visibility = "hidden";
	}
}

function InsertLink()
{
	var lnk_prop = {};
	var range = this.editor.selection.createRange();
	var cur_range = this.GetTag('a');
	
	if (cur_range)
	{
		lnk_prop.href = cur_range.href;
		lnk_prop.title = cur_range.title;
		lnk_prop.target = cur_range.target;
		lnk_prop.content = cur_range.innerHTML;
	}
	else
	{
		lnk_prop.href = lnk_prop.title = lnk_prop.target = "";
		lnk_prop.content = (this.editor.selection.type == "Control") ? range(0).outerHTML : range.text;
	}
	
	var res = showModalDialog("visualeditor/interface/link.php", lnk_prop, 'dialogHeight:190px; dialogWidth:370px; scroll:no; resizable:no; status:no');
	
	if(res != null)
	{
		if (cur_range)
		{
			cur_range.outerHTML = "";
		}
		else
		{
			this.editor.selection.clear();
		}
		this.Insert(res);
	}
}

/*  ,   
function SetColor()
{
	var res = showModalDialog("visualeditor/interface/color.php", null, 'dialogHeight:160px; dialogWidth:240px; scroll:no; resizable:no; status:no');
	if (!res) return false;	
	document.frames[this.name + "frame"].focus();
	document.frames[this.name + "frame"].document.execCommand('forecolor', false, res);
}

function SetBackground()
{
	var res = showModalDialog("visualeditor/interface/color.php", null, 'dialogHeight:160px; dialogWidth:240px; scroll:no; resizable:no; status:no');
	if (!res) return false;	
	document.frames[this.name + "frame"].focus();
	document.frames[this.name + "frame"].document.execCommand('backcolor', false, res);	
}
*/

function AddTable()
{
	if (this.editor.selection.type == "Control")
	{
		alert("    ");
		return false;
	}
	var tabl_prop = {};
	tabl_prop.css = this.parsedcss['tables'];
	var res = showModalDialog("visualeditor/interface/table.php", tabl_prop, 'dialogHeight:325px; dialogWidth:340px; scroll:no; resizable:no; status:no');
	if (!res) return false;
	
	var newtable = document.createElement('TABLE');
	newtable.cellPadding = 0;
	newtable.cellSpacing = res['cellspacing'];
	newtable.className = res['style'];
	newtable.width = res['tablewidth'];
	
	for (i=0;i<res['rows'];i++)
	{
		var newrow = document.createElement('TR');
		for (j=0; j<res['cols']; j++)
		{
			newcell = document.createElement('TD');
			newrow.appendChild(newcell);
			if (Math.ceil(i/2) == i/2)
			{
				if (res['even']!="") newcell.className = res['even'];
			}
			else
			{
				if (res['uneven']!="") newcell.className = res['uneven'];
			}
			if (j==0 && res['firstcol']!="") newcell.className = res['firstcol'];
			if (i==0 && res['firstrow']!="") newcell.className = res['firstrow'];
			newcell.innerHTML = this.tableInnerHTML;
		}
		newtable.appendChild(newrow);
	}
	this.Insert(newtable.outerHTML);
	document.frames[this.name + "frame"].focus();
}

function EditTable()
{
	var curtable = this.GetTag("table");
	if (!curtable)
	{
		alert(" ");
		return false;
	}

	var tabl_prop = {};
	tabl_prop.css = this.parsedcss['tables'];
	tabl_prop.width = (curtable.style.width) ? curtable.style.width : curtable.width;
	tabl_prop.cellspacing = curtable.cellSpacing;
	tabl_prop.style = curtable.className;
	
	var res = showModalDialog("visualeditor/interface/table.php?edit=1", tabl_prop, 'dialogHeight:150px; dialogWidth:340px; scroll:no; resizable:no; status:no');
	if (!res) return false;
	
	curtable.cellSpacing = res['cellspacing'];
	curtable.className = res['style'];
	curtable.style.width = curtable.style.height = "";
	curtable.width = res['tablewidth'];
}

function SetCellStyles(curtable, curtr, curtd, res)
{
	if (curtd.tagName.toLowerCase() == "th")
	{
		var newtd = curtable.rows(curtr.rowIndex).insertCell(curtd.cellIndex);
		newtd.innerHTML = curtd.innerHTML;
		newtd.colSpan = curtd.colSpan;
		newtd.rowSpan = curtd.rowSpan;
		curtd.removeNode();
		curtd = newtd;
	}
	
	curtd.width = res['tdwidth'];
	curtd.align = res['align'];
	curtd.vAlign = res['valign'];
	curtd.noWrap = res['nowrap'];
	curtd.style.paddingLeft = res['paddingleft'];
	curtd.style.paddingRight = res['paddingright'];
	curtd.style.paddingTop = res['paddingtop'];
	curtd.style.paddingBottom = res['paddingbottom'];
	
	if (res['style'] == "")
	{
		curtd.removeAttribute("className");
	}
	else
	{
		curtd.className = res['style'];
	}
}

function EditCell()
{
	var curtable = this.GetTag("table");
	var curtd = this.GetTag("td") || this.GetTag("th");
	var curtr = this.GetTag("tr");

	if (!curtable || !curtd)
	{
		alert("  ");
		return false;
	}

	var td_prop = {};
	if (tablestyles = this.parsedcss['tables'][curtable.className])
	{
		td_prop.css = tablestyles['tdclasses'];
	}
	td_prop.tablestyle =  curtable.className;
	td_prop.style = curtd.className;
	td_prop.width = (curtd.style.width) ? curtd.style.width : curtd.width;
	td_prop.align = curtd.align;
	td_prop.valign = curtd.vAlign;	
	td_prop.nowrap = curtd.noWrap;
	td_prop.paddingleft = curtd.style.paddingLeft;
	td_prop.paddingright = curtd.style.paddingRight;
	td_prop.paddingtop = curtd.style.paddingTop;
	td_prop.paddingbottom = curtd.style.paddingBottom;

	var res = showModalDialog("visualeditor/interface/td.php", td_prop, 'dialogHeight:300px; dialogWidth:410px; scroll:no; resizable:no; status:no'); 
	if (!res) return false;	
	
	SetCellStyles(curtable, curtr, curtd, res);
	
	if (res['allrow'])
	{
		var cells = curtable.rows(curtr.rowIndex).cells;
		for(var i=0; i<cells.length; i++)
		{
			SetCellStyles(curtable, curtr, cells(i), res);
		}
	}
	
	if (res['allcol'])
	{
		for(var i=0; i<curtable.rows.length; i++)
		{	
			var cells = curtable.rows(i).cells;
			if (curtd.cellIndex < cells.length)
			{
				SetCellStyles(curtable, curtr, curtable.rows(i).cells(curtd.cellIndex), res);
			}
		}
	}
}

function InsertCol()
{
	var ct = this.GetTag("table");
	var cr = this.GetTag("tr");
	var cd = this.GetTag("td") || this.GetTag("th");

	if (cd && cr && ct)
	{
		var tm = this.MakeTableMatrix(ct);
		for (j=0; j<tm[cr.rowIndex].length; j++)
		{
			if (tm[cr.rowIndex][j] == cd.cellIndex)
			{
				realIndex=j;
				break;
			}
		}
		for (i=0; i<ct.rows.length; i++)
		{
			if (tm[i][realIndex] != -1)
			{
				if (ct.rows(i).cells(tm[i][realIndex]).colSpan > 1)
				{
					ct.rows(i).cells(tm[i][realIndex]).colSpan++;
				}
				else
				{
					var newc = ct.rows(i).insertCell(tm[i][realIndex]+1)
					var nc = ct.rows(i).cells(tm[i][realIndex]).cloneNode();
					newc.replaceNode(nc);
				}
			}
		}
	}
}

function InsertRow()
{
	var ct = this.GetTag("table"); 
	var cr = this.GetTag("tr"); 
	if (ct && cr)
	{
		var newr = ct.insertRow(cr.rowIndex+1);
		for (i=0; i<cr.cells.length; i++)
		{
			if (cr.cells(i).rowSpan > 1)
			{
				cr.cells(i).rowSpan++;
			}
			else
			{
				var newc = cr.cells(i).cloneNode();
				newr.appendChild(newc);
			}
		}
		for (i=0; i<cr.rowIndex; i++)
		{
			var tempr = ct.rows(i);
			for (j=0; j<tempr.cells.length; j++)
			{
				if (tempr.cells(j).rowSpan > (cr.rowIndex - i)) tempr.cells(j).rowSpan++;
			}
		}
	}
}

function DeleteRow()
{
	var ct = this.GetTag("table"); 
	var cr = this.GetTag("tr"); 
	var cd = this.GetTag("td") || this.GetTag("th");
	if (cd && cr && ct)
	{
		if (ct.rows.length<=1)
		{
			ct.removeNode(true);
		}
		else
		{
			var tm = this.MakeTableMatrix(ct);
			for (i=0; i<cr.rowIndex; i++)
			{
				var tempr = ct.rows(i);
				for (j=0; j<tempr.cells.length; j++)
				{
					if (tempr.cells(j).rowSpan > (cr.rowIndex - i)) tempr.cells(j).rowSpan--;
				}
			}
			curCI = -1;
			for (i=0; i<tm[cr.rowIndex].length; i++)
			{
				prevCI = curCI;
				curCI = tm[cr.rowIndex][i];
				if (curCI != -1 && curCI != prevCI && cr.cells(curCI).rowSpan>1 && (cr.rowIndex+1)<ct.rows.length)
				{
					ni = i;
					nrCI = tm[cr.rowIndex+1][ni];
					while (nrCI == -1)
					{
						ni++;
						if (ni<ct.rows(cr.rowIndex+1).cells.length)
							nrCI = tm[cr.rowIndex+1][ni];
						else
							nrCI = ct.rows(cr.rowIndex+1).cells.length;
					}
					var newc = ct.rows(cr.rowIndex+1).insertCell(nrCI);
					ct.rows(cr.rowIndex).cells(curCI).rowSpan--;
					var nc = ct.rows(cr.rowIndex).cells(curCI).cloneNode();
					newc.replaceNode(nc);
					cs = (cr.cells(curCI).colSpan>1)?cr.cells(curCI).colSpan:1;
					for (j=i; j<(i+cs);j++)
					{
						tm[cr.rowIndex+1][j] = nrCI;
						nj = j;
					}
					for (j=nj; j<tm[cr.rowIndex+1].length; j++)
					{
						if (tm[cr.rowIndex+1][j] != -1) tm[cr.rowIndex+1][j]++;
					}
				}
			}
			ct.deleteRow(cr.rowIndex);
		}
	}
}

function DeleteCol()
{
	var ct = this.GetTag("table"); 
	var cr = this.GetTag("tr"); 
	var cd = this.GetTag("td") || this.GetTag("th"); 
	if (cd && cr && ct)
	{
		var tm = this.MakeTableMatrix(ct);
		if (tm[0].length<=1)  
		{
			ct.removeNode(true);
		}
		else
		{
			for (j=0; j<tm[cr.rowIndex].length; j++)
			{
				if (tm[cr.rowIndex][j] == cd.cellIndex)
				{
					realIndex=j;
					break;
				}
			}
			for (i=0; i<ct.rows.length; i++)
			{
				if (tm[i][realIndex] != -1)
				{
					if (ct.rows(i).cells(tm[i][realIndex]).colSpan>1)
						ct.rows(i).cells(tm[i][realIndex]).colSpan--;
					else
						ct.rows(i).deleteCell(tm[i][realIndex]);
				}
			}
		}
	}
}


function ColSpan()
{
	var ct = this.GetTag("table");
	var cr = this.GetTag("tr"); 
	var cd = this.GetTag("td") || this.GetTag("th"); 
	if (cd && cr && ct)
	{
		var tm = this.MakeTableMatrix(ct);
		for (j=0; j<tm[cr.rowIndex].length; j++)
		{
			if (tm[cr.rowIndex][j] == cd.cellIndex)
			{
				realIndex=j;
				break;
			}
		}
		if (cd.cellIndex+1<cr.cells.length)
		{
			ccrs = cd.rowSpan?cd.rowSpan:1;
			cccs = cd.colSpan?cd.colSpan:1;
			ncrs = cr.cells(cd.cellIndex+1).rowSpan?cr.cells(cd.cellIndex+1).rowSpan:1;
			nccs = cr.cells(cd.cellIndex+1).colSpan?cr.cells(cd.cellIndex+1).colSpan:1;
			j=realIndex;
			while(tm[cr.rowIndex][j] == cd.cellIndex) j++;
			if (tm[cr.rowIndex][j] == cd.cellIndex+1)
			{
				if (ccrs == ncrs)
				{
					cd.colSpan = cccs+nccs;
					cd.innerHTML += cr.cells(cd.cellIndex+1).innerHTML;
					cr.deleteCell(cd.cellIndex+1);
				}
			}
		}
	}
}

function RowSpan()
{
	var ct = this.GetTag("table");
	var cr = this.GetTag("tr"); 
	var cd = this.GetTag("td") || this.GetTag("th"); 
	if (cd && cr && ct)
	{
		var tm = this.MakeTableMatrix(ct);
		for (j=0; j<tm[cr.rowIndex].length; j++)
		{
			if (tm[cr.rowIndex][j] == cd.cellIndex)
			{
				crealIndex=j;
				break;
			}
		}
		ccrs = cd.rowSpan?cd.rowSpan:1;
		cccs = cd.colSpan?cd.colSpan:1;
		if (cr.rowIndex+ccrs<ct.rows.length)
		{
			ncellIndex = tm[cr.rowIndex+ccrs][crealIndex];
			if (ncellIndex != -1 && (crealIndex==0 || (crealIndex>0 && (tm[cr.rowIndex+ccrs][crealIndex-1]!=tm[cr.rowIndex+ccrs][crealIndex]))))
			{
				ncrs = ct.rows(cr.rowIndex+ccrs).cells(ncellIndex).rowSpan?ct.rows(cr.rowIndex+ccrs).cells(ncellIndex).rowSpan:1;
				nccs = ct.rows(cr.rowIndex+ccrs).cells(ncellIndex).colSpan?ct.rows(cr.rowIndex+ccrs).cells(ncellIndex).colSpan:1;
				if (cccs == nccs)
				{
					cd.innerHTML += ct.rows(cr.rowIndex+ccrs).cells(ncellIndex).innerHTML;
					ct.rows(cr.rowIndex+ccrs).deleteCell(ncellIndex);
					cd.rowSpan = ccrs+ncrs;
				}
			}
		}
	}
}

function ColBreak()
{
	var ct = this.GetTag("table"); 
	var cr = this.GetTag("tr"); 
	var cd = this.GetTag("td") || this.GetTag("th");
	if (cd && cr && ct)
	{
		var tm = this.MakeTableMatrix(ct);
		for (j=0; j<tm[cr.rowIndex].length; j++)
		{
			if (tm[cr.rowIndex][j] == cd.cellIndex)
			{
				realIndex=j;
				break;
			}
		}
		if (cd.colSpan>1)
		{
			var newc = ct.rows(cr.rowIndex).insertCell(cd.cellIndex+1);
			cd.colSpan--;
			var nc = cd.cloneNode();
			newc.replaceNode(nc);
			cd.colSpan = 1;
		}
		else
		{
			var newc = ct.rows(cr.rowIndex).insertCell(cd.cellIndex+1);
			var nc = cd.cloneNode();
			newc.replaceNode(nc);
			for (i=0; i<tm.length; i++)
			{
				if (i!=cr.rowIndex && tm[i][realIndex] != -1)
				{
					cs = ct.rows(i).cells(tm[i][realIndex]).colSpan>1?ct.rows(i).cells(tm[i][realIndex]).colSpan:1;
					ct.rows(i).cells(tm[i][realIndex]).colSpan = cs+1;
				}
			}
		}
	}
}

function RowBreak()
{
	var ct = this.GetTag("table"); 
	var cr = this.GetTag("tr"); 
	var cd = this.GetTag("td") || this.GetTag("th"); 
	if (cd && cr && ct)
	{
		var tm = this.MakeTableMatrix(ct);
		for (j=0; j<tm[cr.rowIndex].length; j++)
		{
			if (tm[cr.rowIndex][j] == cd.cellIndex)
			{
				realIndex=j;
				break;
			}
		}
		if (cd.rowSpan>1) 
		{
			i = realIndex;
			while (tm[cr.rowIndex+1][i] == -1) i++;
			if (i == tm[cr.rowIndex+1].length) 
				ni = ct.rows(cr.rowIndex+1).cells.length;
			else
				ni = tm[cr.rowIndex+1][i];
			var newc = ct.rows(cr.rowIndex+1).insertCell(ni);
			cd.rowSpan--;
			var nc = cd.cloneNode();
			newc.replaceNode(nc);
			cd.rowSpan = 1;
		}
		else
		{
			ct.insertRow(cr.rowIndex+1);
			for (i=0; i<cr.cells.length; i++)
			{
				if (i != cd.cellIndex)
				{
					rs = cr.cells(i).rowSpan>1?cr.cells(i).rowSpan:1;
					cr.cells(i).rowSpan = rs+1;
				}
			}
			for (i=0; i<cr.rowIndex; i++)
			{
				var tempr = ct.rows(i);
				for (j=0; j<tempr.cells.length; j++)
				{
					if (tempr.cells(j).rowSpan > (cr.rowIndex - i)) tempr.cells(j).rowSpan++;
				}
			}
			var newc = ct.rows(cr.rowIndex+1).insertCell(0);
			var nc = cd.cloneNode();
			newc.replaceNode(nc);
		}
	}
}

function ClearCode()
{
	var tabl_prop = {};
	tabl_prop.css = this.parsedcss['tables'];
	
	if (!confirm("      .           ,          .  ?")) return;
	
	var res = (this.editor.all.tags('table').length > 0) ? showModalDialog("visualeditor/interface/table.php?edit=1&clearcode=1", tabl_prop, 'dialogHeight:150px; dialogWidth:340px; scroll:no; resizable:no; status:no') : true; 
	if (!res) return false;

	var found = true;
	while (found)
	{
		found = false;
		var all = this.editor.body.all;
		
		for(var i=0; i<all.length; i++)
		{
			if (all[i].tagUrn != null && all[i].tagUrn != '')
			{
				all[i].removeNode(false);
				found = true;
				continue;
			}
			var tag = all[i].tagName.toLowerCase(); 
			if (tag == "a" || tag == "b" || tag == "br" ||
				tag == "em" || tag == "h1" || tag == "h2" ||
				tag == "h3" || tag == "h4" || tag == "h5" ||
				tag == "h6" || tag == "hr" || tag == "i" ||
				tag == "img" || tag == "li" || tag == "ol" ||
				tag == "p" || tag == "span" || tag == "strong" ||
				tag == "table" || tag == "tr" || tag == "td" || 
				tag == "th" || tag == "u" || tag == "ul" 
				|| tag == "tbody" || tag == "colgroup"  || tag == "col")
			{
				switch(tag)
				{
					case "table":
						var curtableclass = false;
						for(var key in this.parsedcss['tables'])
						{
							if (key == all[i].className)
							{
								curtableclass = all[i].className;
							}
						}
						if (!curtableclass && all[i].className != "aplite_noborders")
						{
							all[i].clearAttributes();
							all[i].cellSpacing = res['cellspacing'];
							all[i].className = res['style'];
							all[i].width = res['tablewidth'];
						}
						break;

					case "td":
						var goodtd = false;
						if (curtableclass)
						{
							for(var key in this.parsedcss['tables'][curtableclass]['tdclasses'])
							{
								if (key == all[i].className) goodtd = true;
							}
						}
						if (!curtableclass || !goodtd) 
						{
							var curcolspan = all[i].colSpan;
							var currowspan = all[i].rowSpan;
							all[i].clearAttributes();
							all[i].colSpan = curcolspan;
							all[i].rowSpan = currowspan;
						}
						break;

					case "span":
						var curspan = false;
						for(var key in this.parsedcss['styles'])
						{
							if (key == all[i].className) 
							{
								curspan = all[i].className;
							}
						}
						if (curspan)
						{
							all[i].clearAttributes();
							all[i].className = curspan;
						}
						else
						{
							all[i].removeNode(false);
							found = true;
						}

					case "img":
						break;

					case "th":
						var curcolspan = all[i].colSpan;
						var currowspan = all[i].rowSpan;
						all[i].clearAttributes();
						all[i].colSpan = curcolspan;
						all[i].rowSpan = currowspan;
						break;

					case "p":
						var curpalign = all[i].align;
						all[i].clearAttributes();
						all[i].align = curpalign;
						break;

					case "a":
						var curhref = all[i].href;
						var curtarget = all[i].target;
						all[i].clearAttributes();
						all[i].href = curhref;
						if (curtarget != "") all[i].target = curtarget;
						break;

					default:
						all[i].clearAttributes();
						break;
				}
			}
			else
			{
				all[i].removeNode(false);
				found = true;
			}
		}
	}
}

function Indent()
{
	var curul = this.GetTag("ul") || this.GetTag("ol");
	if (!curul)
	{
		alert(" ");
		return false;
	}
	this.SetCommand('indent');
}

function UnIndent()
{
	var curul = this.GetTag("ul") || this.GetTag("ol");
	if (!curul)
	{
		alert(" ");
		return false;
	}
	this.SetCommand('outdent');
}

function Paste(txt)
{
	//alert(window.clipboardData.getData('URL'));
}

function Show()
{
	this.is_show = true;
	
	document.write('<div style="position:relative" id="' + this.name + 'tools">');
	
	document.write('<img src="' + this.imgpath + 'bold.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.SetCommand(\'Bold\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'italic.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.SetCommand(\'Italic\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'underline.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.SetCommand(\'Underline\')">');

	document.write('<span style="width:5px"></span>');

	document.write('<img src="' + this.imgpath + 'left.gif" width="22" height="20" alt="  " border="0" onclick="' + this.instancename + '.SetCommand(\'JustifyLeft\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'center.gif" width="22" height="20" alt="  " border="0" onclick="' + this.instancename + '.SetCommand(\'JustifyCenter\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'right.gif" width="22" height="20" alt="  " border="0" onclick="' + this.instancename + '.SetCommand(\'JustifyRight\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'justify.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.SetCommand(\'JustifyFull\')">');
	
	document.write('<span style="width:5px"></span>');
	
	document.write('<img src="' + this.imgpath + 'ul.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.SetCommand(\'insertunorderedlist\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'ol.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.SetCommand(\'insertorderedlist\')">');
	document.write('<span style="width:1px"></span>');	
	document.write('<img src="' + this.imgpath + 'indent.gif" width="22" height="20" alt="   " border="0" onclick="' + this.instancename + '.Indent()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'unindent.gif" width="22" height="20" alt="   " border="0" onclick="' + this.instancename + '.UnIndent()">');
	
	document.write('<span style="width:5px"></span>');
	
	document.write('<img src="' + this.imgpath + 'cut.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.SetCommand(\'cut\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'copy.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.SetCommand(\'copy\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'paste.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.SetCommand(\'paste\')">');

	document.write('<span style="width:5px"></span>');
	
	document.write('<img src="' + this.imgpath + 'undo.gif" width="22" height="20" alt="" border="0" onclick="document.execCommand(\'undo\')">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'redo.gif" width="22" height="20" alt="" border="0" onclick="document.execCommand(\'redo\')">');

	document.write('<span style="width:5px"></span>');
	
	document.write('<img src="' + this.imgpath + 'clear.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.ClearCode()">');
	
	document.write('<br>');

	document.write('<select onchange="if (this.selectedIndex>0) eval(this.options[this.selectedIndex].value); this.selectedIndex=0" style="margin-bottom:1px">');
	document.write('<option>  &raquo;&raquo;&raquo;</option>');
	document.write('<option value="' + this.instancename + '.SetTag(\'p\');">');
	for(var key in this.parsedcss['paragraphs'])
	{
		document.write('<option value="' + this.instancename + '.SetTag(\'' + key + '\')">' +  this.parsedcss['paragraphs'][key]);
	}
	document.write('</select>');

	document.write('<span style="width:5px"></span>');
	
	document.write('<select onchange="if (this.selectedIndex>0) eval(this.options[this.selectedIndex].value); this.selectedIndex=0" style="margin-bottom:1px">');
	document.write('<option>  &raquo;&raquo;&raquo;');
	document.write('<option value="' + this.instancename + '.SetClass(\'\')"> ');
	for(var key in this.parsedcss['styles'])
	{
		document.write('<option value="' + this.instancename + '.SetClass(\'' + key + '\')">' +  this.parsedcss['styles'][key]);
	}
	document.write('</select>');
	
	document.write('<br>');

	document.write('<img src="' + this.imgpath + 'images.gif" width="45" height="20" alt="" border="0" onclick="' + this.instancename + '.InsertImage()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'imagesprop.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.ImageProperties()">');
	
	document.write('<span style="width:5px"></span>');
	
	document.write('<img src="' + this.imgpath + 'link.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.InsertLink()">');

	document.write('<span style="width:5px"></span>');
	
	/*  ,   
	document.write('<img src="' + this.imgpath + 'color.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.SetColor()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'background.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.SetBackground()">');
	document.write('<span style="width:5px"></span>');
	*/

	document.write('<img src="' + this.imgpath + 'table.gif" width="22" height="20" alt="" border="0" onclick="' + this.instancename + '.AddTable()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_prop.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.EditTable()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_tdprop.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.EditCell()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_insrow.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.InsertRow()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_inscol.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.InsertCol()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_delrow.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.DeleteRow()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_delcol.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.DeleteCol()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_colspan.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.ColSpan()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_rowspan.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.RowSpan()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_colbreak.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.ColBreak()">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'table_rowbreak.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.RowBreak()">');

	document.write('<span style="width:5px"></span>');	

	document.write('<img src="' + this.imgpath + 'hr.gif" width="22" height="20" alt=" " border="0" onclick="' + this.instancename + '.SetCommand(\'inserthorizontalrule\')">');	
	
	document.write('</div>');

	document.write('<input type="hidden" value="' + this.text + '" name="' + this.name + '">');
	document.write('<iframe name="' + this.name + 'frame" id="' + this.name + 'frame" width="' + this.width + '" height="' + this.height + '">');
	document.write('</iframe>');
	document.write('<textarea style="display:none; width:' + this.width + '; height:' + this.height + '" name="' + this.name + 'textarea"></textarea>');
	this.editor = document.frames[this.name + "frame"].document;
	this.editor.designMode = "On";
	this.editor.open();
	this.editor.write("<style>" + document.styleSheets[this.cssid].cssText + "</style>");
	this.editor.write("<style>" + document.styleSheets[this.csslocalid].cssText + "</style>");
	this.editor.write(this.starttext);
	this.editor.close();
	
	document.write('<div>');
	document.write('<img src="' + this.imgpath + 'design_dis.gif" width="68" height="20" name="' + this.name + 'design" alt=" " border="0" onclick="' + this.instancename + '.SwapMode(true)">');
	document.write('<span style="width:1px"></span>');
	document.write('<img src="' + this.imgpath + 'html.gif" width="68" height="20" name="' + this.name + 'html" alt="   HTML" border="0" onclick="' + this.instancename + '.SwapMode(false)">');
	document.write('</div>');
	
	this.editor.body.onpaste = this.Paste;
}

function MoveDataToForm()
{
	document.forms[this.formname].elements[this.name].value = this.GetData();
	return (document.forms[this.formname].elements[this.name].value);
}

function GetData()
{
	if (!this.is_show)
	{
		alert("Error! Use 'Show' method of VisualEditor");
		return false;
	}
	return (this.designmode) ? this.editor.body.innerHTML : document.forms[this.formname].elements[this.name + 'textarea'].value;
}

function VisualEditor(formname, width, height, name, starttext, instancename, cssid, csslocalid, imgpath)
{
	// dates	
	this.cssid = cssid;
	this.csslocalid = csslocalid;
	this.instancename = instancename;
	this.formname = formname;
	this.width = width;
	this.height = height;
	this.name = name;
	this.starttext = starttext;
	this.imgpath = imgpath;
	this.is_show = false;
	this.designmode = true;
	this.parsedcss = Array();
	this.tableInnerHTML = "";//"&nbsp;";
	// methods
	this.GetTag = GetTag;
	this.MakeTableMatrix = MakeTableMatrix;
	this.Show = Show;
	this.SwapMode = SwapMode;
	this.MoveDataToForm = MoveDataToForm;
	this.SetTag = SetTag;
	this.SetClass = SetClass;
	this.SetCommand = SetCommand;
	this.Insert = Insert;
	this.Format = Format;
	this.InsertImage = InsertImage;
	this.ImageProperties = ImageProperties;
	this.InsertLink = InsertLink;
	/*  ,   
	this.SetColor = SetColor;
	this.SetBackground = SetBackground;
	*/
	this.AddTable = AddTable;
	this.EditTable = EditTable;
	this.EditCell = EditCell;
	this.InsertCol = InsertCol;
	this.InsertRow = InsertRow;
	this.DeleteCol = DeleteCol;
	this.DeleteRow = DeleteRow;
	this.ColSpan = ColSpan;
	this.RowSpan = RowSpan;
	this.ColBreak = ColBreak;
	this.RowBreak = RowBreak;
	this.GetData = GetData;
	this.ClearCode = ClearCode;
	this.SetCellStyles = SetCellStyles;
	this.Indent = Indent;
	this.UnIndent = UnIndent;
	this.Paste = Paste;
	
	// buttons
	var button_names = Array('design', 'html');
	this.buttons = Array();
	this.buttons_dis = Array();
	for(var i=0; i<button_names.length; i++)
	{
		this.buttons[button_names[i]] = new Image();
		this.buttons[button_names[i]].src = this.imgpath + button_names[i] + ".gif";
		this.buttons_dis[button_names[i]] = new Image();
		this.buttons_dis[button_names[i]].src = this.imgpath + button_names[i] + "_dis.gif";
	}
	
	var css = document.styleSheets[this.cssid].rules;
	this.parsedcss['paragraphs'] = new Array();
	this.parsedcss['styles'] = new Array();
	this.parsedcss['tables'] = new Array();
	var reg_table = new RegExp("^table.([^ ]+)$", "i");
	var reg_td = new RegExp("^table.([^ ]+)[ ]*td.([^ ]+)$", "i");

	for(i=0; i<css.length; i++)
	{
		if (css[i].style['name'])
		{
			if (css[i].selectorText.charAt(0) != '.' && css[i].selectorText.charAt(0) != '#' && css[i].selectorText.substring(0,6).toLowerCase() != "table.")
			{
				this.parsedcss['paragraphs'][css[i].selectorText] = css[i].style['name'];
			}
			else if (css[i].selectorText.charAt(0) == '.')
			{
				this.parsedcss['styles'][css[i].selectorText.substr(1, css[i].selectorText.length)] = css[i].style['name'];
			}
			else if (exp_selector = reg_table.exec(css[i].selectorText))
			{
				this.parsedcss['tables'][exp_selector[1]] = new Array();
				this.parsedcss['tables'][exp_selector[1]]['name'] = css[i].style['name'];
				this.parsedcss['tables'][exp_selector[1]]['tdclasses'] = new Array();
			}
			else if (exp_selector = reg_td.exec(css[i].selectorText))
			{
				this.parsedcss['tables'][exp_selector[1]]['tdclasses'][exp_selector[2]] = css[i].style['name'];
			}
		}
	}
}
