<?php
if(!defined('__ADMIN__'))
{
	define('__ADMIN__', true);

//	include_once(dirname(__FILE__).'/../../../../inc/classes/storage.php');
	
	class Admin extends Storage
	{
		public $connection = null;

		function __construct(&$connection, $id = null)
		{
			parent::__construct($connection, 'admins', 'Admin_Id');
			$this->SetId($id);
			$this->Init();
		}
		
		function Init()
		{
			$this->Get();
			$this->GetModsPermissions();
			$this->GetIesPermissions();
			$this->GetRestructsPermissions();
			$this->GetPublishPermissions();
		}
		
		function Login($login, $pass)
		{
			$ret = $this->GetRec($this->table, $this->index, "Login='".$this->connection->EscapeString($login)."' AND Pass='".$this->connection->EscapeString($pass)."'");
			if ($ret)
			{
				$this->SetId($ret);
				$this->Init();
			}
			return $ret;
		}
		
		function IsAdmin()
		{
			if ($this->id == null) return false;
			return $this->data['IsAdmin'];
		}
		
		function IsWebMaster()
		{
			if ($this->id == null) return false;
			return $this->data['IsWebmaster'];
		}
		
		function IsStaticsEditor()
		{
			if ($this->id == null) return false;
			if ($this->IsAdmin() || $this->IsWebMaster()) return true;
			return $this->data['IsStaticsEditor'];
		}
		
		function IsIePermission($id)
		{
			if ($this->id == null) return false;
			if ($this->IsAdmin() || $this->IsWebMaster()) return true;
			return in_array($id, $this->iespermissions);
		}
		
		function IsRestructPermission($id)
		{
			if ($this->id == null) return false;
			if ($this->IsAdmin() || $this->IsWebMaster()) return true;
			return in_array($id, $this->restructspermissions);
		}
		
		function IsPublishPermission($id)
		{
			if ($this->id == null) return false;
			if ($this->IsAdmin() || $this->IsWebMaster()) return true;
			return in_array($id, $this->publishpermissions);
		}
		
		function IsModPermission($id)
		{
			if ($this->id == null) return false;
			if ($this->IsAdmin() || $this->IsWebMaster()) return true;
			return in_array($id, $this->modspermissions);
		}

		function checkLogin($login)
		{
			$where = "Login='".$this->connection->EscapeString($login)."'";
			if ($this->id != null) $where .= ' AND '.$this->index.'<>'.$this->id;
			return $this->CountRecs($this->table, $where);
		}

		function Add($name, $login, $pass, $isadmin, $isstaticseditor, $iswebmaster=null)
		{
			if ($this->checkLogin($login))
			{
				$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>E_MSG_ADMIN_LOGINDOUBLE));
				return false;
			}
			$sql = 'INSERT INTO '.$this->table.'
					(Name, Login, Pass, IsAdmin, IsStaticsEditor'.($iswebmaster!==null?', IsWebmaster':'').")
					VALUES
					('".$this->connection->EscapeString($name)
					."','".$this->connection->EscapeString($login)
					."','".$this->connection->EscapeString($pass)
					."',".(int)$isadmin
					.",".(int)$isstaticseditor
					.($iswebmaster!==null?', '.(int)$iswebmaster:'').')';
			if ($this->connection->exec($sql))
			{
				$this->SetId($this->connection->getInsertedId());
				$this->Get();
				return $this->id;
			}
			else return false;
		}
		
		function Update($name, $login, $pass, $isadmin=null, $isstaticseditor=null, $iswebmaster=null)
		{
			if ($this->id == null) return false;
			if ($this->checkLogin($login))
			{
				$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>E_MSG_ADMIN_LOGINDOUBLE));
				return false;
			}
			if ($isadmin===0)
			{
				if ($this->CountRecs($this->table, $this->index.'='.$this->id.' AND IsAdmin=1') == $this->CountRecs($this->table, 'IsAdmin=1'))
				{
					$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>E_MSG_ADMIN_LASTPERM));
					return false;
				}
			}
			if ($iswebmaster===0)
			{
				if ($this->CountRecs($this->table, $this->index.'='.$this->id.' AND IsWebmaster=1') == $this->CountRecs($this->table, 'IsWebmaster=1'))
				{
					$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>E_MSG_ADMIN_LASTPERM));
					return false;
				}
			}
			$sql = 'UPDATE '.$this->table.' SET '
					.($name!=null?"Name='".$this->connection->EscapeString($name)."',":'')
					."Login='".$this->connection->EscapeString($login)."'"
					.($pass!=''?",Pass='".$this->connection->EscapeString($pass)."'":'')
					.($isadmin!==null?',IsAdmin='.(int)$isadmin:'')
					.($isstaticseditor!==null?',IsStaticsEditor='.(int)$isstaticseditor:'')
					.($iswebmaster!==null?',IsWebmaster='.(int)$iswebmaster:'')
					.' WHERE '.$this->index.'='.$this->id;
			if ($this->connection->exec($sql))
			{
				$this->Get();
				return true;
			}
			else return false;
		}
		
		function Get()
		{
			if ($this->id == null) return false;
			if (!isset($this->data)) $this->data = $this->GetRec($this->table, '*', $this->index.'='.$this->id);
			return $this->data;
		}
		
		function GetName()
		{
			if ($this->id == null) return false;
			return $this->data['Name'];
		}
		
		function GetPublishPermissions()
		{
			if ($this->id == null) return false;
			if (!isset($this->publishpermissions)) $this->publishpermissions = $this->GetPairs('publish_permissions', null, 'Rub_Id', '1', $this->index.'='.$this->id);
			return $this->publishpermissions;
		}
		
		function GetIesPermissions()
		{
			if ($this->id == null) return false;
			if (!isset($this->iespermissions)) $this->iespermissions = $this->GetPairs('ie_permissions', null, 'Ie_Id', '1', $this->index.'='.$this->id);
			return $this->iespermissions;
		}

		function GetModsPermissions()
		{
			if ($this->id == null) return false;
			if (!isset($this->modspermissions)) $this->modspermissions = $this->GetPairs('mod_permissions', null, 'Mod_Id', '1', $this->index.'='.$this->id);
			return $this->modspermissions;
		}
		
		function GetRestructsPermissions()
		{
			if ($this->id == null) return false;
			if (!isset($this->restructspermissions)) $this->restructspermissions = $this->GetPairs('restruct_permissions', null, 'Group_Id', '1', $this->index.'='.$this->id);
			return $this->restructspermissions;
		}

		function SetPermissions($ies, $restructs, $mods)
		{
			if ($this->id == null) return false;
			$sql = 'DELETE FROM ie_permissions WHERE '.$this->index.'='.$this->id;
			$this->connection->exec($sql);
			foreach($ies as $value)
			{
				$sql = 'INSERT INTO ie_permissions SET '.$this->index.'='.$this->id.', Ie_Id='.(int)$value;
				$this->connection->exec($sql);
			}
			$sql = 'DELETE FROM restruct_permissions WHERE '.$this->index.'='.$this->id;
			$this->connection->exec($sql);
			foreach($restructs as $value)
			{
				$sql = 'INSERT INTO restruct_permissions SET '.$this->index.'='.$this->id.', Group_Id='.(int)$value;
				$this->connection->exec($sql);
				$ie_id = $this->GetRec('ies', 'Ie_Id', 'Group_Id='.(int)$value);
				$sql = 'INSERT INTO ie_permissions SET '.$this->index.'='.$this->id.', Ie_Id='.$ie_id;
				$this->connection->exec($sql);
			}
			$sql = 'DELETE FROM mod_permissions WHERE '.$this->index.'='.$this->id;
			$this->connection->exec($sql);
			foreach($mods as $value)
			{
				$sql = 'INSERT INTO mod_permissions SET '.$this->index.'='.$this->id.', Mod_Id='.(int)$value;
				$this->connection->exec($sql);
			}
		}

		function SetPublishPermissions($rubricator_id, $publishrubs)
		{
			if ($this->id == null) return false;
			$cur_rubricator_rubs = $this->GetPairs('rubs', null, 'Rub_Id', '1', 'Group_Id='.(int)$rubricator_id);
			if (count($cur_rubricator_rubs) == 0) return false;
			$sql = 'DELETE FROM publish_permissions WHERE '.$this->index.'='.$this->id.' AND Rub_Id IN('.implode(',',$cur_rubricator_rubs).')';
			$this->connection->exec($sql);
			foreach($publishrubs as $value)
			{
				$sql = 'INSERT INTO publish_permissions SET '.$this->index.'='.$this->id.', Rub_Id='.(int)$value;
				$this->connection->exec($sql);
			}
			return true;
		}
		
		function AddPublishPermission($publishrub)
		{
			if ($this->id == null) return false;
			$sql = 'INSERT INTO publish_permissions SET '.$this->index.'='.$this->id.', Rub_Id='.$publishrub;
			if (!$this->connection->exec($sql))
			{
				return false;
			}
			$this->publishpermissions[] = $publishrub;
			return true;
		}
	}
}
?>