<?php
if(!defined('__FIELD__'))
{
	define('__FIELD__', true);

//	include_once(dirname(__FILE__).'/../../../../inc/classes/storage.php');

	class Field extends Storage
	{
		public $properties;

		function __construct(&$connection, $id = null)
		{
			parent::__construct($connection, 'ie_fields', 'Field_Id');
			$this->SetId($id);
			if ($this->GetId()) $this->properties = $this->GetField();
			else $this->properties = false;
		}
		
		function GetFieldIdentifier()
		{
			if ($this->id == null) return false;
			return $this->properties['Identifier'];
		}

		function GetFieldKind()
		{
			if ($this->id == null) return false;
			return $this->properties['Kind'];
		}

		function GetIeId()
		{
			if ($this->id == null) return false;
			return $this->properties['Ie_Id'];
		}

		function GetSelect()
		{
			if ($this->id == null)	return false;
			return $this->GetPairs('ie_selects', 'Identifier', 'Title', 'Select_Id', $this->index.'='.$this->id);
		}

		function CountSelect()
		{
			if ($this->id == null) return false;
			return $this->CountRecs('ie_selects', $this->index.'='.$this->id);
		}

		function IsPreview()
		{
			if ($this->id == null) return false;
			return (bool)$this->properties['ShowPreview'];
		}

		function GetField()
		{
			if ($this->id == null) return false;
			return $this->GetRec($this->table, '*', $this->index.'='.$this->id);
		}
		
		function SearchAttached($ss)
		{
			if ($this->GetFieldKind() != 'ie') return false;
			$attached_ie_field_identifier = $this->GetRec($this->table, 'Identifier', 'Ie_Id='.$this->properties['Properties_I'].' AND ShowPreview=1 ORDER By Ord');
 			return $this->GetPairs('ie'.$this->properties['Properties_I'], 'Id', $attached_ie_field_identifier, 1, "$attached_ie_field_identifier RLIKE '$ss'");
		}

		function CreateRestriction($kind, $id_field, $value)
		{
			if ($this->id == null) return false;
			switch($kind)
			{
				case 'only_in_subrub':
					$properties_i = 0;
					$properties = $value;
				break;
				default:
					$properties_i = $value;
					$properties = '';
				break;
			}
			$sql = 'INSERT INTO ierub_fieldrestrictions(Field_Id, Kind, Properties_I, Properties) VALUES('.$this->id.', \''.$kind.'\', '.(int)$properties_i.', \''.$properties.'\')';
			if (!$this->connection->exec($sql)) return false;
		}

		function DeleteRestriction($id_restriction)
		{
			if ($this->id == null) return false;
			$sql = "DELETE FROM ierub_fieldrestrictions WHERE Field_Id=".$this->id." AND Restriction_Id=".$id_restriction;
			return $this->connection->exec($sql);
		}
	}
}
?>