<?php
if(!defined('__FORM__'))
{
	define('__FORM__', true);

//	include_once(dirname(__FILE__).'/../../../../inc/classes/storage.php');

	class Form extends Storage
	{
		function __construct(&$connection, $id = null)
		{
			parent::__construct($connection, 'forms', 'Form_Id');
			$this->SetId($id);
			if ($this->id != null)
			{
				$data = $this->GetRec($this->table, '*', $this->index.'='.$this->id);
				$this->identifier = $data['Identifier'];
				$this->ie_id = $data['Ie_Id'];
				$this->title = $data['Title'];
				$this->body = $data['Body'];
			}
		}

		function Delete()
		{
			if ($this->id == null) return false;
			$sql = "DELETE FROM ".$this->table." WHERE ".$this->index."=".$this->id;
			$this->connection->exec($sql);
			$this->id = null;
			$this->identifier =	$this->ie_id = $this->title = $this->body = "";
			return true;
		}
		
		function Create($ie_id, $identifier, $title, $body)
		{
			if ($this->CountRecs($this->table, "Identifier='$identifier'") > 0) return false;
			$sql = "INSERT INTO ".$this->table." SET Ie_Id=$ie_id, Identifier='$identifier', Title='$title', Body='$body'";
			$this->identifier = $identifier;
			$this->ie_id = $ie_id;
			$this->title = $title;
			$this->body = $body;
			return $this->connection->exec($sql);
		}
		
		function Update($title, $body)
		{
			if ($this->id == null) return false;
			$sql = "UPDATE ".$this->table." SET Title='$title', Body='$body' WHERE ".$this->index."=".$this->id;
			$this->title = $title;
			$this->body = $body;
			return $this->connection->exec($sql);
		}
		
		/**
		      
		     
		"good" =>   
		"bad" =>        IE
		"reserve" =>    
		*/
		function AnalyseFields()
		{
			$failed_names = array('MAX_FILE_SIZE');
			$ret = array
			(
				'good' => array(),
				'bad' => array(),
				'reserve' => array()
			);
			preg_match_all("/<input [^>]*name=\"?([^\"> ]+)\"?[^>]*>/i", $this->body, $form_inputs);
			preg_match_all("/<textarea [^>]*name=\"?([^\"> ]*)\"?[^>]*>/i", $this->body, $form_textareas);
			preg_match_all("/<select [^>]*name=\"?([^\"> ]*)\"?[^>]*>/i", $this->body, $form_selects);
			$element_names = array_unique(array_merge($form_inputs[1], $form_textareas[1], $form_selects[1]));
			$ie = new IE($this->connection, $this->ie_id);
			$identifiers = $ie->GetFieldsIdentifiers();
			
			foreach($identifiers as $name)
			{
				if (in_array($name, $element_names))
				{
					$ret['good'][] = new Field($this->connection, $ie->GetFieldId($name));
				}
				else
				{
					$ret['reserve'][] = new Field($this->connection, $ie->GetFieldId($name));
				}
			}
			foreach($element_names as $name)
			{
				if (in_array($name, $failed_names)) continue;
				if (!in_array($name, $identifiers))
				{
					$ret['bad'][] = $name;
				}
			}
			
			return $ret;
		}
		
		function Show($action, $js_validation = true)
		{
			if ($this->id == null) return false;
			$check_result = $this->AnalyseFields();
			$additional = $formattribs = '';
			$has_js = false;
			foreach ($check_result['good'] as $value)
			{
				switch($value->GetFieldKind())
				{
					case 'file':
						$formattribs .= ' enctype="multipart/form-data"';
					break;
					case 'regexp':
						if ($js_validation)
						{
							$field_data = $value->GetField();
							$additional .= ' r = new RegExp(/'.$field_data['Properties'].'/);';
							$additional .= ' if (!r.test(document.forms["'.$this->identifier.'"].elements["'.$field_data['Identifier'].'"].value)) { alert("  : '.$field_data['Title'].'");';
							$additional .= ' document.forms["'.$this->identifier.'"].elements["'.$field_data['Identifier'].'"].focus(); return false; }';
							$has_js = true;
						}
					break;
				}
			}
			if ($has_js)
			{
				$additional = '<script type="text/javascript"> function ValidateForm() {'.$additional.' return true; }</script>';
				$formattribs .= ' onSubmit="return ValidateForm()"';
			}
			$show_view = preg_replace('/<form([^>]*)>/i', '<form'.$formattribs.' action="'.$action.'"\\1><input type="hidden" value="'.$this->ie_id.'" name="ie_id">', $this->body);
			$show_view = $show_view.$additional;
			return $show_view;
		}
		
		/**
		     .
		 */
		function Parse($data_id, $fields, $data)
		{
			$return = preg_replace('/<input [^>]*type="?hidden"?[^>]*>/i', '', $this->body);
			foreach ($fields as $field_id => $value)
			{
				if (isset($data[$value['Identifier']]))	switch ($value['Kind'])
				{
					case 'text':
					case "regexp":
						$return = preg_replace('/<input [^>]*name="?'.$value['Identifier'].'"?[^>]*>/i', parseHtml($data[$value['Identifier']]), $return);
					break;
					case "file":
						if ($data[$value['Identifier']]=='')
						{
							$return = preg_replace('/<input [^>]*name="?'.$value['Identifier'].'"?[^>]*>/i', '', $return);
						}
						else
						{
							$return = preg_replace('/<input [^>]*name="?'.$value['Identifier'].'"?[^>]*>/i', '<a href="http://'.$_SERVER['SERVER_NAME'].($_SERVER['SERVER_PORT']!=80?':'.$_SERVER['SERVER_PORT']:'').FILE_UPLOAD_DIR_FRONT.$this->ie_id.'_'.$data_id.'_'.$value['Identifier'].'_'.parseHtml($data[$value['Identifier']]).'">'.parseHtml($data[$value['Identifier']]).'</a>', $return);
						}
					break;
					case 'textarea':
						$return = preg_replace('/<textarea [^>]*name="?'.$value['Identifier'].'"?[^>]*><\/textarea>/i', parseHtml($data[$value['Identifier']]), $return);
					break;
					case "select":
						$field = new Field($this->connection, $field_id);
						$select = $field->GetSelect();
						if (isset($select[$data[$value['Identifier']]])) switch($value['Properties'])
						{
							case 'select':
								$return = preg_replace('/<select [^>]*name="?'.$value['Identifier'].'"?[^>]*>.*<\/select>/iU', $select[$data[$value['Identifier']]], $return);
							break;
							case 'radio':
								foreach ($select as $key => $val)
								{
									$search = array('/<INPUT [^>]*value="?'.$key.'"?[^>]*name="?'.$value['Identifier'].'"?[^>]*>/i', '/<INPUT [^>]*name="?'.$value['Identifier'].'"?[^>]*value="?'.$key.'"?[^>]*>/i');
									if ($data[$value['Identifier']] == $key)	$return = preg_replace($search, '', $return);
									else										$return = preg_replace($search, '', $return);
								}
							break;
						}
					break;
					case "checkbox":
						$r = $value['Identifier']==0 ? '' : '';
						$return = preg_replace('/<input [^>]*name="?'.$value['Identifier'].'"?[^>]*>/i', $r, $return);
					break;
				}
			}
			$return = preg_replace(array('/<input [^>]*class="?button"?[^>]*>/i'), '&nbsp;', $return);
			$return = preg_replace(array('/<td([^>]*)><\/td>/i', '/<form[^>]*>/i', '/<\/form>/i'), array('<td\\1>&nbsp;</td>', ''), $return);
			return $return;
		}
	}
}
?>