<?php
if(!defined('__IE__'))
{
	define('__IE__', true);

	/* TODO:    */
	define('FILE_UPLOAD_DIR_FRONT', '/files/ie/');
	define('FILE_UPLOAD_DIR', realpath(dirname(__FILE__).'/../../../..'.FILE_UPLOAD_DIR_FRONT).'/');
	define('MULTIFILE_UPLOAD_DIR_FRONT', '/files/ie_files/');
	define('MULTIFILE_UPLOAD_DIR', realpath(dirname(__FILE__).'/../../../..'.MULTIFILE_UPLOAD_DIR_FRONT).'/');

	class IE extends Storage
	{

		const FILTER_LIKE		= 1;
		const FILTER_NOTLIKE	= 2;
		const FILTER_EQUAL		= 3;
		const FILTER_NOTEMPTY	= 4;
		const FILTER_EMPTY		= 5;
		const FILTER_LESSTHEN	= 6;
		const FILTER_MORETHEN	= 7;
		const FILTER_NOTPUBL	= 8;
		const FILTER_PUBLISHED	= 9;
		
		const FIELD_PROP_PUBDATE	= 1;
		const FIELD_PROP_ANNOUNCE	= 1;
		const FIELD_PROP_MULTI		= 1;
		
		const FIELDLIST_PREVIEW	= true;
		const FIELDLIST_FULL	= false;
		
		const FLAG_PUBLISH_DISABLE	= 1;
		
		public $identifier = null;
		public $group_id = null;
		public $title = null;
		protected $fields = null;
		protected $data = array();
		protected $templates = array();

		function __construct(&$connection, $id = null)
		{
			parent::__construct($connection, 'ies', 'Ie_Id');
			if ($id != null && ($data = $this->GetRec($this->table, '*', (is_numeric($id)?$this->index.'='.$id:"Identifier='".$this->connection->EscapeString($id)."'"))))
			{
				$this->id = $data[$this->index];
				foreach ($data as $key => $value)
				{
					$key = strtolower($key);
					$this->$key = $value;
				}
			}
		}

		function isSetFlag($flag)
		{
			return ($this->flags & $flag) == $flag;
		}

		function GetFields()
		{
			if ($this->id == null) return false;
			if ($this->fields == null) $this->fields = $this->GetAllRecs("ie_fields", "*", "Field_Id", "Ord", "Ie_Id=".$this->id);
			return $this->fields;
		}

		function CountFields($preview_only = self::FIELDLIST_FULL)
		{
			if ($this->id == null) return false;
			if ($this->fields == null) $this->GetFields();
			$count = 0;
			if ($preview_only == self::FIELDLIST_FULL) return sizeof($this->fields);
			else if (sizeof($this->fields)) foreach ($this->fields as $key => $value)
			{
				if ($value['ShowPreview']) $count++;
			}
			return $count;
		}

		function GetField($id)
		{
			if ($this->id == null) return false;
			if ($this->fields == null) $this->GetFields();
			if (is_numeric($id) && isset($this->fields[$id])) return $this->fields[$id];
			else if (sizeof($this->fields)) foreach ($this->fields as $key => $value)
			{
				if ($value['Identifier'] == $id) return $value;
			}
			return false;
		}

		/**
		 *    Field  ID  Identifier.
		 */
		function GetFieldObj($id)
		{
			if ($field = $this->GetField($id))
			{
				$objField = new Field($this->connection, $field['Field_Id']);
				if ($objField->GetId())	return $objField;
				else					return false;
			}
			else return false;
		}

		function GetPreviewFields()
		{
			if ($this->id == null) return false;
			if ($this->fields == null) $this->GetFields();
			$ret = array();
			if (sizeof($this->fields)) foreach ($this->fields as $key => $value)
			{
				if ($value['ShowPreview']) $ret[$key] = $value;
			}
			return $ret;
		}

		function GetFieldId($identifier)
		{
			if ($this->id == null) return false;
			if ($this->fields == null) $this->GetFields();
			if (sizeof($this->fields)) foreach ($this->fields as $key => $value)
			{
				if ($value['Identifier'] == $identifier) return $key;
			}
			return false;
		}

		function GetFieldsIdentifiers($preview = self::FIELDLIST_FULL)
		{
			if ($this->id == null) return false;
			if ($this->fields == null) $this->GetFields();
			$ret = array();
			if (sizeof($this->fields)) foreach ($this->fields as $key => $value)
			{
				if ($preview == self::FIELDLIST_FULL || $preview == self::FIELDLIST_PREVIEW && $value['ShowPreview']) $ret[] = $value['Identifier'];
			}
			return $ret;
		}

		function GetFieldsIdentifiersByKind($kind)
		{
			if ($this->id == null) return false;
			if ($this->fields == null) $this->GetFields();
			$ret = array();
			if (sizeof($this->fields)) foreach ($this->fields as $key => $value)
			{
				if ($value['Kind'] == $kind) $ret[] = $value['Identifier'];
			}
			return $ret;
		}

		function GetCountData()
		{
			if ($this->id == null) return false;
			return $this->CountRecs("ie".$this->id);
		}

		function CheckIECopy($id)
		{
			if ($this->id == null) return false;
			return $this->CountRecs('ie'.$this->id, 'Id='.$id);
		}

		function PrepareGetData($sort_mode, $sort_field, $preview)
		{
			$identifiers = $this->GetFieldsIdentifiers($preview);
			$identCount = count($identifiers);
			if (is_numeric($sort_field))
			{
				$sort_field = abs($sort_field);
                if ($sort_field > $identCount) $sort_field = $identCount;
			}
			else
            {
            	//  ..       
            	//if (!in_array($sort_field, $identifiers)) $sort_field=0;
            }
			return Array($sort_mode, $sort_field, $identifiers, $identCount);
		}

		function GetAllData($page = 0, $page_item_count = DB::LIMIT_CLAUSE_LAST, $sort_mode = 0, $sort_field = 0, $preview = self::FIELDLIST_PREVIEW)
		{
			if ($this->id == null) return false;
			list($sort_mode, $sort_field, $identifiers, $identCount) = $this->PrepareGetData($sort_mode, $sort_field, $preview);
			if ($identCount == 0) return Array();
			return $this->GetAllRecs(
					'ie'.$this->id,
					'Modified,'.implode(',', $identifiers).',Admin_Creator_Id,Admin_Lastmodif_Id',
					'SQL_CALC_FOUND_ROWS Id',
					(is_numeric($sort_field) ? ($sort_field+2) : $sort_field).' '.(($sort_mode < 2)?'DESC':'ASC'),
					DB::WHERE_CLAUSE_NEUTRAL,
					($page*$page_item_count).','.$page_item_count
					);
		}

		function GetAllDataWithFieldlist($identifiers, $order = '1')
		{
			if ($this->id == null) return false;
			if (is_array($identifiers))
			{
				$fieldlist = implode(', ', $identifiers);
			}
			return $this->GetAllRecs(
					'ie'.$this->id,
					$identifiers,
					'Id',
					$order
					);
		}

		function GetAllDataByRub($rub_id, $page, $page_item_count, $sort_mode = 0, $sort_field = 0, $preview = self::FIELDLIST_PREVIEW)
		{
			if ($this->id == null) return false;
			list($sort_mode, $sort_field, $identifiers, $identCount) = $this->PrepareGetData($sort_mode, $sort_field, $preview);
			if ($identCount == 0) return Array();
			return $this->GetAllRecs(
					'ie'.$this->id.' I, rub_ie RI',
					'I.Modified,I.'.implode(',I.', $identifiers).',I.Admin_Creator_Id,I.Admin_Lastmodif_Id',
					'SQL_CALC_FOUND_ROWS I.Id',
					(is_numeric($sort_field) ? ($sort_field+2) : $sort_field).' '.(($sort_mode < 2)?'DESC':'ASC'),
					'I.Id=RI.Ie AND RI.Rub='.$rub_id.' AND RI.Ie_Table='.$this->id,
					($page*$page_item_count).','.$page_item_count
					);
		}

		/*
			          
		*/
		function GetAllDataExcludeRub($rub_id, $page, $page_item_count, $sort_mode = 0, $sort_field = 0, $preview = self::FIELDLIST_PREVIEW)
		{
			if ($this->id == null) return false;
			list($sort_mode, $sort_field, $identifiers, $identCount) = $this->PrepareGetData($sort_mode, $sort_field, $preview);
			if ($identCount == 0) return Array();
			return $this->GetAllRecs(
					'ie'.$this->id." I LEFT JOIN rub_ie R ON I.Id=R.Ie AND Ie_Table=".$this->id,
					'Modified,'
						.implode(',', $identifiers).',Admin_Creator_Id,Admin_Lastmodif_Id',
					'SQL_CALC_FOUND_ROWS Id',
					(is_numeric($sort_field) ? ($sort_field+2) : $sort_field).' '.(($sort_mode < 2)?'DESC':'ASC'),
					"R.Rub IS NULL",
					($page*$page_item_count).','.$page_item_count
					);
		}

		function GetFilteredData($filter, $previewonly = self::FIELDLIST_PREVIEW, $page = 0, $page_item_count = DB::LIMIT_CLAUSE_LAST, $sort_mode = 0, $sort_field = 0)
		{
			if ($this->id == null || !is_array($filter)) return false;
			$outputidifs = $this->GetFieldsIdentifiers($previewonly);
			list($sort_mode, $sort_field, $identifiers, $identCount) = $this->PrepareGetData($sort_mode, $sort_field, self::FIELDLIST_FULL);
			$search_sql = DB::WHERE_CLAUSE_NEUTRAL;
			$add_fields = array('modified', 'creator', 'lastmodif');
			foreach($filter as $field => $opts)
			{
				if (!in_array($field, $identifiers) && !in_array($field, $add_fields)) continue;
				switch ($opts["kind"])
				{
					case "date":
						if (!isset($opts["use"]) || (!isset($opts["date"]["from"]) && !isset($opts["date"]["to"]))) continue;
						$search_sql .= (isset($opts["date"]["from"])?" AND '".$this->connection->EscapeString($opts["date"]["from"])."' <= ".$field:'')
									. (isset($opts["date"]["to"])?" AND ".$field." <= '".$this->connection->EscapeString($opts["date"]["to"])."' ":'');
					break;
					
					case "text":
						$opts["text"] = trim($opts["text"]);
						if ($opts["option"] == self::FILTER_NOTEMPTY)
						{
							$search_sql .= " AND " . $field . "<>''";
						}
						else if ($opts["option"] == self::FILTER_EMPTY)
						{
							$search_sql .= " AND " . $field . "=''";
						}
						else
						{
							if (strlen($opts["text"]) == 0) continue;
							$opts["text"] = parseHtml($opts["text"]);
							$search_sql .= " AND " . $field . ( $opts["option"] == self::FILTER_EQUAL ? "=" : (($opts["option"] == self::FILTER_NOTLIKE ? " NOT " : "") . " RLIKE ")) . "'".$this->connection->EscapeString($opts["text"])."'";
						}
					break;
					
					case "number":
						$opts["number"] = trim($opts["number"]);
						if ($opts["number"] != '')
						{
							$search_sql .= " AND " . $field;
							switch($opts["option"])
							{
								case self::FILTER_LESSTHEN:
									$search_sql .= '<';
									break;
								case self::FILTER_MORETHEN:
									$search_sql .= '>';
									break;
								case self::FILTER_EQUAL:
								default:
									$search_sql .= '=';
									break;
							}
							$search_sql .= "'".$this->connection->EscapeString($opts["number"])."'";
						}
					break;
					
					case "check":
						$search_sql .= " AND ".$field."=".(int)$opts["text"];
					break;
					
					case "multiselect":
						if (!is_array($opts["id"]))
						{
							$opts["id"] = explode(',',$opts["id"]);
						}
						$prefix = '';
						$t_sql = '';
						foreach ($opts['id'] as $id)
						{
							if ($id != '')
							{
								$t_sql .= $prefix . $field . " REGEXP '[[:<:]]".$id."[[:>:]]'";
								$prefix = ' OR ';
							}
						}
						if (strlen($t_sql) > 0) $search_sql .= ' AND (' . $t_sql . ')';
					break;
					
					case 'admin':
						if (!empty($opts['id']))
						{
							$dbfield = ($field=='creator' ? 'Admin_Creator_Id':'Admin_Lastmodif_Id');
							$search_sql .= ' AND '.$dbfield.'='.$opts['id'];
						}
					break;
				}
			}
			$joined_fields = '';
			if (empty($filter['pub']))
			{
				$join = "";
			}
			else
			{
				$join = " I LEFT JOIN rub_ie R ON I.Id=R.Ie AND Ie_Table=".$this->id;
				if (empty($filter['rub_id']))
				{
					$search_sql .= " AND R.Rub IS ".($filter['pub'] == self::FILTER_PUBLISHED?"NOT":"")." NULL";
				}
				else
				{
					$search_sql .= " AND R.Rub=".(int)$filter['rub_id'];
					$joined_fields = ',R.`Ord`';
				}
			}
			return $this->GetAllRecs(
					'ie'.$this->id.$join,
					'Modified,'
						.implode(',', $outputidifs).',Admin_Creator_Id,Admin_Lastmodif_Id'.$joined_fields,
					'SQL_CALC_FOUND_ROWS Id',
					(is_numeric($sort_field) ? ($sort_field+2) : $sort_field).' '.(($sort_mode < 2)?'DESC':'ASC'),
					$search_sql,
					($page*$page_item_count).','.$page_item_count
					);
		}

		function Search($fieldslist, $searchstr, $page = 0, $page_item_count = DB::LIMIT_CLAUSE_LAST, $rub_id = null)
		{
			if ($this->id == null) return false;
			$fields = Array();
			for($i=0; $i<sizeof($fieldslist); $i++)
			{
				$fields[$i] = 'MATCH (`'.$fieldslist[$i]."`) AGAINST ('".$this->connection->EscapeString($searchstr)."')";
			}
			$joined_where = $joined_fields = $join = "";
			if ($rub_id != null)
			{
				$join = " I LEFT JOIN rub_ie R ON I.Id=R.Ie AND Ie_Table=".$this->id;
				$joined_where = " AND R.Rub=".$rub_id;
				$joined_fields = ',R.`Ord`';
			}
			return $this->GetAllRecs(
					'ie'.$this->id.$join,
					'('.implode(')+(', $fields).') as score'.$joined_fields,
					'SQL_CALC_FOUND_ROWS Id',
					'score',
					implode(' OR ', $fields).$joined_where,
					($page*$page_item_count).','.$page_item_count
			);
		}
		
		function CalcFoundRows()
		{
			$res = $this->connection->exec('SELECT FOUND_ROWS()');
			return $this->connection->getField($res);
		}

		function GetData($id, $identifiers = array())
		{
			if ($this->id == null) return false;
//			if (isset($this->data[$id])) return $this->data[$id];
			if ((is_array($identifiers) && count($identifiers) == 0) || $identifiers=='') $identifiers = $this->GetFieldsIdentifiers();
			$fields = is_array($identifiers) ? implode(',', $identifiers) : $identifiers;
			$data = $this->GetRec('ie'.$this->id, ($fields==''||$fields=='*' ? '*' : 'Id,Modified,'.$fields.',Admin_Creator_Id,Admin_Lastmodif_Id'), 'Id='.(int)$id);
			if ($data)
			{
				if (!isset($this->data[$id])) $this->data[$id] = array();
				$this->data[$id] = array_merge($this->data[$id], $data);
			}
			return $data;
		}

		function GetOneData($id, $identifier)
		{
			if ($this->id == null) return false;
			if (!isset($this->data[$id][$identifier])) $this->data[$id][$identifier] = $this->GetRec('ie'.$this->id, $identifier, 'Id='.(int)$id);
			return $this->data[$id][$identifier];
		}

		function CheckData($identifier, $value)
		{
			if ($this->id == null) return false;
			return (bool)$this->CountRecs('ie'.$this->id, "$identifier='$value'");
		}

		function SaveData($id, $admin_id = null, $texts = array(), $textareas = array(), $htmls = array(), $checkboxs = array(), $regexps = array(), $files = array(), $dates = array(), $selects = array(), $attaches = array(), $multifiles = array())
		{
			if ($this->id == null) return false;
			if ($admin_id != null) $sqladmin = " Admin_Lastmodif_Id=".$admin_id;
			else  $sqladmin = " Admin_Lastmodif_Id=Admin_Lastmodif_Id";
			if ($id == null)
			{
				$sql = 'INSERT INTO ie'.$this->id.'(Admin_Creator_Id) VALUES('.(int)$admin_id.')';
				$this->connection->exec($sql);
				$id = $this->connection->getInsertedId();
			}
			$sql = "";
			foreach($texts as $key => $value) //     int c float
			{
				$sql .= ", $key='$value'";
			}
			foreach($textareas as $key => $value)
			{
				$sql .= ", $key='$value'";
			}
			foreach($selects as $key => $value)
			{
				$sql .= ", $key='$value'";
			}
			foreach($htmls as $key => $value)
			{
				$sql .= ", $key='$value'";
			}
			foreach($checkboxs as $key => $value)
			{
				$sql .= ", $key='$value'";
			}
			foreach($regexps as $key => $value)
			{
				$sql .= ", $key='$value'";
			}
			$update_pub_date = false;
			foreach($dates as $key => $value)
			{
				$field_props = $this->GetField($key);
				if ($field_props['Properties_I']==self::FIELD_PROP_PUBDATE)
				{
					$update_pub_date = true;
					$pub_date = "'".$value." ".date("H:i:s")."'";
				}
				$sql .= ", $key='$value'";
			}
			foreach($files as $key => $value)
			{
				if (is_string($value) && $value == "")
				{
					$oldfilename = FILE_UPLOAD_DIR.$this->id."_".$id."_".$key."_".$this->GetRec("ie".$this->id, $key, "Id=".$id);
					if (file_exists($oldfilename))
					{
						unlink($oldfilename);
					}
					$sql .= ", $key=''";
				}
				elseif (is_array($value) && $value["name"] != "")
				{
					$oldfilename = FILE_UPLOAD_DIR.$this->id."_".$id."_".$key."_".$this->GetRec("ie".$this->id, $key, "Id=".$id);
					if (file_exists($oldfilename))
					{
						unlink($oldfilename);
					}
					if (move_uploaded_file($value['tmp_name'], FILE_UPLOAD_DIR.$this->id."_".$id."_".$key."_".$value["name"]))
					{
						chmod(FILE_UPLOAD_DIR.$this->id."_".$id."_".$key."_".$value["name"], APL_UPLOADEDFILE_PERM);
						$sql .= ", $key='".$value["name"]."'";
					}
				}
			}
			foreach($multifiles as $key => $value)
			{
				$sql_f = "INSERT INTO ie_files(Filename) VALUES('".$value["name"]."')";
				$this->connection->exec($sql_f);
				$cur_file_id = $this->connection->getInsertedId();
				
				if (move_uploaded_file($value['tmp_name'], MULTIFILE_UPLOAD_DIR.$cur_file_id."_".$value["name"]))
				{
					$sql .= ", $key=IF($key = '', '$cur_file_id', CONCAT($key, ',', '$cur_file_id'))";
				}
				else
				{
					$sql_f = "DELETE FROM ie_files WHERE Id=".$cur_file_id;
					$this->connection->exec($sql_f);
				}
			}
			foreach($attaches as $key => $value)
			{
				$sql .= ", $key='$value'";
			}
			$sql = 'UPDATE ie'.$this->id.' SET' . $sqladmin . $sql . ' WHERE Id='.(int)$id;
			if ($this->connection->exec($sql))
			{
				$sql = "UPDATE rub_ie SET ".($update_pub_date?' Pub_Date='.$pub_date.', ':'')."Sort_String='".$this->GetFirstPreviewFieldData((int)$id)."' WHERE Ie_Table=".$this->id." AND Ie=".(int)$id;
				$this->connection->exec($sql);
				foreach($attaches as $key => $value)
				{
					$field = $this->GetField($key);
					$sql = "DELETE FROM ie_ie WHERE Field_Id=".$field['Field_Id']." AND P_Ie_Id=".$id;
					$this->connection->exec($sql);
					$ord = 1;
					foreach (explode(',', $value) as $a_id)
					{
						$sql =	"INSERT INTO ie_ie(P_Ie, Field_Id, P_Ie_Id, C_Ie, C_Ie_Id, Ord) ".
								"VALUES(".$this->id.", ".$field['Field_Id'].", $id, ".$field['Properties_I'].", $a_id, $ord)";
						$this->connection->exec($sql);
						$ord++;
					}
				}
			}
			return $id;
		}

		function SaveFile($id, $field_identifier, $filedata)
		{
			$oldfilename = $this->GetRec("ie".$this->id, $field_identifier, "Id=".$id);
			if ($oldfilename != "")
			{
				$oldfilename = FILE_UPLOAD_DIR.$this->id."_".$id."_".$field_identifier."_".$oldfilename;
				if (file_exists($oldfilename))
				{
					unlink($oldfilename);
				}
				$sql = "UPDATE ie".$this->id." SET ".$field_identifier."='' WHERE Id=".$id;
				$this->connection->exec($sql);
			}
			if (is_array($filedata) && $filedata["name"] != "" && $filedata["tmp_name"] != "")
			{
				if (rename($filedata['tmp_name'], FILE_UPLOAD_DIR.$this->id."_".$id."_".$field_identifier."_".$filedata["name"]))
				{
					$sql = "UPDATE ie".$this->id." SET ".$field_identifier."='".$filedata["name"]."' WHERE Id=".$id;
					$this->connection->exec($sql);
				}
			}
		}

		function DeleteData($id)
		{
			if ($this->id == null) return false;
			$data = $this->GetData($id);
			$fields = $this->GetFields();
			foreach ($fields as $field)
			{
				switch ($field['Kind'])
				{
					case 'file':
						$filename = FILE_UPLOAD_DIR.$this->id."_".$id."_".$field['Identifier']."_".$data[$field['Identifier']];
						if (file_exists($filename))
						{
							unlink($filename);
						}
					break;
					
					case 'files':
						foreach (explode(',', $data[$field['Identifier']]) as $file_id)
						{
							$this->UnlinkMultiFile($file_id);
						}
					break;
				}
			}
			$sql = "DELETE FROM ie_ie WHERE P_Ie=".$this->id." AND P_Ie_Id=".$id;
			$this->connection->exec($sql);
			// TODO: 1.    ,    
			//       2.    Ord
			$sql = "DELETE FROM ie_ie WHERE C_Ie=".$this->id." AND C_Ie_Id=".$id;
			$this->connection->exec($sql);
			$sql = "DELETE FROM rub_ie WHERE Ie_Table=".$this->id." AND Ie=".$id;
			$this->connection->exec($sql);
			$sql = "DELETE FROM ie".$this->id." WHERE Id=".$id;
			return $this->connection->exec($sql);
		}

		function GetAttached($attached_ie_id, $attached_data, $show_attached = true)
		{
			if ($this->id == null) return false;
			$ret = Array();
			if ($attached_ie_id == 0) return $ret;
			if ($show_attached && $attached_data=='') return $ret;
            $field_identifier_for_show = $this->GetRec('ie_fields', 'Identifier', 'Ie_Id='.$attached_ie_id.' AND ShowPreview=1 ORDER By Ord');
            if ($field_identifier_for_show == false) return $ret;
            $cond = DB::WHERE_CLAUSE_NEUTRAL;
			if ($show_attached)
			{
				$ret = $this->GetPairs('ie'.$attached_ie_id, 'Id', $field_identifier_for_show, $field_identifier_for_show, 'Id IN ('.$attached_data.')');
			}
			else
			{
				if ($attached_data != '')
					$cond = 'Id NOT IN ('.$attached_data.')';
				$ret = $this->GetPairs('ie'.$attached_ie_id, 'Id', $field_identifier_for_show, $field_identifier_for_show, $cond);
			}
			return $ret;
		}
		
		function CountAttached($attached_ie_id, $attached_data, $show_attached = true)
		{
			if ($this->id == null) return false;
			if ($attached_ie_id == 0) return false;
			$ret = 0;
			if ($show_attached && $attached_data=='') return $ret;
            $cond = DB::WHERE_CLAUSE_NEUTRAL;
			if ($show_attached)
			{
				$ret = $this->CountRecs('ie'.$attached_ie_id, 'Id IN ('.$attached_data.')');
			}
			else
			{
				if ($attached_data != '')
					$cond = 'Id NOT IN ('.$attached_data.')';
				$ret = $this->CountRecs('ie'.$attached_ie_id, $cond);
			}
			return $ret;
		}

		function Attach($field_identifier, $attached_ie_id, $id)
		{
			if ($this->id == null) return false;
			$sql = "UPDATE ie".$this->id." SET ".$field_identifier."=IF(ISNULL($field_identifier), $attached_ie_id, CONCAT($field_identifier, ',".$attached_ie_id."')) WHERE Id=".$id;
			$ret = $this->connection->exec($sql);
			$field = $this->GetField($field_identifier);
			$ord = $this->GetRec('ie_ie', 'MAX(Ord)', "P_Ie=".$this->id." AND Field_Id=$field_id AND P_Ie_Id=$id") + 1;
			$sql =	"INSERT INTO ie_ie(P_Ie, Field_Id, P_Ie_Id, C_Ie, C_Ie_Id, Ord) ".
					"VALUES(".$this->id.", ".$field['Field_Id'].", $id, ".$field['Properties_I'].", $attached_ie_id, $ord)";
			return ($ret && $this->connection->exec($sql));
		}

		function GetTemplates()
		{
			if ($this->id == null) return false;
			if ($this->templates == null) $this->templates = $this->GetAllRecs('ie_templates', 'Identifier,Title,Body', 'Template_Id', 'Title', 'Ie_Id='.$this->id);
			return $this->templates;
		}

		function GetTemplateByIdentifier($template_identifier)
		{
			if ($this->id == null) return false;
			if ($this->templates == null) $this->GetTemplates();
			if (sizeof($this->templates)) foreach ($this->templates as $id => $template)
			{
				if ($template['Identifier'] == $template_identifier) return $template;
			}
			return false;
		}

		function ParseTemplate($template_identifier, $data_id, $replacements = Array(), $attachments = Array())
		{
			if ($this->id == null) return false;
			$template = $this->GetTemplateByIdentifier($template_identifier);
			if (!$template) return false;
			//  ,     
			$template = preg_replace("/\{<!--([^\}>]*)-->[^\}]*\}/", "{<!--\\1-->}", $template['Body']);
			if (!$data = $this->GetData($data_id))
			{
				return '';
			}
			else
			{
				// $this->fields    $this->GetData()
				foreach($data as $key => $value)
				{
					$field = $this->GetField($key);
					//   
					if (!$field)
					{
						switch ($key)
						{
							case 'Modified':
								$value = date("j.m.Y H:i", strtotime($value));
							break;
							case 'Id':
								$value = $data_id;
							break;
						}
					}
					//      
					else if (is_array($attachments) && isset($attachments[$key]))
					{
						$att_ie = new IE($this->connection, $field["Properties_I"]);
						$parsed_attachemnts = "";
						if ($value != "") foreach(explode(",", $value) as $attached_data_id)
						{
							$parsed_attachemnts .= $att_ie->ParseTemplate($attachments[$key], $attached_data_id, $replacements, $attachments);
						}
						$key = "ie,".$key;
						$value = $parsed_attachemnts;
					}
					//     
					else
					{
						switch($field["Kind"])
						{
							case "file":
								$filename = $this->id."_".$data_id."_".$key."_".$value;
								if ($value == "" || !file_exists(FILE_UPLOAD_DIR.$filename))
								{
									$template = str_replace("{<!--link,".$key."-->}", "", $template);
									$template = str_replace("{<!--/link,".$key."-->}", "", $template);
									$template = str_replace("{<!--obj,".$key."-->}", "", $template);
								}
								else
								{
									$template = str_replace("{<!--link,".$key."-->}", '<a href="'.FILE_UPLOAD_DIR_FRONT.$filename.'">', $template);
									$template = str_replace("{<!--/link,".$key."-->}", '</a>', $template);
									preg_match("/^.+\.([^.]+)$/", $filename, $splitfile);
									$ext = strtolower($splitfile[1]);
									if ($ext == "jpg" ||  $ext == "jpeg" ||  $ext == "png" ||  $ext == "gif" ||  $ext == "bmp")
									{
										$size = getimagesize(FILE_UPLOAD_DIR.$filename);
										$template = str_replace("{<!--obj,".$key."-->}", '<img src="'.FILE_UPLOAD_DIR_FRONT.$filename.'" alt=""  border="0" '.$size[3].'>', $template);
									}
									if ($ext == 'swf')
									{
										$size = getimagesize(FILE_UPLOAD_DIR.$filename);
										$template = str_replace("{<!--obj,".$key."-->}", '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" '.$size[3].' id="aplite_'.$this->id."_".$data_id."_".$key.'" align=""><param name="allowScriptAccess" value="sameDomain" /><param name="movie" value="'.FILE_UPLOAD_DIR_FRONT.$filename.'" /><param name="menu" value="false" /><param name="quality" value="high" /><param name="bgcolor" value="#ffffff" /><embed src="'.FILE_UPLOAD_DIR_FRONT.$filename.'" quality="high" bgcolor="#ffffff" '.$size[3].' name="aplite_'.$this->id."_".$data_id."_".$key.'" align="" allowScriptAccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" /></object>', $template);
									}
								}
							break;
							case "date":
								$value = preg_replace("/(\d{4})-(\d{2})-(\d{2})/", "\\3.\\2.\\1", $value);
							break;
							case 'checkbox':
								if ($value) $value = $field['Properties'];
								else $value = '';
							break;
						}
					}
					$template = str_replace("{<!--".$key."-->}", $value, $template);
				}
			}
			//   
			if (is_array($replacements)) foreach ($replacements as $key => $value)
			{
				$template = str_replace("{<!--".$key."-->}", $value, $template);
			}
			return $template;
		}

		function GetRubIds($id, $rub_group)
		{
			if ($this->id == null) return false;
            return $this->GetPairs("rub_ie ri, rubs r", null, "Rub", "1", "ri.Ie_Table=".$this->id." AND ri.Ie=$id AND ri.Rub=r.Rub_Id AND r.Group_Id=$rub_group");
		}
		
		function GetPubData($id, $rub_id = null)
		{
			if ($this->id == null) return false;
			return $this->GetAllRecs(
						'rub_ie',
						'*',
						null,
						1,
						'Ie_Table='.$this->id.' AND Ie='.$id.($rub_id != null ? ' AND Rub='.$rub_id:'')
					);
		}

		function IsPublished($id)
		{
			if ($this->id == null) return false;
			return $this->CountRecs('rub_ie', 'Ie_Table='.$this->id.' AND Ie='.(int)$id);
		}

		function UnpublishInRubs($id, $remove_rub_ids)
		{
			if ($this->id == null) return false;
			if (!is_array($remove_rub_ids)) return false;
			$ret = true;
			foreach ($remove_rub_ids as $rub_id)
			{
				$ord = (int)$this->GetRec("rub_ie", "MAX(Ord)", "Rub=".$rub_id." AND Ie_Table=".$this->id." AND Ie=".$id);
				$sql = "DELETE FROM rub_ie WHERE Ie_Table=".$this->id." AND Rub=".$rub_id." AND Ie=".$id;
				$ret = $ret & $this->connection->exec($sql);
				$sql = "UPDATE rub_ie SET Ord=Ord-1 WHERE Rub=".$rub_id." AND Ord>".$ord;
				$ret = $ret & $this->connection->exec($sql);
			}
			return $ret;
		}

		function PublishInRubs($id, $publish_rub_ids, $admin_id=0)
		{
			if ($this->id == null) return false;
			if (!is_array($publish_rub_ids)) return false;
			$ret = true;
			$data = $this->GetData($id);
			$this->GetFields();
			
			$sort_string = '';
			$field_1_num = 0;
			$pub_date = '';
			
			foreach ($this->fields as $field)
			{
				if ($field_1_num == 0 && $field['ShowPreview'] == 1)
				{
					$sort_string = $data[$field['Identifier']];
					$field_1_num = $field['Ord'];
				}
				if ($field['Kind']=='date' && $field['Properties_I']==self::FIELD_PROP_PUBDATE)
				{
					if (is_null($data[$field['Identifier']]) || $data[$field['Identifier']]=="0000-00-00 00:00:00")
						$pub_date = DB::SQL_FUNCTION_CURRENTDATE;
					else
						$pub_date = "'".$data[$field['Identifier']]." ".date("H:i:s")."'";
				}
				if ($field_1_num > 0 && $pub_date != '') break;
			}
			if ($pub_date == '') $pub_date = DB::SQL_FUNCTION_CURRENTDATE;
			
			foreach ($publish_rub_ids as $rub_id)
			{
				$max = (int)$this->GetRec("rub_ie", "MAX(Ord)", "Rub=".$rub_id);
				$sql = "INSERT INTO rub_ie SET Rub=".$rub_id.", Ie=".$id.", Ie_Table=".$this->id.", Admin_Id=".$admin_id.", Pub_Date=".$pub_date.", Sort_String='".$sort_string."', Ord=".($max+1);
				$ret = $ret & $this->connection->exec($sql);
			}
			
			return $ret;
		}

		function GetFirstPreviewFieldData($id)
		{
			$fields = $this->GetFieldsIdentifiers(self::FIELDLIST_PREVIEW);
			if (sizeof($fields) == 0) return false;
			$preview_field = current($fields);
			return $this->GetOneData($id, $preview_field);
		}

		function GetMultiFiles($id, $field_name)
		{
			$data = $this->GetData($id, $field_name);
			if (empty($data[$field_name])) return array();
			return $this->GetPairs('ie_files', 'File_Id', 'Filename', 'Filename', 'File_Id IN ('.$data[$field_name].')');
		}

		function DeleteMultiFile($id, $field_name, $file_id)
		{
			if ($this->id == null) return false;
			$data = $this->GetData($id, $field_name);
			$file_ids = explode(',', $data[$field_name]);
			$cur_pos = array_search($file_id, $file_ids);
			if ($cur_pos !== false)
			{
				if ($this->UnlinkMultiFile($file_id))
				{
					unset($file_ids[$cur_pos]);
					$sql = 'UPDATE ie'.$this->id.' SET '.$field_name.'=\''.implode(',', $file_ids).'\' WHERE Id='.$id;
					return $this->connection->exec($sql);
				}
			}
			else
			{
				return false;
			}
		}

		function UnlinkMultiFile($file_id)
		{
			$filename = $this->GetRec('ie_files', 'Filename', 'File_Id='.(int)$file_id);
			$sql = 'DELETE FROM ie_files WHERE File_Id='.(int)$file_id;
			if ($this->connection->exec($sql))
			{
				@unlink(MULTIFILE_UPLOAD_DIR.$file_id.'_'.$filename);
				return true;
			}
			else return false;
		}

		function SaveMultiFile($id, $field_name, $file_info)
		{
			if ($this->id == null) return false;
			$sql = "INSERT INTO ie_files(Filename) VALUES('".$file_info['name']."')";
			$this->connection->exec($sql);
			$cur_file_id = $this->connection->getInsertedId();
			if (move_uploaded_file($file_info['tmp_name'], MULTIFILE_UPLOAD_DIR.$cur_file_id.'_'.$file_info['name']))
			{
				$sql = 'UPDATE ie'.$this->id.' SET '.$field_name."=IF(".$field_name."='', '$cur_file_id', CONCAT(".$field_name.", ',', '$cur_file_id')) WHERE Id=".$id;
				return $this->connection->exec($sql);
			}
			else
			{
				$sql_f = 'DELETE FROM ie_files WHERE Id='.$cur_file_id;
				$this->connection->exec($sql_f);
				return false;
			}
		}

		function GetAlphabet($field)
		{
			if ($this->id == null) return false;
			return $this->GetPairs(
				'ie'.$this->id, 
				null,
				'DISTINCT LEFT('.$field.', 1) LET', 
				'LET');
		}

		function GetRandomIds($count)
		{
			if ($this->id == null) return false;
			return $this->GetPairs(
				'ie'.$this->id, 
				null,
				'Id', 
				'RAND()',
				DB::WHERE_CLAUSE_NEUTRAL,
				"0,$count"
				);
		}

		function GetByLetter($field, $letter)
		{
			if ($this->id == null) return false;
			return $this->GetAllRecs(
				'ie'.$this->id,
				$field,
				"Id", 
				$field,
				"LEFT($field, 1) = '$letter'");
		}

		function GetNextId($id)
		{
			if ($this->id == null) return false;
			$next = $this->GetRec(
				'ie'.$this->id, 
				'Id', 
				"Id>$id ORDER BY Id ASC LIMIT 0,1");
			if (!$next)
			{
				$next = $this->GetRec(
				'ie'.$this->id, 
				'MIN(Id)');
			}
			return $next;
		}

		function GetPrevId($id)
		{
			if ($this->id == null) return false;
			$prev = $this->GetRec(
				'ie'.$this->id, 
				'Id', 
				"Id<$id ORDER BY Id DESC LIMIT 0,1");
			if (!$prev)
			{
				$prev = $this->GetRec(
				'ie'.$this->id, 
				'MAX(Id)');
			}
			return $prev;
		}

	}
}
?>