<?php
if(!defined('__IE_ADMIN__'))
{
	define('__IE_ADMIN__', true);

	class IE_Admin extends IE
	{

		const FIELD_PLACELAST	= -1; //     

		function __construct(&$connection, $id = null)
		{
			parent::__construct($connection, $id);
		}

		function GetAdmins($id)
		{
			if ($this->id == null) return false;
			return $this->GetRec('ie'.$this->id, 'Admin_Creator_Id, Admin_Lastmodif_Id', 'Id='.$id);
		}

		/* ie */

		/**
		 * IE_Admin::checkIdentifier()
		 *
		 * @return  boolean
		 * TRUE     
		 */
		function checkIdentifier($identifier)
		{
			$where = "Identifier='$identifier'";
			if ($this->id != null) $where .= ' AND '.$this->index.'<>'.$this->id;
			if ($this->CountRecs($this->table, $where) > 0)
				return true;
			else
				return false;
		}

		function Create($identifier, $title, $ie_group_id = null, $rub_group_id = null)
		{
			if ($this->checkIdentifier($identifier))
			{
				//$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>'   ! [Rubricator::Create()]'));
				return false;
			}
			if ($ie_group_id == null || $ie_group_id == 0) $ord = 0;
			else
			{
				$ord = $this->GetRec('ies', 'MAX(Ord)', "Ie_Group_Id=$ie_group_id") + 1;
			}
			$sql = "INSERT INTO ies SET Identifier='$identifier', Title='$title', Ord=$ord".($ie_group_id ? ", Ie_Group_Id=$ie_group_id" : "").($rub_group_id ? ", Group_Id=$rub_group_id" : "");
			if ($this->connection->exec($sql))
			{
				$this->id = $this->connection->getInsertedId();
				$sql = 'CREATE TABLE IF NOT EXISTS ie'.$this->id."(Id int not null AUTO_INCREMENT, Modified timestamp, Admin_Creator_Id int DEFAULT '0' NOT NULL, Admin_Lastmodif_Id int DEFAULT '0' NOT NULL, Rating DECIMAL(7,4) DEFAULT '0' NOT NULL, Votes INT UNSIGNED DEFAULT '0' NOT NULL, primary key(Id)) ENGINE=".DB_ENGINE.' DEFAULT CHARSET='.DB_CODEPAGE." COMMENT=' $title'";
				if ($this->connection->exec($sql))
				{
					return $this->id;
				}
				else
				{
					$sql = 'DELETE FROM ies WHERE Ie_Id='.$this->id;
					$this->connection->exec($sql);
					$this->id = null;
				}
			}
			return false;
		}

		function myClone($clone_ie, $identifier, $title, $ie_group_id = null)
		{
			$all_ok = true;
			if (!$this->Create($identifier, $title, $ie_group_id))
			{
				$all_ok = false;
			}
			else
			{
				$all_ok = $this->id;
				$ie_2b_cloned = new IE_Admin($this->connection, $clone_ie);
				$fields = $ie_2b_cloned->GetFields();
				foreach($fields as $field_key => $value)
				{
					if (!$field_id = $this->AddField($value['Identifier'], $value['Title'], $value['Kind'], $value['ShowPreview'], $value['For_Sort'], self::FIELD_PLACELAST))
					{
						$all_ok = false;
						continue;
					}
					switch ($value['Kind'])
					{
						case "select":
						case "multi":
							$field = new Field($this->connection, $field_key);
							$select = $field->GetSelect();
							$this->UpdateField($field_id, $value['Title'], $value['ShowPreview'], $value['For_Sort'], implode(",",array_values($select)), implode(",",array_keys($select)), null, $value['Properties']);
						break;
						case "ie":
						case "checkbox":
						case "html":
							$this->UpdateField($field_id, $value['Title'], $value['ShowPreview'], $value['For_Sort'], null, null, $value['Properties_I'], $value['Properties']);
						break;
						case "regexp":
						case 'date':
							$this->UpdateField($field_id, $value['Title'], $value['ShowPreview'], $value['For_Sort'], null, null, null, $value['Properties']);
						break;
					}
				}
				$templates = $ie_2b_cloned->GetTemplates();
				foreach($templates as $key => $value)
				{
					if (!$template_id = $this->AddTemplate($value['Identifier'], $value['Title']))
					{
						$all_ok = false;
						continue;
					}
					if (!$this->UpdateTemplate($template_id, $value['Title'], $value['Body']))
						$all_ok = false;
				}
			}
			return $all_ok;
		}

		function Update($title, $flags)
		{
			if ($this->id == null) return false;
			$sql = "UPDATE ies SET Title='$title', Flags=$flags WHERE Ie_Id=".$this->id;
			$return = $this->connection->exec($sql);
			if ($return)
			{
				$sql = "ALTER TABLE ie".$this->id." COMMENT=' $title'";
				$return = $this->connection->exec($sql);
			}
			return $return;
		}

		function UpdateSpecial($identifier, $title)
		{
			if ($this->id == null) return false;
			$sql = "UPDATE ies SET Identifier='$identifier', Title='$title' WHERE Ie_Id=".$this->id;
			$return = $this->connection->exec($sql);
			if ($return)
			{
				$sql = "ALTER TABLE ie".$this->id." COMMENT=' $title'";
				$return = $this->connection->exec($sql);
			}
			return $return;
		}

		function Delete()
		{
			if ($this->id == null) return false;
			$sql = 'DELETE FROM rub_ie WHERE Ie_Table='.$this->id;
			$this->connection->exec($sql);
			$sql = 'DELETE FROM forms WHERE Ie_Id='.$this->id;
			$this->connection->exec($sql);
			$sql = 'DELETE FROM ie_templates WHERE Ie_Id='.$this->id;
			$this->connection->exec($sql);
			foreach ($this->GetPairs('ie_fields', null, 'Field_Id', '1', 'Ie_Id='.$this->id) as $field_id)
			{
				$this->DeleteField($field_id);
			}
			$sql = 'SELECT Ie_Id,Field_Id FROM ie_fields WHERE Properties_I='.$this->id;
			$res = $this->connection->exec($sql);
			while($row = $this->connection->fetch($res))
			{
				$attached_ie = new IE_Admin($this->connection, $row['Ie_Id']);
				if ($attached_ie->GetId())
				{
					$attached_ie->DeleteField($row['Field_Id']);
				}
			}
			$sql = 'DELETE FROM ie_permissions WHERE Ie_Id='.$this->id;
			$this->connection->exec($sql);
			$sql = 'DELETE FROM ies WHERE Ie_Id='.$this->id;
			$this->connection->exec($sql);
			$sql = 'DROP TABLE ie'.$this->id;
			$this->connection->exec($sql);
			$this->id = null;
			return true;
		}

		/* templates */
		function GetNextTemplateId()
		{
			return $this->_GetEntityProperties('ie_templates', 'Auto_increment');
		}

		function CountTemplates()
		{
			if ($this->id == null) return false;
			return $this->CountRecs('ie_templates', 'Ie_Id='.$this->id);
		}

		function GetTemplatesIdentifiers()
		{
			if ($this->id == null) return false;
			return $this->GetPairs('ie_templates', null, 'Identifier', '1', 'Ie_Id='.$this->id);
		}

		private function checkTemplate($identifier)
		{
			return $this->CountRecs('ie_templates', "Identifier='$identifier' AND Ie_Id=".$this->id);
		}

		function AddTemplate($identifier, $title)
		{
			if ($this->id == null || $this->checkTemplate($identifier)) return false;
			$sql = "INSERT INTO ie_templates SET Identifier='$identifier', Title='$title', Ie_Id=".$this->id;
			if ($this->connection->exec($sql))
			{
				return $this->connection->getInsertedId();
			}
			else return false;
		}

		function UpdateTemplate($id, $title, $body)
		{
			if ($this->id == null) return false;
			$sql = "UPDATE ie_templates SET Title='$title', Body='$body' WHERE Template_Id=".$id;
			return $this->connection->exec($sql);
		}

		function DeleteTemplate($id)
		{
			if ($this->id == null) return false;
			$sql = 'DELETE FROM ie_templates WHERE Template_Id='.$id;
			return $this->connection->exec($sql);
		}

		/* fields */
		function GetNextFieldId()
		{
			return $this->_GetEntityProperties("ie_fields", "Auto_increment");
		}

		function AddField($identifier, $title, $kind, $showpreview, $sort_type, $after_field)
		{
			if ($this->id == null) return false;
			if (in_array($identifier, $this->GetFieldsIdentifiers(self::FIELDLIST_FULL))) return false;
			if (in_array($identifier, $GLOBALS['reserved_sql_words'])) return false;
			/*        */
			if ($after_field == 0) //  
			{
				$ord = 1;
			}
			else if ($after_field > 0 && is_int($after_field)) //     ID
			{
				$ord = $this->GetRec('ie_fields', 'Ord', 'Field_Id='.$after_field);
				if ($ord == 0) return false;
				$ord++;
			}
			else // $after_field == self::FIELD_PLACELAST (=-1) --   ( ,  )
			{
				$ord = $this->GetRec('ie_fields', 'MAX(Ord)', 'Ie_Id='.$this->id) + 1;
			}
			switch($kind)
			{
				default:
					$props = '';
				break;
				case 'select':
					$props = 'select';
				break;
			}
			$fulltext_index = false;
			$index = false;
			switch($kind)
			{
				case "html":
				case "textarea":
					$fulltext_index = true;
					$type = DB::DATATYPE_TEXT." not null default ''";
					break;
				case "ie":
				case "multi":
				case "files":
					$type = DB::DATATYPE_LIST." not null default ''";
					break;
				case "date":
					$type = DB::DATATYPE_DATE;
					break;
				case "checkbox":
					$type = DB::DATATYPE_BIT." not null default 0";
					break;
				case "int":
					$index = true;
					$type = DB::DATATYPE_INT." NOT NULL DEFAULT 0";
					break;
				case "float":
					$index = true;
					$type = DB::DATATYPE_FLOAT." NOT NULL DEFAULT 0";
					break;
				case "text":
					$fulltext_index = true;
				default:
					$type = DB::DATATYPE_DEFAULT." not null default ''";
					break;
			}
			$sql = "ALTER TABLE ie".$this->id." ADD $identifier $type";
			if ($this->connection->exec($sql))
			{
				$sql = "INSERT INTO ie_fields SET Identifier='$identifier', Title='$title', Kind='$kind', ShowPreview=$showpreview, For_Sort=$sort_type, Ord=$ord, Properties_I=0, Properties='$props', Ie_Id=".$this->id;
				if ($this->connection->exec($sql))
				{
					$field_id = $this->connection->getInsertedId();
					
					$sql = 'UPDATE ie_fields SET Ord=Ord+1 WHERE Field_Id <> '.$field_id.' AND Ie_Id='.$this->id.' AND Ord >= '.$ord;
					$this->connection->exec($sql);
					
					if ($fulltext_index) $this->connection->AddFulltext('ie'.$this->id, $identifier);
					if ($index) $this->connection->AddIndex('ie'.$this->id, $identifier);
					
					$this->fields = null;
					return $field_id;
				}
				else
				{
					$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>$this->connection->getError()));
					$sql = "ALTER TABLE ie".$this->id." DROP $identifier";
					$this->connection->exec($sql);
					return false;
				}
			}
			else
			{
				$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>$this->connection->getError()));
				return false;
			}
		}

		function UpdateField($id, $title, $showpreview, $sort_type, $selecttitles=null, $selectvalues=null, $properties_i=null, $properties=null)
		{
			if ($this->id == null) return false;
			$id = (int)$id;
			if ($properties_i !== null)
			{
				$properties_i_sql = ", Properties_I=$properties_i ";
				$field = $this->GetField($id);
				if ($field['Kind'] == 'ie' && $field['Properties_I']!=$properties_i)
				{
					$sql = "DELETE FROM ie_ie WHERE Field_Id=$id";
					$this->connection->exec($sql);
				}
			}
			else
				$properties_i_sql = '';
			if ($properties !== null)
				$properties_sql = ", Properties='$properties' ";
			else
				$properties_sql = '';
			$sql = "UPDATE ie_fields SET Title='$title', ShowPreview=$showpreview, For_Sort=$sort_type $properties_i_sql $properties_sql WHERE Field_Id=".$id;
			if($this->connection->exec($sql))
			{
				if ($selecttitles!=null && $selectvalues!=null)
				{
					$sql = "DELETE FROM ie_selects WHERE Field_Id=".$id;
					$this->connection->exec($sql);
					$selecttitles_arr = explode(",", $selecttitles);
					$selectvalues_arr = explode(",", $selectvalues);
					for($i=0, $selecttitles_arr_size=sizeof($selecttitles_arr); $i<$selecttitles_arr_size; $i++)
					{
						$sql = "INSERT INTO ie_selects(Field_Id, Identifier, Title) VALUES(".$id.",'".$selectvalues_arr[$i]."','".$selecttitles_arr[$i]."')";
						$this->connection->exec($sql);
					}
				}
				$this->fields = null;
				return true;
			}
			return false;
		}

		function MoveFieldDown($id)
		{
			if ($this->id == null) return false;
			$ord = $this->GetRec("ie_fields", "Ord", "Field_Id=".$id) + 1;
			$sql = "UPDATE ie_fields SET Ord=Ord-1 WHERE Ord=".$ord." AND Ie_Id=".$this->id;
			$res = $this->connection->exec($sql);
			$sql = "UPDATE ie_fields SET Ord=Ord+1 WHERE Field_id=".$id." AND Ie_Id=".$this->id;
			$res = $this->connection->exec($sql);
			$this->fields = null;
		}

		function MoveFieldUp($id)
		{
			if ($this->id == null) return false;
			$ord = $this->GetRec("ie_fields", "Ord", "Field_Id=".$id) - 1;
			$sql = "UPDATE ie_fields SET Ord=Ord+1 WHERE Ord=".$ord." AND Ie_Id=".$this->id;
			$res = $this->connection->exec($sql);
			$sql = "UPDATE ie_fields SET Ord=Ord-1 WHERE Field_id=".$id." AND Ie_Id=".$this->id;
			$res = $this->connection->exec($sql);
			$this->fields = null;
		}

		function DeleteField($id)
		{
			if ($this->id == null) return false;
			$row = $this->GetField($id);
			switch ($row['Kind'])
			{
				case 'file':
					$files = $this->GetAllRecs('ie'.$this->id, 'Id,'.$row['Identifier'], null);
					foreach ($files as $row1)
					{
						$filename = FILE_UPLOAD_DIR.$this->id.'_'.$row1['Id'].'_'.$row['Identifier'].'_'.$row1[$row['Identifier']];
						@unlink($filename);
					}
				break;
				case 'files':
					foreach ($this->GetPairs('ie'.$this->id, null, $row['Identifier'], 'Id') as $file_ids)
					{
						foreach (explode(',', $file_ids) as $file_id)
						{
							$this->UnlinkMultiFile($file_id);
						}
					}
				break;
				case 'select':
				case 'multi':
					$sql = 'DELETE FROM ie_selects WHERE Field_Id='.$id;
					$this->connection->exec($sql);
				break;
				case 'ie':
					$sql = "DELETE FROM ie_ie WHERE Field_Id=$id";
					$this->connection->exec($sql);
				break;
			}
			
			$sql = 'DELETE FROM ierub_fieldrestrictions WHERE Field_Id='.$id;
			$this->connection->exec($sql);
			$sql = 'DELETE FROM ie_fields WHERE Field_Id='.$id;
			$this->connection->exec($sql);
			$sql = 'UPDATE ie_fields SET Ord=Ord-1 WHERE Ord>'.$row['Ord'].' AND Ie_Id='.$this->id;
			$this->connection->exec($sql);
			$sql = 'ALTER TABLE `ie'.$this->id.'` DROP `'.$row['Identifier'].'`';
			$this->connection->exec($sql);
			$this->fields = null;
			return true;
		}

	}
}
?>