<?php
if(!defined("__RUBRICATOR__"))
{
	define("__RUBRICATOR__", true);

	define("E_MSG_RR_DELETE", "  ");

//	include_once(dirname(__FILE__)."/../../../../inc/classes/storage.php");

	/**
	 * Class Rubricator()
	 *    () -  ( ) .
	 *          
	 * @author maxim.yefimochkin@v6.ru
	 */
	class Rubricator extends Storage
	{
		public $identifier = null;
		public $rublevelsmax = 0;
		public $title = '';
		public $ie_id = null;

		function __construct(&$connection, $id = null)
		{
			parent::__construct($connection, "rub_groups", "Group_Id");
			$this->SetId($id);
			if ($this->id != null)
			{
				$data = $this->GetRec($this->table, '*', $this->index.'='.$this->id);
				$this->identifier = $data['Identifier'];
				$this->rublevelsmax = $data['Rub_Levels_Max'];
				$this->title = $data['Title'];
                $this->SetIeId();
			}
		}

		function GetIeId()
        {
			if ($this->id == null) return false;
            return $this->ie_id;
        }

		function SetIeId()
		{
			if ($this->id == null) return false;
			$this->ie_id = $this->GetRec('ies', 'Ie_Id', 'Group_Id='.$this->id);
		}

		function SetIE($ie = null)
		{
			if ($ie != null)
			{
				$this->ie = $ie;
			}
			else
			{
				if ($this->id == null) return false;
				$this->ie = new IE($this->connection, $this->GetIeId());
			}
		}

		function GetData($ie_data_id, $identifiers = array())
		{
			if (!isset($this->ie)) $this->SetIE(new IE($this->connection, $this->GetIeId()));
			return $this->ie->GetData($ie_data_id, $identifiers);
		}

		/**
		 * Rubricator::checkIdentifier()
		 *
		 * @return  boolean
		 * TRUE            
		 */
		function checkIdentifier($identifier)
		{
			$where = "Identifier='$identifier'";
			if ($this->id != null) $where .= ' AND '.$this->index.'<>'.$this->id;
			$ie = new IE_Admin($this->connection, $this->ie_id);
			if ($this->CountRecs($this->table, $where) > 0 || $ie->checkIdentifier($identifier))
				return true;
			else
				return false;
		}

		function Create($identifier, $title, $rublevelsmax=0)
		{
			if ($this->checkIdentifier($identifier))
			{
				//$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>'   ! [Rubricator::Create()]'));
				return false;
			}
			$sql = 'INSERT INTO rub_groups(Identifier, Title, Rub_Levels_Max) VALUES(\''.$identifier.'\', \''.$title.'\', '.(int)$rublevelsmax.')';
			if ($this->connection->exec($sql))
			{
				$this->id = $this->connection->getInsertedId();
				$this->identifier = $identifier;
				$this->rublevelsmax = (int)$rublevelsmax;
				$this->title = $title;
				//       
				$ie = new IE_Admin($this->connection);
				$this->ie_id = $ie->Create($identifier, $title, null, $this->id);
				return $this->id;
			}
			else return false;
		}

		/*
		. Rub::checkIdentifier()
		*/
		function GetByIdentifier($identifier, $rub_parent)
		{
			if ($this->id == null) return false;
			$rub_id = $this->GetRec('rubs', 'Rub_Id', "Identifier='".$this->connection->EscapeString($identifier)."' AND Group_Id=".$this->id.' AND Rub_Parent='.$rub_parent);
			if($rub_id)
				$rub = new Rub($this->connection, $rub_id);
			else
				return false;
			if ($rub->GetId())
				return $rub;
			else
				return false;
		}

		/**
		   return    Rub
		*/
		function GetTopRubrics()
		{
			if ($this->id == null) return false;
			$c = array();
            $ids = $this->GetPairs("rubs", null, "Rub_Id", "Ord", "Rub_Parent=0 AND Group_Id=".$this->id);
            foreach ($ids as $id)
			{
				array_push($c, new Rub($this->connection, $id));
			}
			return $c;
		}

		function CountTopRubrics()
		{
			if ($this->id == null) return false;
			return $this->CountRecs("rubs", "Rub_Parent=0 AND Group_Id=".$this->id);
		}

		function Update($identifier, $title, $rublevelsmax=0)
		{
			if ($this->id == null) return false;
			if ($this->checkIdentifier($identifier))
			{
				//$_SESSION['Error']->Add(array('level'=>E_ERROR, 'message'=>'   ! [Rubricator::Update()]'));
				return false;
			}
			$sql = "UPDATE rub_groups SET Identifier='$identifier', Title='$title'".($rublevelsmax > $this->rublevelsmax || $rublevelsmax == 0?', Rub_Levels_Max='.$rublevelsmax:'')." WHERE Group_Id=".$this->id;
			$this->identifier = $identifier;
			$this->title = $title;
			$this->rublevelsmax = $rublevelsmax;
			$ie = new IE_Admin($this->connection, $this->GetIeId());
			$return = $this->connection->exec($sql);
			if ($return) $ie->UpdateSpecial($identifier, $title);
			return $return;
		}

		function Delete()
		{
			if ($this->id == null) return false;
			if ($this->CountTopRubrics() > 0)
			{
				$_SESSION["Error"]->Add(array("level"=>E_ERROR, "message"=>E_MSG_RR_DELETE.":    [Rubricator::Delete()]"));
				return false;
			}
			/* autodelete rubrics
			$sql = "SELECT Rub_Id FROM rubs WHERE Group_Id=".$this->id;
            $res = $this->connection->exec($sql);
            while ($row = $this->connection->fetch($res))
            {
                $rub = new Rub($this->connection,$row["Rub_Id"]);
                $rub->Delete();
            }*/
			$sql = "DELETE FROM restruct_permissions WHERE Group_Id=".$this->id;
			$this->connection->exec($sql);

			$ie = new IE_Admin($this->connection, $this->ie_id);
			if ($ie->Delete() || $ie->id == null)
			{
				$sql = "DELETE FROM rub_groups WHERE Group_Id=".$this->id;
				$this->connection->exec($sql);
			}
			
			$this->id = null;
			$this->ie_id = null;
			$this->identifier = null;
			$this->ie = null;
			return true;
		}

		function GetRestrictions()
		{
			if ($this->id == null) return false;
			return $this->GetAllRecs("ierub_fieldrestrictions", "*", "Restriction_Id", "Restriction_Id", "Field_Id IN (SELECT Field_Id FROM ie_fields WHERE Ie_Id=".$this->ie_id.")");
		}
	}
}
?>