<?php
if(!defined('__FORUM_ADMIN__'))
{
	define('__FORUM_ADMIN__', true);

	class Forum_Admin extends Forum_Tree
	{

		const	ERRORCODE_LEFT_GREATER_RIGHT	= 1; //     .
		const	ERRORCODE_KEYS_WRONG_VALUES		= 2; //      1.        .
		const	ERRORCODE_KEYS_WRONG_DIFF		= 4; //         .
		const	ERRORCODE_LEFT_KEY_LEVEL		= 8; //            ,       .
		const	ERRORCODE_KEYS_NOT_UNIQUE		= 16;//   ,        .
		
		protected	$errorcode	= array();
		protected	$error_ids	= array();
		protected	$nodes_count	= array();
		protected	$min_left_key	= array();
		protected	$max_right_key	= array();
		
		function __construct(&$connection)
		{
			parent::__construct($connection);
		}
		
		public function test($thread_id)
		{
			$this->errorcode[$thread_id] = 0;
			if ($LEFT_GREATER_RIGHT = $this->GetPairs($this->table, null, 'body_id', 1, 'thread_id = '.$thread_id.' AND left_key >= right_key'))
			{
				$this->errorcode[$thread_id] |= self::ERRORCODE_LEFT_GREATER_RIGHT;
				$this->error_ids[$thread_id][self::ERRORCODE_LEFT_GREATER_RIGHT] = $LEFT_GREATER_RIGHT;
			}
			$KEYS_WRONG_VALUES = $this->GetRec($this->table, 'COUNT('.$this->index.') c, MIN(left_key) mi, MAX(right_key) ma', 'thread_id = '.$thread_id);
			if ($KEYS_WRONG_VALUES != false && ($KEYS_WRONG_VALUES['mi'] != 1 || $KEYS_WRONG_VALUES['c']*2 != $KEYS_WRONG_VALUES['ma']))
			{
				$this->errorcode[$thread_id] |= self::ERRORCODE_KEYS_WRONG_VALUES;
				$this->nodes_count[$thread_id] = $KEYS_WRONG_VALUES['c'];
				$this->min_left_key[$thread_id] = $KEYS_WRONG_VALUES['mi'];
				$this->max_right_key[$thread_id] = $KEYS_WRONG_VALUES['ma'];
			}
			if ($KEYS_WRONG_DIFF = $this->GetAllRecs($this->table, 'MOD((right_key - left_key), 2) AS ostatok', 'body_id', 1, 'thread_id = '.$thread_id.' AND MOD((right_key - left_key), 2)=0'))
			{
				$this->errorcode[$thread_id] |= self::ERRORCODE_KEYS_WRONG_DIFF;
				$this->error_ids[$thread_id][self::ERRORCODE_KEYS_WRONG_DIFF] = $KEYS_WRONG_DIFF;
			}
			if ($LEFT_KEY_LEVEL = $this->GetAllRecs($this->table, 'MOD((left_key - `level` + 2), 2) AS ostatok', 'body_id', 1, 'thread_id = '.$thread_id.' AND MOD((left_key - `level` + 2), 2)=1'))
			{
				$this->errorcode[$thread_id] |= self::ERRORCODE_LEFT_KEY_LEVEL;
				$this->error_ids[$thread_id][self::ERRORCODE_LEFT_KEY_LEVEL] = $LEFT_KEY_LEVEL;
			}
			
			return $this->errorcode[$thread_id];
		}
		
		protected function getErrorInfo($thread_id)
		{
			return $this->errorcode[$thread_id];
		}
	}
}
?>