<?php
if(!defined('__FORUM_TREE__'))
{
	define('__FORUM_TREE__', true);

	class Forum_Tree extends Storage
	{

		public		$forum_id	= null;

		function __construct(&$connection)
		{
			parent::__construct($connection, 'forum_message_tree', 'body_id');
		}
		
		public function AddNode($body_id, $parent_id = null, $admin_message = 0)
		{
			if ($parent_id == null && $this->forum_id == null) return false;
			if ($parent_id == null)
			{
				$right_key = 1;
				$level = $parent_id = 0;
				$thread_id = $body_id;
			}
			else
			{
				if (!$parent_data = $this->GetRec($this->table, 'right_key, `level`, thread_id, forum_id', $this->index.'='.$parent_id)) return false;
				list($right_key, $level, $thread_id, $this->forum_id) = array_values($parent_data);
				
				$sql = 'UPDATE '.$this->table.' SET '
						.'  right_key = right_key + 2'
						.', left_key = IF(left_key > '.$right_key.', left_key + 2, left_key) '
						.'WHERE right_key >= '.$right_key.' AND thread_id = '.$thread_id;
				$this->connection->exec($sql);
			}
			$sql = 'INSERT INTO '.$this->table.' SET '
					.'  left_key = '.$right_key
					.', right_key = '.$right_key.' + 1'
					.', `level` = '.$level.' + 1'
					.', body_id = '.$body_id
					.', thread_id = '.$thread_id
					.', parent_id = '.$parent_id
					.', forum_id = '.$this->forum_id
					.', admin_mess = '.intval((boolean)$admin_message);
			return $this->connection->exec($sql);
		}
		
		public function GetNode($body_id)
		{
			return $this->GetRec($this->table, '*', $this->index.'='.$body_id);
		}
		
		public function GetTree($thread_id)
		{
			return $this->GetAllRecs($this->table, '*', null, 'left_key', 'thread_id = '.$thread_id);
		}
		
		public function GetNodesCount($forum_id)
		{
			return $this->CountRecs($this->table, 'forum_id = '.$forum_id);
		}
		
		public function GetNodeLatest($forum_id)
		{
			$latest = $this->GetAllRecs($this->table, '*', null, 'dt_stamp DESC', 'forum_id = '.$forum_id, '1');
			return ($latest?$latest[0]:false);
		}
		
		public function GetReplyCount($thread_id)
		{
			return $this->CountRecs($this->table, 'thread_id = '.$thread_id) - 1;
		}
	}
}
?>