<?
if(!defined('__INQUIRER__'))
{
	define('__INQUIRER__', true);
	include_once(dirname(__FILE__).'/../../../../inc/classes/storage.php');

	class Inquirer extends Storage
	{

		const INQUIRER_NOTACTIVE	= 0;
		const INQUIRER_ACTIVE		= 1;
		
		const QUESTION_ONE_ANSWER	= 0;
		const QUESTION_MANY_ANSWER	= 1;

		function __construct(&$connection, $id = null)
		{
			parent::__construct($connection, 'fb_inquirer', 'Inquirer_Id');
			$this->SetId($id);
		}

		function Create($identifier, $title)
		{
			$sql = 'INSERT INTO '.$this->table.' SET Identifier=\''.$identifier.'\', Title=\''.$title.'\', Dat=NOW(), IsActive='.self::INQUIRER_NOTACTIVE;
			if ($this->connection->exec($sql))
			{
				$this->id = $this->connection->getInsertedId();
				return $this->id;
			}
			else return false;
		}

		function Update($title)
		{
			if ($this->id == null) return false;
			$sql = 'UPDATE '.$this->table.' SET Title=\''.$title.'\' WHERE '.$this->index.'='. $this->id;
			return $this->connection->exec($sql);
		}
		
		function GetData()
		{
			if ($this->id == null) return false;
			return $this->GetRec($this->table, '*', $this->index.'='.$this->id);
		}

		function Delete()
		{
			if ($this->id == null) return false;
			$questions = array_keys($this->GetQuestions());
			foreach ($questions as $value)
			{
				$this->DeleteQuestion($value);
			}
			$sql = 'DELETE FROM '.$this->table.' WHERE '.$this->index.'='.$this->id;
			$this->connection->exec($sql);
			$this->id = null;
			return true;
		}
		
		function GetQuestions()
		{
			if ($this->id == null) return false;
			return $this->GetAllRecs($this->table.'_question', 'Title,Kind', 'Question_Id' ,'Title', 'Inquirer_Id='.$this->id);
		}

		function GetQuestion($question_id)
		{
			if ($this->id == null) return false;
			return $this->GetRec($this->table.'_question', 'Title,Kind', 'Question_Id='.$question_id);
		}
		
		function CreateQuestion($title, $kind)
		{
			$sql = 'INSERT INTO '.$this->table.'_question SET Title=\''.$title.'\', Kind='.(int)$kind.', Inquirer_Id='.$this->id;
			if ($this->connection->exec($sql))
			{
				return $this->connection->getInsertedId();
			}
			else return false;
		}
		
		function UpdateQuestion($question_id, $title, $kind)
		{
			if ($this->id == null) return false;
			$sql = 'UPDATE '.$this->table.'_question SET Title=\''.$title.'\', Kind='.(int)$kind.' WHERE Question_Id='.(int)$question_id;
			return $this->connection->exec($sql);
		}
		
		function DeleteQuestion($question_id)
		{
			if ($this->id == null) return false;
			$answers = array_keys($this->GetAnswers($question_id));
			foreach ($answers as $value)
			{
				$this->DeleteAnswer($value);
			}
			$sql = 'DELETE FROM '.$this->table.'_question WHERE Question_Id='.(int)$question_id;
			$this->connection->exec($sql);
			return true;
		}
		
		function CreateAnswer($question_id, $title)
		{
			$sql = 'INSERT INTO '.$this->table.'_answer SET Title=\''.$title.'\', Count=0, Question_Id='.(int)$question_id;
			if ($this->connection->exec($sql))
			{
				return $this->connection->getInsertedId();
			}
			else return false;
		}
		
		function UpdateAnswer($answer_id, $title, $count)
		{
			if ($this->id == null) return false;
			$sql = 'UPDATE '.$this->table.'_answer SET Title=\''.$title.'\', Count='.(int)$count.' WHERE Answer_Id='.(int)$answer_id;
			return $this->connection->exec($sql);
		}
		
		function GetAnswers($question_id)
		{
			if ($this->id == null) return false;
			return $this->GetAllRecs($this->table.'_answer', 'Title,Count', 'Answer_Id' ,'Title', 'Question_Id='.(int)$question_id);
		}
		
		function GetAnswer($answer_id)
		{
			if ($this->id == null) return false;
			return $this->GetRec($this->table.'_answer', 'Title,Count', 'Answer_Id='.(int)$answer_id);
		}
		
		function DeleteAnswer($answer_id)
		{
			if ($this->id == null) return false;
			$sql = 'DELETE FROM '.$this->table.'_answer WHERE Answer_Id='.(int)$answer_id;
			$this->connection->exec($sql);
			return true;
		}
		
		function SetActive()
		{
			if ($this->id == null) return false;
			$questions = $this->GetQuestions();
			if (empty($questions)) return false;
			foreach ($questions as $question)
			{
				$answers = $this->GetAnswers($question['Question_Id']);
				if (empty($answers)) return false;
			}
			$sql = 'UPDATE '.$this->table.' SET IsActive='.self::INQUIRER_NOTACTIVE;
			$this->connection->exec($sql);
			$sql = 'UPDATE '.$this->table.' SET IsActive='.self::INQUIRER_ACTIVE.', WasActive='.self::INQUIRER_ACTIVE.' WHERE '.$this->index.'='.$this->id;
			$this->connection->exec($sql);
			return true;
		}
		
		function SetNotActive()
		{
			if ($this->id == null) return false;
			$sql = 'UPDATE '.$this->table.' SET IsActive='.self::INQUIRER_NOTACTIVE.' WHERE '.$this->index.'='.$this->id;
			$this->connection->exec($sql);
			return true;
		}
		
		function IncreaseAnswer($answer_id)
		{
			if ($this->id == null) return false;
			$sql = 'UPDATE '.$this->table.'_answer SET Count=Count+1 WHERE Answer_Id='.(int)$answer_id;
			return $this->connection->exec($sql);
		}
		
		function Vote($answers)
		{
			if ($this->id == null) return false;
			$return = true;
			foreach($answers as $key => $value)
			{
				if (is_array($value))
				{
					foreach($value as $key1 => $value1)
					{
						$return &= $this->IncreaseAnswer($value1);
					}
				}
				else
				{
					$return &= $this->IncreaseAnswer($value);
				}
			}
			return $return;
		}
	}
}
?>