<?php
if(!defined('__INQUIRERS__'))
{
	define('__INQUIRERS__', true);
	include_once(dirname(__FILE__).'/inquirer.php');

	class Inquirers extends Storage
	{
		function __construct(&$connection)
		{
			parent::__construct($connection, 'fb_inquirer');
		}

		function GetNextId()
		{
			return $this->_GetEntityProperties($this->table);
		}

		function GetAll($page = 0, $page_item_count = -1)
		{
			return $this->GetAllRecs(
					$this->table,
					'*',
					null,
					'Dat DESC',
					DB::WHERE_CLAUSE_NEUTRAL,
					($page*$page_item_count).','.$page_item_count
					);
		}

		function GetCount()
		{
			return $this->CountRecs($this->table);
		}
		
		function HasCompleted()
		{
			$active = $this->CountRecs($this->table, 'IsActive='.Inquirer::INQUIRER_ACTIVE);
			$wasactive = $this->CountRecs($this->table, 'WasActive='.Inquirer::INQUIRER_ACTIVE);
			$total = $this->GetCount();
			if ($total == $wasactive && $wasactive == $active || $wasactive == 0) return false;
			else return true;
		}
		
		function Get($page, $count)
		{
			return $this->GetAllRecs($this->table, '*', null, 'Dat DESC');
		}
		
		function GetActive()
		{
			$active_inq = $this->GetRec($this->table, 'Inquirer_Id', 'IsActive='.Inquirer::INQUIRER_ACTIVE);
			if ($active_inq)
			{
				return new Inquirer($this->connection, $active_inq);
			}
			else
			{
				return false;
			}
		}
		
		function GetLastActive()
		{
			$active_inq = $this->GetRec($this->table, 'Inquirer_Id', 'WasActive='.Inquirer::INQUIRER_ACTIVE.' ORDER BY Inquirer_Id DESC LIMIT 1');
			if ($active_inq)
			{
				return new Inquirer($this->connection, $active_inq);
			}
			else
			{
				return false;
			}
		}
		
		function GetPrevCompletedId($inq_id)
		{
			return $this->GetRec($this->table, 'Inquirer_Id', 'Inquirer_Id < '.$inq_id.' AND WasActive='.Inquirer::INQUIRER_ACTIVE.' ORDER BY Inquirer_Id DESC LIMIT 1');
		}
		
		function GetNextCompletedId($inq_id)
		{
			return $this->GetRec($this->table, 'Inquirer_Id', 'Inquirer_Id > '.$inq_id.' AND WasActive='.Inquirer::INQUIRER_ACTIVE.' ORDER BY Inquirer_Id LIMIT 1');
		}
	}
}
?>