<?php
if(!defined("__SHOP_CATALOG__"))
{
	define("__SHOP_CATALOG__", true);

	include_once(dirname(__FILE__)."/../../../../inc/classes/storage.php");
	include_once(realpath(dirname(__FILE__)."/../../aplite/classes/")."/ies.php");
	include_once(realpath(dirname(__FILE__)."/../../aplite/classes/")."/ie.php");
	
	class Shop_Catalog extends Storage
	{
		public $connection = null;

		function Shop_Catalog(&$connection)
		{
			$this->connection = $connection;
		}
		
		function SetOrder($ord, $old_rub_parent, $id)
		{
			$cur_ord = $this->GetRec("shop_catalog", "Ord", "Id=".$id);
			$cur_par_id = $this->GetRec("shop_catalog", "Par_Id", "Id=".$id);
            $MAX = $this->GetRec("shop_catalog", "MAX(Ord)", "Par_Id=".$old_rub_parent);
			if ($cur_ord != false)
			{
				//modify
				$sql = "UPDATE shop_catalog SET Ord=Ord-1 WHERE Ord>".$cur_ord." AND Par_Id=".$old_rub_parent;
				$this->connection->exec($sql);
			}
			$MAX = $MAX<1 ? $MAX+1 : $MAX;
			$ord = ($ord>$MAX || $ord<1) ? $MAX : $ord;
			$sql = "UPDATE shop_catalog SET Ord=Ord+1 WHERE Ord>=".$ord." AND Par_Id=".$cur_par_id;
			$this->connection->exec($sql);
			$sql = "UPDATE shop_catalog SET Ord=".$ord." WHERE Id=".$id;
			$this->connection->exec($sql);
			return $ord;
		}
		
		function Add($par_id, $title, $description, $hidden, $ord)
		{
			$sql = "INSERT INTO shop_catalog SET par_id=$par_id, title='$title', description='$description', hidden=$hidden";
			$this->connection->exec($sql);
			$id = $this->connection->getInsertedId();
			$this->SetOrder($ord, $par_id, $id);
			return  $id;
		}
		
		function GetRubrics($par_id = 0)
		{
			return $this->GetAllRecs("shop_catalog", "Title, Hidden", "Id", "Ord", "Par_Id=".$par_id);
		}
		
		function GetChildCount($rub_id)
		{
			return $this->CountRecs("shop_catalog", "Par_Id=".$rub_id);
		}
		
		function GetRubricsByFirm($firm_id, $hidden = 0)
		{
			return $this->GetAllRecs(
				"shop_catalog C, shop_goods G",
				"C.Title, COUNT(C.Id) GoodsCount", 
				"C.Id", 
				"C.Ord", 
				"C.Id = G.Catalog_Id AND G.Firm_Id=$firm_id AND G.Hidden=$hidden GROUP BY C.Id");
		}
		
		function GetFirms($id)
		{
			$ies = new IEs($this->connection);
			$firms_ie_info = $ies->GetByIdentifier(FIRM_IDENTIFIER);
			$sql = "SELECT DISTINCT I.Id,I.".FIRM_FIELD_IDENTIFIER." FROM shop_goods G, ie".$firms_ie_info['Ie_Id']." I WHERE G.Catalog_Id=".$id." AND G.Firm_Id=I.Id ORDER BY I.".FIRM_FIELD_IDENTIFIER;
			$ret = array();
			$res = $this->connection->exec($sql);
			while($row = $this->connection->fetch($res))
			{
				$ret[$row["Id"]] = $row[FIRM_FIELD_IDENTIFIER];
			}
			return $ret;
		}
		
		function GetRubric($id)
		{
			return $this->GetRec("shop_catalog", "Par_Id, Title, Description, Hidden, Ord", "Id=".$id);		
		}
		
		function GetPathRubrics($id)
		{
			global $par_rub;
			
			if (!defined("SHOP_ADDRUB"))
			{
				define("SHOP_ADDRUB", 1);
				function addrub($id, &$th)
				{
					global $par_rub; 
					$rub = $th->GetRubric($id);
					$par_rub[$id] = $rub;
					if ($rub['Par_Id'] != 0)
					{
						addrub($rub['Par_Id'], $th); 
					}
				}
			}
			$par_rub = Array();
			addrub($id, $this); 
			return array_reverse($par_rub, true);
		}		
		
		function Delete($id)
		{
			if (sizeof($this->GetRubrics($id)) > 0) return false; //   ..  
			$sql = "DELETE FROM shop_catalog WHERE Id=$id";
			$this->connection->exec($sql);
			$sql = "DELETE FROM shop_fields WHERE Catalog_Id=$id";
			$this->connection->exec($sql);			
			return true;
		}
		
		function Update($id, $par_id, $title, $description, $hidden, $ord)
		{
			global $child_ids;
			$child_ids = Array();
			array_push($child_ids, $id);
			
			function addrubid($rubs, &$th)
			{
				global $child_ids; 
				foreach($rubs as $key => $value)
				{
					array_push($child_ids, $key);
					$child_rubs = $th->GetRubrics($key);
					if (sizeof($child_rubs) > 0)
					{
						addrubid($child_rubs, $th);		
					}
				}
			}
			
			$rubs = $this->GetRubrics($id);
			addrubid($rubs, $this);
			
			if (!in_array($par_id, $child_ids))
			{
				$sql = "UPDATE shop_catalog SET par_id=$par_id, title='$title', description='$description', hidden=$hidden WHERE Id=$id";
				$this->connection->exec($sql);
				$this->SetOrder($ord, $par_id, $id);
				return true;
			}
			else return false;
		}	
	}
}
?>