<?php
if(!defined("__SHOP_GOODS__"))
{
	define("__SHOP_GOODS__", true);

	include_once(dirname(__FILE__)."/../../../../inc/classes/storage.php");
	include_once(dirname(__FILE__)."/fields.php");
	
	define("SHOP_FILE_PREVIEW_UPLOAD_DIR", realpath(dirname(__FILE__)."/../../../../files/shop_preview")."/");
	define("SHOP_FILE_PREVIEW_SHOW_DIR", "files/shop_preview/");
	define("SHOP_FILE_PREVIEW_SHOW_DIR_PREFIX", "../");

	define("SHOP_FILE_UPLOAD_DIR", realpath(dirname(__FILE__)."/../../../../files/shop")."/");
	define("SHOP_FILE_SHOW_DIR", "files/shop/");
	define("SHOP_FILE_SHOW_DIR_PREFIX", "../");	

	define("SHOP_FILE_UPLOAD_TMP_PREFIX", "tmp");	
	
	class Shop_Goods extends Storage
	{
		public $connection = null;

		function Shop_Goods(&$connection)
		{
			$this->connection = $connection;
		}

		function AddData($goods_id, $data)
		{
			$sql = "INSERT INTO shop_data(Field_Id, Goods_Id, DataVarchar, DataFloat) VALUES ";
			$sep = "";
			$flds = new Shop_Fields($this->connection);
			foreach($data as $key => $value)
			{
				$field_type = $flds->GetFieldType($key);
				$sql .= $sep."(".$key." ,".$goods_id.",";
				switch ($field_type)
				{
					case "number":
					 	$sql .= "'',".(float)$value;
						break;
					case "check":
					 	$sql .= "'',".(int)$value;
						break;						
					default:
					 	$sql .= "'".$value."',0";
				}
				$sql .= ")";
				$sep = ",";
			}
			$this->connection->exec($sql);
		}
		
		function UpdateData($goods_id, $data)
		{
			$flds = new Shop_Fields($this->connection);
			foreach($data as $key => $value)
			{
				if ($this->connection->countTableRecs("shop_data", "Field_Id=".$key." AND Field_Id=".$goods_id) == 0)
				{
					$sql1 = "INSERT INTO shop_data(Field_Id, Goods_Id) VALUES($key, $goods_id)";
					$this->connection->exec($sql1);
				}

				$field_type = $flds->GetFieldType($key);
				$sql = "UPDATE shop_data SET ";
				switch ($field_type)
				{
					case "number":
					 	$sql .= "DataFloat=".(float)$value;
						break;
					case "check":
					 	$sql .= "DataFloat=".(int)$value;
						break;						
					default:
					 	$sql .= "DataVarchar='".$value."'";
				}
				$sql .= " WHERE Field_Id=".$key." AND Goods_Id=".$goods_id;
				$this->connection->exec($sql);
			}
		}
		
		function GetData($field_id, $goods_id)
		{
			$flds = new Shop_Fields($this->connection);
			$field_type = $flds->GetFieldType($field_id);
			
			switch($field_type)
			{
				case "number":
					return $this->GetRec("shop_data", "DataFloat", "Field_Id=".$field_id." AND Goods_Id=".$goods_id);
					break;
				case "check":
					return $this->GetRec("shop_data", "DataFloat", "Field_Id=".$field_id." AND Goods_Id=".$goods_id);
					break;					
				default:
					return $this->GetRec("shop_data", "DataVarchar", "Field_Id=".$field_id." AND Goods_Id=".$goods_id);
			}
		}
		
		function Add($catalog_id, $identifier, $title, $price, $description, $hidden, $firm_id, $goodsstatus, $addcatalog_id)
		{
			$sql = "INSERT INTO shop_goods SET
					Catalog_Id=$catalog_id,
					Identifier='$identifier',
					Title='$title',
					Price=$price,
					Description='$description',
					Hidden=$hidden,
					Firm_Id=$firm_id,
					AddCatalog_Id=$addcatalog_id,
					GoodsStatus=$goodsstatus";
			$this->connection->exec($sql);
			return  $this->connection->getInsertedId();
		}
		
		function Update($id, $identifier, $title, $price, $description, $hidden, $firm_id, $goodsstatus, $addcatalog_id)
		{
			$sql = "UPDATE shop_goods SET
					Identifier='$identifier',
					Title='$title',
					Price=$price,
					Description='$description',
					Hidden=$hidden,
					Firm_Id=$firm_id,
					GoodsStatus=$goodsstatus,
					AddCatalog_Id=$addcatalog_id
					WHERE Id=$id";
			$this->connection->exec($sql);
		}
		
		function GetMany($catalog_id, $page = 0, $page_item_count = SQL_CONSTANT_LARGESTNUMBER, $sort_field = 1, $sort_mode = 0, $firm_id = null)
		{
			return $this->GetAllRecs("shop_goods", "Identifier, Title, Price, Hidden, Firm_Id, PreviewFilename", "Id", ($sort_field+1).(($sort_mode==1) ? " DESC" : " ASC"), (($firm_id != null) ? "Firm_Id=".$firm_id." AND " : "")."Catalog_Id=".$catalog_id, ($page*$page_item_count).",".$page_item_count);
		}
		
		function GetByAddCatalog($addcatalog_id, $page, $page_item_count, $sort_field, $sort_mode)
		{
			return $this->GetAllRecs("shop_goods", "Identifier, Title, Price, Hidden, PreviewFilename, Catalog_Id", "Id", ($sort_field+1).(($sort_mode==1) ? " DESC" : " ASC"), "AddCatalog_Id=".$addcatalog_id, ($page*$page_item_count).",".$page_item_count);
		}
		
		function GetByFirm($firm_id, $page, $page_item_count, $sort_field, $sort_mode)
		{
			return $this->GetAllRecs("shop_goods", "Identifier, Title, Price, Hidden, PreviewFilename, Catalog_Id", "Id", ($sort_field+1).(($sort_mode==1) ? " DESC" : " ASC"), "Firm_Id=".$firm_id, ($page*$page_item_count).",".$page_item_count);
		}
		
		function Get($id)
		{
			return $this->GetRec("shop_goods", "Catalog_Id, Firm_Id, Identifier, Title, Price, Description, PreviewFilename, Hidden, Firm_Id, GoodsStatus, AddCatalog_Id", "Id=".$id);		
		}

		function DeletePreview($id)
		{
			$preview_filename = SHOP_FILE_PREVIEW_UPLOAD_DIR.$id."_".$this->GetRec("shop_goods", "PreviewFilename", "Id=".$id);
			if (file_exists($preview_filename))
			{
				unlink($preview_filename);
			}
			$sql = "UPDATE shop_goods SET PreviewFilename='' WHERE Id=".$id;
			$this->connection->exec($sql);
		}
		
		function AddUpdatePreview($previewfilename_name, $id)
		{
			$this->DeletePreview($id);
			$sql = "UPDATE shop_goods SET PreviewFilename='$previewfilename_name' WHERE Id=$id";
			if($this->connection->exec($sql))
			{
			 	rename(SHOP_FILE_PREVIEW_UPLOAD_DIR.SHOP_FILE_UPLOAD_TMP_PREFIX.$previewfilename_name, SHOP_FILE_PREVIEW_UPLOAD_DIR.$id."_".$previewfilename_name);
			}
		}		
		
		function AddImage($filename_name, $id, $title)
		{
			$sql = "INSERT INTO shop_images SET Filename='$filename_name', Title='$title', Goods_Id=$id";
			if($this->connection->exec($sql))
			{
			 	rename(SHOP_FILE_UPLOAD_DIR.SHOP_FILE_UPLOAD_TMP_PREFIX.$filename_name, SHOP_FILE_UPLOAD_DIR.$this->connection->getInsertedId()."_".$filename_name);
			}
		}
		
		function GetImages($id)
		{
			return $this->GetAllRecs("shop_images", "Title,Filename", "Id", "1", "Goods_Id=".$id);
		}
		
		function DeleteImage($id)
		{
			$filename = SHOP_FILE_UPLOAD_DIR.$id."_".$this->GetRec("shop_images", "Filename", "Id=".$id);
			if (file_exists($filename))
			{
				unlink($filename);
			}
			$sql = "DELETE FROM shop_images WHERE Id=".$id;
			$this->connection->exec($sql);
		}
		
		function Delete($id)
		{
			$this->DeletePreview($id);
			$sql = "DELETE FROM shop_goods WHERE Id=$id";
			$this->connection->exec($sql);
			$sql = "DELETE FROM shop_data WHERE Goods_Id=$id";
			$this->connection->exec($sql);
			$sql = "DELETE FROM shop_promo WHERE Goods_Id=$id";
			$this->connection->exec($sql);
			$images = $this->GetImages($id);
			foreach($images as $key => $value)
			{
				$this->DeleteImage($key);
			}
			return true;
		}
		
		function GetCount($catalog_id, $withhidden = true, $firm_id = null)
		{
			return $this->CountRecs("shop_goods", (($firm_id != null) ? "Firm_Id=".$firm_id." AND " : "")."Catalog_Id=".$catalog_id.(($withhidden) ? "" : " AND Hidden<>1"));
		}
		
		function GetCountByFirm($firm_id, $withhidden = true)
		{
			return $this->CountRecs("shop_goods", "Firm_Id=".$firm_id.(($withhidden) ? "" : " AND Hidden<>1"));
		}
		
		function GetCountByAddCatalog($addcatalog_id, $withhidden = true)
		{
			return $this->CountRecs("shop_goods", "AddCatalog_Id=".$addcatalog_id.(($withhidden) ? "" : " AND Hidden<>1"));
		}
		
		function GetLeaders($count = 1)
		{
			return $this->GetAllRecs("shop_goods_orders sgo, shop_goods sg", "COUNT(*) Top", "sg.Id", "Top DESC", "sg.Id=sgo.Goods_Id GROUP BY sg.Id", "0,".(int)$count);
		}
		
		function _Clone($id)
		{
			$goods = $this->Get($id);
			$new_id = $this->Add($goods['Catalog_Id'], $goods['Identifier']." ()", $goods['Title']." ()", $goods['Price'], $goods['Description'], $goods['Hidden'], (int)$goods['Firm_Id'], (int)$goods['GoodsStatus'], (int)$goods['AddCatalog_Id']);

			$data = $this->GetAllRecs("shop_data", "Field_Id, DataVarchar, DataFloat", null, 1, "Goods_Id=".$id);
			foreach($data as $value)
			{
				$sql = "INSERT INTO shop_data(Goods_Id, Field_Id, DataVarchar, DataFloat) VALUES(".$new_id.",".$value['Field_Id'].",'".$value['DataVarchar']."',".$value['DataFloat'].")";
				$this->connection->exec($sql);
			}
			return $new_id;
		}
		
	}
}
?>