<?php
if(!defined("__SHOP_USERS__"))
{
	define("__SHOP_USERS__", true);

	include_once(dirname(__FILE__)."/../../../../inc/classes/storage.php");
	include_once(dirname(__FILE__)."/orders.php");

	class Shop_Users extends Storage
	{
		public $connection = null;
		
		function Shop_Users(&$connection)
		{
			$this->Storage($connection, "shop_users", "Id");
		}

		function GetId() { return null; }
		function GetTitle() { return null; }

		function CheckLogin($login)
		{
			return $this->CountRecs($this->table, "Login='".$this->connection->EscapeString($login)."'");
		}
		function CheckEmail($email)
		{
			return $this->CountRecs($this->table, "Email='".$this->connection->EscapeString($email)."'");
		}

		function GetIdByEmail($email)
		{
			return $this->GetRec($this->table, "Id", "Email='".$this->connection->EscapeString($email)."'");
		}
		function GetIdByLogin($login)
		{
			return $this->GetRec($this->table, "Id", "Login='".$this->connection->EscapeString($login)."'");
		}
		
		function Add($fname, $lname, $login, $pass, $email, $phone, $address, $admcomments="")
		{
			if (!($this->CheckLogin($login) === "0") || !($this->CheckEmail($email) === "0"))
			{
				$ret = false;
			}
			else
			{
				$sql = "INSERT INTO shop_users SET"
						. " RegDate=NOW()"
						. ", FirstName='".$this->connection->EscapeString($fname)."'"
						. ", LastName='".$this->connection->EscapeString($lname)."'"
						. ", Login='".$this->connection->EscapeString($login)."'"
						. ", Pass='".$this->connection->EscapeString($pass)."'"
						. ", Email='".$this->connection->EscapeString($email)."'"
						. ", Phone='".$this->connection->EscapeString($phone)."'"
						. ", Address='".$this->connection->EscapeString($address)."'"
						. ", AdminComments='".$this->connection->EscapeString($admcomments)."'";
				if($this->connection->exec($sql))
					$ret = $this->connection->getInsertedId();
				else
				{
					echo $sql;
					$ret = false;
				}
			}
			return $ret;
		}

		function Delete($user_id)
		{
			$sql = "DELETE FROM shop_users WHERE Id=".$user_id;
			if ($this->connection->exec($sql))
			{
				$orders_id = $this->GetPairs("shop_orders", null, "Id", "1", "User_Id=".(int)$user_id);
				$orders = new Shop_Orders($this->connection);
				foreach ($orders_id as $oid)
				{
					$orders->Delete($oid);
				}
				return true;
			}
			else
			{
				return false;
			}
		}

		function Update($user_id, $fname, $lname, $login, $pass, $email, $phone, $address, $admcomments="")
		{
			$sql = "UPDATE shop_users SET"
					. " FirstName='".$this->connection->EscapeString($fname)."'"
					. ", LastName='".$this->connection->EscapeString($lname)."'"
					. ", Login='".$this->connection->EscapeString($login)."'"
					. ", Pass='".$this->connection->EscapeString($pass)."'"
					. ", Email='".$this->connection->EscapeString($email)."'"
					. ", Phone='".$this->connection->EscapeString($phone)."'"
					. ", Address='".$this->connection->EscapeString($address)."'"
					. ", AdminComments='".$this->connection->EscapeString($admcomments)."'"
					. " WHERE Id=".(int)$user_id;
			return $this->connection->exec($sql);
		}

		function GetList($page, $page_item_count, $sort_field=1, $sort_mode=1)
		{
            define("MAX", 4);
			$sort_field = ($sort_field>MAX || $sort_field<1) ? 1 : (int)$sort_field;
			return $this->GetAllRecs(
					"shop_users", "*", "Id", 
                    ($sort_field+1)." ".(($sort_mode < 2)?"DESC":"ASC"),
					"1", 
					($page*$page_item_count).",".$page_item_count
					);
		}

		function Get($user_id, $fields="*")
		{
			return $this->GetRec("shop_users", $fields, "Id=".$user_id);
		}

		function GetFiltered($filter, $page, $page_item_count, $sort_field=1, $sort_mode=1)
		{
			
            define("MAX", 4);
			$sort_field = ($sort_field>MAX || $sort_field<1) ? 1 : (int)$sort_field;
			return $this->GetAllRecs(
					"shop_users", "*", "Id", 
                    ($sort_field+1)." ".(($sort_mode < 2)?"DESC":"ASC"),
					"1", 
					($page*$page_item_count).",".$page_item_count
					);
		}

		function CountAll()
		{
			return $this->CountRecs("shop_users");
		}

		function CountOrders($id)
		{
			$orders = new Shop_Orders($this->connection);
			return $orders->Count("", $id);
		}
		
		function Login($login, $pass)
		{
			if ($user_id = $this->GetRec($this->table, $this->index, "Login='".$this->connection->EscapeString($login)."' AND Pass='".$this->connection->EscapeString($pass)."'"))
				return $this->Get($user_id, "Id,FirstName,LastName,Login,Pass,Email,Phone,Address,Subscription");
			else
				return false;
		}
	}
}
?>