<?php
if(!defined('__STATS_REPORTS__'))
{
	define('__STATS_REPORTS__', true);

	include_once(dirname(__FILE__).'/../../../../inc/classes/storage.php');

	/**
	 * Class Stats_Reports()
	 *    .
	 * @author maxim.yefimochkin@v6.ru
	 */
	class Stats_Reports extends Storage
	{
		function Stats_Reports(&$connection)
		{
			$this->Storage($connection);
		}

		/**
		 * Stats_Reports::CountHosts()
		 *     ,   .
		 * 
		 * @return		int		     
		 */
		function CountHosts()
		{
			return $this->CountRecs('stats_visiters');
		}
		
		/**
		 * Stats_Reports::CountDays()
		 *           .
		 * 
		 * @return		int		     
		 */
		function CountDays($start='0000-00-00', $end='0000-00-00')
		{
			if ($start=='0000-00-00')
			{
				$start = $this->GetMinVisitDate();
				if ($start=='0000-00-00 00:00:00') return 0;
			}
			if ($end=='0000-00-00') $end = date("Y-m-d");
			$timestamp_start = strtotime($start);
			$timestamp_end = strtotime($end);
			if( $timestamp_start >= $timestamp_end ) return 0;
			$start_year = date("Y",$timestamp_start);
			$end_year = date("Y", $timestamp_end);
			$num_days_start = date("z", $timestamp_start);
			$num_days_end = date("z", $timestamp_end);
			$num_days = 0;
			$i = 0;
			if($end_year > $start_year)
			{
				while($i < ($end_year - $start_year))
				{
					$num_days = $num_days + date("z", strtotime(($start_year + $i).'-12-31'));
					$i++;
				}
			}
			return ($num_days_end + $num_days) - $num_days_start;
		}
		
		/**
		 * Stats_Reports::GetMinVisitDate()
		 *    . '0000-00-00 00:00:00'    .
		 */
		function GetMinVisitDate()
		{
			if (!$ret = $this->GetRec('stats_visits', 'MIN(Visit_DT)', SQL_WHERE_CLAUSE_NEUTRAL))
			{
				return '0000-00-00 00:00:00';
			}
			return $ret;
		}
		
		function CountVisitersByDate($date)
		{
			return count($this->GetPairs('stats_visits', null, 'DISTINCT Visiter_Id', '1', 'Visit_Date = \''.$date.'\''));
		}
		
		function CountVisitsByDate($date)
		{
			return $this->CountRecs('stats_visits', 'Visit_Date = \''.$date.'\'');
		}
		
		/**
		 * Stats_Reports::GetRubVisiters()
		 *    .
		 *
		 * @param		$rub_id		int	ID 
		 * @param		$sort		int -n/n,    
		 *
		 * @return		array
		 */
		function GetRubVisiters($rub_id, $sort = -1)
		{
			$sort = abs($sort) < 1 || abs($sort) > 4 ? -1 : $sort;
			return $this->GetAllRecs('stats_visits v, stats_visiters vr', 'MAX(v.Visit_DT) Last_Visit_DT, vr.Host_IP, vr.Host_Alpha, COUNT(v.Visiter_Id) Visits', null, abs($sort).($sort<0?' DESC':' ASC'), 'v.Rub_Id='.(int)$rub_id.' AND v.Visiter_Id=vr.Visiter_Id GROUP BY v.Visiter_Id');
		}
		
		/**
		 * Stats_Reports::GetRubVisits()
		 *    .
		 *
		 * @param		$rub_id				int	ID 
		 * @param		$page				int  
		 * @param		$page_item_count	int -  
		 * @param		$sort				int -n/n,    
		 *
		 * @return		array
		 */
		function GetRubVisits($rub_id, $page = 0, $page_item_count = -1, $sort = -1)
		{
			$sort = abs($sort) < 1 || abs($sort) > 4 ? -1 : $sort;
			return $this->GetAllRecs('stats_visits v, stats_visiters vr',
									 'v.Visit_DT, vr.Host_IP, vr.Host_Alpha, v.HTTP_REFERER', null,
									 abs($sort).($sort<0?' DESC':' ASC'),
									 'v.Rub_Id='.(int)$rub_id.' AND v.Visiter_Id=vr.Visiter_Id',
									 ($page*$page_item_count).','.$page_item_count);
		}
		
		function CountRubVisits($rub_id)
		{
			return $this->CountRecs('stats_visits v, stats_visiters vr', 'v.Rub_Id='.(int)$rub_id.' AND v.Visiter_Id=vr.Visiter_Id');
		}
	}
}
?>