<?php
if(!defined('__STATS_USER__'))
{
	define('__STATS_USER__', true);

	include_once(dirname(__FILE__).'/../../../../inc/classes/storage.php');

	define('STATS_OPTS_GROUP_USESTATS', 1);
	/**
	 * Class Stats_User()
	 *       -.
	 * @author maxim.yefimochkin@v6.ru
	 */
	class Stats_User extends Storage
	{
		public $rub_group_id;
		public $options;
		public $options_default;
		
		function Stats_User(&$connection, $rub_group_id = null)
		{
			$this->options_default = 0;
			$this->Storage($connection);
			$this->SetRubGroup($rub_group_id);
			$this->GetOptions();
		}

		function AddVisit(&$rub_or_page)
		{
			if ($this->rub_group_id == null) return $this->AddPageVisit($rub_or_page);
			else return $this->AddRubVisit($rub_or_page);
		}
		
		function AddRubVisit(&$rub)
		{
			if (($this->options[$this->rub_group_id]['use_stats'] & STATS_OPTS_GROUP_USESTATS) != STATS_OPTS_GROUP_USESTATS) return false;
			if ($this->rub_group_id != $rub->GetParam('group_id')) return false;
			/*  */
			$sql = 'UPDATE stats_rubs SET Hits=Hits+1 WHERE Rub_Id='.$rub->GetId();
			$ret_rub = $this->connection->getAffected($sql);
			if ($ret_rub==false) //   
			{
				$ret_rub = $this->AddRub($rub, 1); //  1 hit
			}
			/* Host */
			$host_id = $this->GetRec('stats_visiters', 'Visiter_Id', 'Host_IP=\''.$_SERVER['REMOTE_ADDR'].'\'');
			if ($host_id) //    ?
			{
				$sql = 'UPDATE stats_visiters SET Visits=Visits+1 WHERE Visiter_Id='.$host_id;
				$ret_host = $this->connection->getAffected($sql);
			}
			else // ...  
			{
				$host_name = isset($_SERVER['REMOTE_HOST']) ? $_SERVER['REMOTE_HOST'] : $this->GetHostnameByIP($_SERVER['REMOTE_ADDR']);
				$host_id = $ret_host = $this->AddHost($_SERVER['REMOTE_ADDR'], $host_name, 1);
			}
			/* Visit */
			$ret = false;
			if ($ret_rub && $ret_host)
			{
				$http_referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
				$sql = 'INSERT INTO stats_visits (Visiter_Id, Rub_Id, Visit_DT, Visit_Date, Visit_Time, HTTP_REFERER)';
				$sql .= ' VALUES('.$host_id.','.$rub->GetId().','.SQL_FUNCTION_CURRENTDATE.','.SQL_FUNCTION_CURRENTDATE.','.SQL_FUNCTION_CURRENTDATE.',\''.$this->connection->EscapeString($http_referer).'\')';
				$ret = $this->connection->exec($sql);
			}
			return $ret & $ret_rub & $ret_host;
		}
		
		function AddRub(&$rub, $hits)
		{
			$sql = 'INSERT INTO stats_rubs (Rub_Id, Title, Hits)';
			$sql .= ' VALUES('.$rub->GetId().',\''.$rub->GetTitle().'\','.$hits.')';
			return $this->connection->exec($sql);
		}
		
		function AddHost($ip, $name, $visits)
		{
			$sql = 'INSERT INTO stats_visiters (Host_IP, Host_Alpha, Visits)';
			$sql .= ' VALUES(\''.$ip.'\',\''.$name.'\','.$visits.')';
			if ($this->connection->exec($sql))
				return $this->connection->getInsertedId();
			else
				return false;
		}
		
		function AddPageVisit($page)
		{
		}
		
		/**
		 * Stats_User::ChangeRubGroup()
		 *     ,     .
		 *
		 * @param $rub_group_id		int		ID 
		 */
		function ChangeRubGroup($rub_group_id)
		{
			$this->SetRubGroup($rub_group_id);
			$this->GetOptions();
		}
		
		function SetRubGroup($rub_group_id)
		{
			$this->rub_group_id = (int)$rub_group_id;
		}
		
		function GetOptions()
		{
			if ($this->rub_group_id == null) return $this->GetPageOptions();
			else return $this->GetGroupOptions();
		}
		
		function GetPageOptions()
		{
			if (isset($this->options['use_stats'])) return $this->options['use_stats'];
			else return $this->options['use_stats'] = STATS_OPTS_GROUP_USESTATS;
		}
		
		function GetGroupOptions()
		{
			if ($this->rub_group_id == null) return false;
			if (!isset($this->options[$this->rub_group_id]))
			{
				if ($options = $this->GetRec('stats_rub_groups', 'Options', 'Group_Id='.$this->rub_group_id))
				{
					$this->options[$this->rub_group_id]['use_stats'] = $options & STATS_OPTS_GROUP_USESTATS;
				}
				else
				{
					$this->options[$this->rub_group_id]['use_stats'] = $this->options_default & STATS_OPTS_GROUP_USESTATS;
				}
			}
			return $this->options[$this->rub_group_id];
		}
		
		function GetHostnameByIP($ip)
		{
			$hostname = gethostbyaddr($ip);
			return $hostname==$ip ? '' : $hostname;
		}
	}
}
?>