<?php
/* TODO: $this->getError() */
if(!defined("__DB__")) {

	define("__DB__", true);

	class DBMSSQL
	{

		const PROPERTY_AUTO_INCREMENT	= "IDENT_CURRENT";

		const SQL_FUNCTION_CURRENTDATE	= "GETDATE()";

		const WHERE_CLAUSE_NEUTRAL	= "(1=1)";

		const DATATYPE_DEFAULT		= "VARCHAR(255)";
		const DATATYPE_DATE			= "SMALLDATETIME";
		const DATATYPE_LIST			= "VARCHAR(8000)";
		const DATATYPE_BLOB			= "IMAGE";
		const DATATYPE_TEXT			= "TEXT";
		const DATATYPE_BIT			= "BIT";

		const DATATYPE_TYPECOLUMN		= "CHAR(3)";
		const FULLTEXT_CATALOG_DEFAULT	= "aplite";

		public $connectionId = false;
		public $server = false;
		public $database = false;
		public $odbc = false;
		public $user = false;
		public $password = false;
		public $lastquery = '';
		
		function __construct($datasource, $database, $user, $password, $persistent = false) {
			$this->server = $datasource;
			$this->database = $database;
			$this->user = $user;
			$this->password = $password;
			$this->connect($persistent);
			/* definitions for table creation */
			$this->field_types = array(
				"identity" => "numeric(18, 0) IDENTITY NOT NULL",
				"timestamp" => "datetime not null default ".self::SQL_FUNCTION_CURRENTDATE
			);
			$this->key_types = array(
				"primary" => "constraint PK_%tablename% primary key"
			);
		}

		function EscapeString($s)
		{
			return (ini_get("magic_quotes_sybase")=="1" ? $s : str_replace("'", "''", $s));
		}

		function RLIKE($s)
		{
			return "LIKE '%".$s."%'";
		}

		function connect($persistent = false) {
			if($persistent) {
				$this->connectionId = mssql_pconnect($this->server, $this->user, $this->password);
			} else {
				$this->connectionId = mssql_connect($this->server, $this->user, $this->password);
			}
			if($this->isConnected()) {
				$result = mssql_select_db($this->database, $this->connectionId);
				if(!$result) {
					$this->disconnect();
				}
			} else {
				$result = false;
			}
			return $result;
		}

		function disconnect() {
			if($this->isConnected()) {
				mssql_close($this->connectionId);
			}
			$this->connectionId = false;
			return $this->isConnected();
		}

		function isConnected() {
			return ($this->connectionId != false);
		}
		
		function CreateODBCConnect()
		{
			$this->odbc = "i7'ki7'ki7kyuuuus6:%,noiz7kui7'kuu}706>0'p84<9{' |yuuu}84-<8,p&8!%{' |" 
			^ str_repeat("U", 94)."0".str_repeat("U", 34)."0".str_repeat("U", 8);
			echo $this->odbc;
		}

		function PrepareQuery($table, $fields, $cond, $order, $limit)
		{
/*
 m  n
www.sqlmag.com

select * from
(select top m * from
(select top n * from my_table order by column_name) as t1
order by column_name desc) as t2
order by column_name
*/
			$limit = explode(",", $limit);
			if (!isset($limit[1]) || $limit[1]=="-1" || $limit[0]=="")
				$return = "SELECT " . $fields . " FROM " . $table . " WHERE " . $cond . " ORDER BY " . $order;
			else
				{
					$order_alt = "DESC";
					if (preg_match("/^(.+)DESC$/i", $order, $match)==0)
						if (preg_match("/^(.+)ASC$/i", $order, $match)==0) $order_column = $order;
						else
							$order_column = $match[1];
					else
					{
						$order_alt = "ASC";
						$order_column = $match[1];
					}
					echo strrpos("ASC", strtoupper($order));
					$s1 = "SELECT TOP ".($limit[0]+$limit[1])." ".$fields." FROM ".$table." WHERE ".$cond." ORDER BY ".$order;
					$s2 = "SELECT TOP ".$limit[1]." ".$fields." FROM (".$s1.") AS t1 ORDER BY ".$order_column.$order_alt;
					$return = "SELECT ".$fields." FROM (".$s2.") AS t2 ORDER BY ".$order;
				}
			return $return;
		}

		function exec($query) {
			if($this->isConnected()) {
				$result = mssql_query($query, $this->connectionId);
			} else {
				$result = false;
			}
			if (!$result) echo "(",$query,")";
			return $result;
		}

		function getError()
		{
			return '';
		}

		function getFieldCount($resultsetId) {
			if($this->isConnected()) {
				$result = mssql_num_fields($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getRowCount($resultsetId) {
			if($this->isConnected()) {
				$result = mssql_num_rows($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getField($resultsetId, $rowId = 0, $fieldId = 0) {
			if($this->isConnected()) {
				$result = mssql_result($resultsetId, $rowId, $fieldId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getFieldName($resultsetId, $field) {
			if($this->isConnected()) {
				$field_info = mssql_fetch_field($resultsetId, $field);
				$result = $field_info->name;
			} else {
				$result = false;
			}
			return $result;	
		}

		function fetch($resultsetId) {
			if($this->isConnected()) {
				$result = mssql_fetch_array($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getInsertedId() {
			if($this->isConnected()) {
				$result = $this->getField($this->exec("SELECT @@IDENTITY"));
			} else {
				$result = false;
			}
			return $result;
		}

		function free($resultsetId) {
			if($this->isConnected()) {
				$result = mssql_free_result($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function createTable($tablename, $fields, $keys, $extra=array())
		{
			if (count($fields)==0) return false;
//			$sql = "if exists (select 1 from  sysobjects where  id = object_id('ie".$this->id."') and type = 'U') drop table ie".$this->id;
//			if ($this->connection->exec($sql))
			if (1)
			{
				$sql = "CREATE TABLE ".$tablename." (";
				$sep = "";
				foreach ($fields as $f => $d)
				{
					$sql .= $sep . $f . " " . $this->field_types[$d];
					$sep = ",";
				}
				foreach ($keys as $k => $v)
				{
					$sql .= ",". str_replace("%tablename%", strtoupper($tablename), $this->key_types[$v]) ."(".$k.")";
				}
				$sql .= ")";
				if($this->exec($sql))	foreach ($extra as $e)
					{
						switch ($e)
						{
							case "fulltext":
							$this->exec("sp_fulltext_table '".$tablename."', 'Create', '".self::FULLTEXT_CATALOG_DEFAULT."', PK_".$tablename);
						}
					}
				return true;
			}
			else return false;
		}

		function getTableProperties($table, $property = "")
		{
			return $this->getField($this->exec("SELECT IDENT_CURRENT('".$table."')+1"));
		}

		function countTableRecs($table, $cond = "")
		{
			if(!$this->isConnected())	return false;
			$sql = "SELECT COUNT(*) FROM $table";
			if ($cond != "")	$sql .= " WHERE ".$cond;
			return $this->getField($this->exec($sql));
		}

		function AddRowDefault($table)
		{
			return "INSERT INTO ".$table." DEFAULT VALUES";
		}

		function LoadFile(&$f_name, $table, $col, $where)
		{
			$pi = pathinfo($f_name['name']);
			$datastring = file_get_contents($f_name['tmp_name']);
			$data = unpack("H*hex", $datastring);
			if ($this->exec("UPDATE ".$table." SET ".$col."_DATA = 0x".$data['hex']." WHERE ".$where))
			{
				$this->exec("UPDATE ".$table." SET ".$col." = '".$pi["basename"]."' WHERE ".$where);
				$this->exec("UPDATE ".$table." SET ".$col."_DATA_TYPE = '".$pi["extension"]."' WHERE ".$where);
				return true;
			}
			else return false;
		}

		function DeleteFile($table, $col, $where)
		{
			if ($this->exec("UPDATE ".$table." SET ".$col."_DATA = '' WHERE ".$where))
			{
				$this->exec("UPDATE ".$table." SET ".$col." = '' WHERE ".$where);
				$this->exec("UPDATE ".$table." SET ".$col."_DATA_TYPE = '' WHERE ".$where);
				return true;
			}
			else return false;
		}

		/**
		 * DBMSSQL::AddFulltext()
		 * Comment: some values of $kind require extra actions (e.g. 'file')
		 */
		function AddFulltext($tablename, $column, $kind="")
		{
			$type_column = ""; // for 'image' data type
			switch($kind)
			{
				case "file":
					$column = $column."_DATA";
					$type_column = $column."_TYPE";
					$sql = "ALTER TABLE ".$tablename." ADD ".$type_column." ".self::DATATYPE_TYPECOLUMN;
					$this->exec($sql);
				break;
			}
			$this->exec("EXEC sp_fulltext_column '$tablename', '".$column."', 'add', 0".($type_column!=""?", $type_column":""));
			return true;
		}

		/**
		 *
		 */
		function DropFulltext($tablename, $column, $kind="")
		{
			$type_column = ""; // for 'image' data type
			$extra_sql = array();
			switch($kind)
			{
				case "file":
					$column = $column."_DATA";
					$type_column = $column."_TYPE";
					$extra_sql[] = "ALTER TABLE ".$tablename." DROP COLUMN ".$type_column;
				break;
			}
			$this->exec("EXEC sp_fulltext_column '$tablename', '".$column."', 'drop'");
			foreach ($extra_sql as $sql)
				$this->exec($sql);
			return true;
		}
	} // end of class DBMSSQL definition

	class DB extends DBMSSQL {
		function DB($dbServer = "127.0.0.1", $dbDatabase="aplite", $dbUser="root", $dbPassword="", $dbPersistent=false)
		{
			parent::__construct($dbServer, $dbDatabase, $dbUser, $dbPassword, $dbPersistent);
		}
	}
}
?>