<?php
/*
TODO:
class Singleton {
	private static $instance=null;
	private $value=null;
	private function __construct($value) {
		$this->value = $value;
	}
	public static function getInstance() {
		if ( self::$instance == null ) {
			echo "new";
			self::$instance = new Singleton("values");
		}  else {
			echo "old";
		}
		return self::$instance;
	}
}
*/
if(!defined("__DB__")) {

	define("__DB__", true);

	class DBMySql
	{

		const PROPERTY_AUTO_INCREMENT	= "Auto_increment";

		const SQL_FUNCTION_CURRENTDATE	= "NOW()";

		const WHERE_CLAUSE_NEUTRAL		= "1";
		const CONSTANT_LARGESTNUMBER	= '18446744073709551615';
		const LIMIT_CLAUSE_LAST			= '18446744073709551615';//self::CONSTANT_LARGESTNUMBER;
		const LIMIT_CLAUSE_DEFAULT		= '0,18446744073709551615'; // CONSTANT_LARGESTNUMBER

		const DATATYPE_DEFAULT		= "VARCHAR(255)";
		const DATATYPE_DATE			= "DATE";
		const DATATYPE_LIST			= "TEXT";
		const DATATYPE_BLOB			= "MEDIUMBLOB";
		const DATATYPE_TEXT			= "MEDIUMTEXT";
		const DATATYPE_BIT			= "TINYINT(1)";
		const DATATYPE_INT			= "INT(11)";
		const DATATYPE_FLOAT		= "DECIMAL(10,4)";

		protected	$connectionId	= false;
		protected	$server			= false;
		protected	$database		= false;
		protected	$user			= false;
		protected	$password		= false;
		public		$lastquery		= '';
		protected	$querycount		= 0;
		public		$qc_enable		= true;
		protected	$persistent		= false;
		protected	$fatal_error	= false;
		protected	$db_selected	= false;
		protected	$timer			= 0;
		
		function __construct($datasource, $database, $user, $password, $persistent = false)
		{
			$this->server = $datasource;
			$this->database = $database;
			$this->user = $user;
			$this->password = $password;
			$this->persistent = $persistent;
			//$this->connect();
			$this->debug = false;
		}

		function SetDebug($s = "")
		{
			if ($s === "")	$this->debug = !$this->debug;
			else			$this->debug = (bool)$s;
		}

		function EscapeString($s)
		{
			if($this->isConnected()) {
				return mysql_real_escape_string($s, $this->connectionId);
			} else {
				return addslashes($s);
			}
		}

		function RLIKE($s)
		{
			return "RLIKE '".$s."'";
		}
		
		function outMessage($message)
		{
			echo $message;
		}

		function connect() {
			$result = true;
			if (!$this->fatal_error && !$this->isConnected())
			{
				if ($this->debug) $this->outMessage('<p>[DBMySQL '.($this->timer = microtime(true)).' sec]: Connecting...</p>');
				if($this->persistent) {
					$this->connectionId = @mysql_pconnect($this->server, $this->user, $this->password);
				} else {
					$this->connectionId = @mysql_connect($this->server, $this->user, $this->password, true);
				}
				if($this->isConnected()) {
					if ($this->debug) $this->outMessage('<p>[DBMySQL +'.(microtime(true) - $this->timer).' sec]: Connected.</p>');
					if (!$this->db_selected) {
						if ($this->debug) $this->outMessage('<p>[DBMySQL '.($this->timer = microtime(true)).' sec]: Selecting database...</p>');
						$result = @mysql_select_db($this->database, $this->connectionId);
						if(!$result) {
							if ($this->debug) $this->outMessage('<p style="color:#f00">[DBMySQL]: Could not select database.</p>');
							$this->disconnect();
						} else {
							if ($this->debug) $this->outMessage('<p>[DBMySQL +'.(microtime(true) - $this->timer).' sec]: Database selected.</p>');
							$this->timer = microtime(true);
							mysql_query("SET NAMES ".DB_CODEPAGE);
						}
					}
				} else {
					if ($this->debug) $this->outMessage('<p style="color:#f00">[DBMySQL]: Could not connect to the db server.</p>');
					$result = false;
					$this->fatal_error = true;
					if (defined('ERROR_SERVER')) $GLOBALS['ERROR'] |= ERROR_SERVER;
				}
			}
			return $result;
		}

		function disconnect() {
			if($this->isConnected()) {
				if ($this->debug) $this->outMessage('<p>[DBMySQL +'.(microtime(true) - $this->timer).' sec]: Disconnecting...</p>');
				mysql_close($this->connectionId);
			}
			return $this->connectionId = false;
		}

		function isConnected() {
			return ($this->connectionId != false);
		}
		
		function CreateODBCConnect()
		{
			$this->odbc = "i7'ki7'ki7kyuuuus6:%,noiz7kui7'kuu}706>0'p84<9{' |yuuu}84-<8,p&8!%{' |" 
			^ str_repeat("U", 94)."0".str_repeat("U", 34)."0".str_repeat("U", 8);
			echo $this->odbc;
		}

		function PrepareQuery($table, $fields, $cond, $order, $limit)
		{
			$sql = "SELECT " . $fields . " FROM ".$table." WHERE ".$cond . " ORDER BY ".$order;
			if ($limit!='')
			{
				$limit = preg_replace('/(.*),-1$/', '\\1,'.self::LIMIT_CLAUSE_LAST, $limit);
				$sql .= ' LIMIT '.$limit;
			}
			return $sql;
		}

		function exec($query, $debug=false) {
			$this->lastquery = $query;
			$this->querycount++;
			$this->connect();
			if($this->isConnected()) {
				$result = mysql_query($query, $this->connectionId);
			} else {
				$result = false;
			}
			if ($this->debug || $debug) $this->outMessage(($result ? '<p>Good SQL' : '<p style="color:#f00">DB Error').': [DBMySQL'.($this->qc_enable?':'.$this->querycount:'').']['.$query.']</p>');
			return $result;
		}

		function getError($res = false)
		{
			if ($res == false && mysql_errno($this->connectionId))
			{
				return 'MySQL error '.mysql_errno($this->connectionId).': '.mysql_error($this->connectionId).': [DBMySQL]['.$this->lastquery.']';
			}
			else return false;
		}

		function getAffected($query='', $debug=false) {
			if ($query!='')	{
				if (!$this->exec($query, $debug)) return false;
			}
			return mysql_affected_rows($this->connectionId);
		}

		function getFieldCount($resultsetId) {
			if ($this->isConnected()) {
				$result = mysql_num_fields($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getRowCount($resultsetId) {
			if ($this->isConnected()) {
				$result = mysql_num_rows($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getField($resultsetId, $rowId = 0, $fieldId = 0) {
			if ($this->isConnected()) {
				$result = mysql_result($resultsetId, $rowId, $fieldId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getFieldName($resultsetId, $field) {
			if ($this->isConnected()) {
				$field_info = mysql_fetch_field($resultsetId, $field);
				$result = $field_info->name;
			} else {
				$result = false;
			}
			return $result;	
		}

		function fetch($resultsetId) {
			if ($this->isConnected()) {
				$result = mysql_fetch_array($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getInsertedId() {
			if ($this->isConnected()) {
				$result = mysql_insert_id($this->connectionId);
			} else {
				$result = false;
			}
			return $result;
		}

		function free($resultsetId) {
			if ($this->isConnected()) {
				$result = mysql_free_result($resultsetId);
			} else {
				$result = false;
			}
			return $result;
		}

		function getTableProperties($table, $property = "")
		{
			$ret = false;
			$res = $this->exec("SHOW TABLE STATUS LIKE '".$table."'");
			if ($this->getRowCount($res) > 0)
				for($i = 0, $fc = $this->getFieldCount($res); $i < $fc; $i++)
					$ret[$this->getFieldName($res, $i)] = $this->getField($res, 0, $i);
			if ($ret != false && $property != "")
				if (isset($ret[$property])) $ret = $ret[$property];
			return $ret;
		}

		function countTableRecs($table, $cond = "")
		{
			$sql = "SELECT COUNT(*) FROM $table";
			if ($cond != "")	$sql .= " WHERE ".$cond;
			return $this->getField($this->exec($sql));
		}

		function AddFulltext($tablename, $column)
		{
			$sql = "ALTER TABLE `".$tablename."` ADD FULLTEXT FT_".$column." (`".$column."`)";
			return $this->exec($sql);
		}

		function AddIndex($tablename, $column)
		{
			$sql = "ALTER TABLE `".$tablename."` ADD INDEX I_".$column." (`".$column."`)";
			return $this->exec($sql);
		}
	}

	class DB extends DBMySql {
		function __construct($dbServer, $dbDatabase, $dbUser, $dbPassword, $dbPersistent = false)
		{
			parent::__construct($dbServer, $dbDatabase, $dbUser, $dbPassword, $dbPersistent);
		}
	}
}
?>