<?php
if (!defined('__MAIL__'))
{
	define('__MAIL__', true);
	if (!defined('MAIL_SMTP_HOST')) define('MAIL_SMTP_HOST', 'localhost');
	if (!defined('MAIL_FROM')) define('MAIL_FROM', 'yourmail@domain.ru');
	Class Mail
	{
		public $debug;
		public $debugmethod;
		public $log;
		public $LE;
		public $SMTP;
		public $Headers;
		public $Text;
		public $Body;
		public $countSend;
		public $countFail;
		
		function Mail()
		{
			$this->debug			= true;
			$this->debugmethod		= LOG_USER; // = (LOG_USER|LOG_SYSLOG)
			$this->log				= array();
			$this->LE				= "\r\n";
	        $this->SMTP['Host']		= MAIL_SMTP_HOST;
			$this->SMTP['Port']		= 25;
			$this->SMTP['Timeout']	= 25;
			$this->SMTP['Helo']		= (!isset($_SERVER['SERVER_NAME']) || $_SERVER['SERVER_NAME']=='') ? 'localhost' : $_SERVER['SERVER_NAME'];
			$this->SMTP['MailFrom']	= MAIL_FROM;
			$this->Headers['MIME-Version']	= '1.0';
			$this->Headers['Content-Type']	= 'text/plain;
	charset="koi8-r"';
			$this->Headers['Content-Transfer-Encoding']	= '8bit';
			$this->Headers['From']			= '"Maillist" <'.MAIL_FROM.'>';
			$this->Headers['To']			= '"Maillist" <'.MAIL_FROM.'>';
			$this->Headers['Subject']		= '';
			$this->Text = '';
			$this->Body = '';
			$this->countSend=0;
			$this->countFail=0;
		}
		
		/*
		 * m_type = (LOG_CRIT|LOG_ERR|LOG_USER|LOG_DEBUG)
		 */
		function error($m_type, $str)
		{
			if ($this->debug)
				switch ($this->debugmethod)
				{
					case LOG_USER:
						$this->log[] = array('date'=>date("Y.m.d H:i:s"),'level'=>$m_type,'msg'=>$str);
					break;
					case LOG_SYSLOG:
					default:
						error_log("[$m_type] $str");
					break;
				}
		}
		
		function checkResponse($fp, $code, $cmd='')
		{
			$ret = true;
			if ($cmd!='') {
				fwrite($fp, $cmd."\r\n");
				$this->error(LOG_DEBUG, $cmd);
			}
			$line = fgets($fp, 1024);
			$this->error(LOG_DEBUG, trim($line));
			if (preg_match("/^([\d]+)(.*)$/",$line,$match)) {
				if ($match[1] == $code) {
					$ret = false;
				}
				else {
					$ret = array($match[1], $match[2]);
				}
			}
			return $ret;
		}
		
		function PrepareBody()
		{
			$this->Body = '';
			foreach ($this->Headers as $header => $predefined)
			{
				$this->Body .= $header.': '.$predefined."\r\n";
			}
			$this->Body .= "\r\n".$this->Text;
		}
		
		function SMTP($to)
		{
			if (!is_array($to)) {
				$to = explode(',',$to);
			}
			$fp = fsockopen($this->SMTP['Host'], $this->SMTP['Port'], $errno, $errstr, $this->SMTP['Timeout']);
			if (!$fp) {
				$this->error(LOG_CRIT, '    : '.$errstr);
				return false;
			}
			if ($ret = $this->checkResponse($fp, '220', '')) {
				$this->error(LOG_CRIT, '    : '.$ret[1].' ('.$ret[0].')');
				fclose($fp);
				return false;
			}
			if ($ret = $this->checkResponse($fp, '250', 'HELO '.$this->SMTP['Helo'])) {
				$this->error(LOG_CRIT, '    : '.$ret[1].' ('.$ret[0].')');
				fclose($fp);
				return false;
			}
			$error = false;
			if ($ret = $this->checkResponse($fp, '250', 'MAIL FROM: <'.$this->SMTP['MailFrom'].'>')) {
				$error = true;
				$this->error(LOG_CRIT, ': '.$ret[1].' ('.$ret[0].') ');
			}
			else
			{
				foreach ($to as $email_to)
				{
					if ($ret = $this->checkResponse($fp, '250', 'RCPT TO: <'.$email_to.'>'))
					{
						$this->countFail++;
						$this->error(LOG_ERR, '      <'.$email_to.'>: '.$ret[1].' ('.$ret[0].')');
					}
					else
					{
						$this->countSend++;
					}
				}
				if ($ret = $this->checkResponse($fp, '354', 'DATA')) {
					$error = true;
					$this->error(LOG_CRIT, ': '.$ret[1].' ('.$ret[0].') ');
				}
				else
				{
					$this->error(LOG_DEBUG, '<>');
					if (!fwrite($fp, $this->Body)) {
						$error = true;
						$this->error(LOG_CRIT, ': '.$ret[1].' ('.$ret[0].') ');
					}
					else
					{
						if ($ret = $this->checkResponse($fp, '250', "\r\n.")) {
							$error = true;
							$this->error(LOG_CRIT, ': '.$ret[1].' ('.$ret[0].') ');
						}
					}
				}
			}
			if ($error)
			{
				$this->error(LOG_CRIT, '  !');
				fclose($fp);
				return false;
			}
			else
			{
				if ($ret = $this->checkResponse($fp, '221', 'QUIT'))
				{
					$this->error(LOG_CRIT, '    : '.$ret[1].' ('.$ret[0].')');
				}
				fclose($fp);
				$this->error(LOG_USER, ' :');
				$this->error(LOG_USER, '   '.$this->countSend.' ');
				if ($this->countFail != 0)
				{
					$this->error(LOG_USER, '    '.$this->countFail.' ');
				}
				return $this->countSend;
			}
		}
		
		function Send($emails, $subject='', $data='', $to='', $from='', $ctype='')
		{
			if ($subject!='') $this->Headers['Subject'] = convert_cyr_string($subject, 'w', 'k');
			if ($data!='') $this->Text = convert_cyr_string($data, 'w', 'k');
			if ($from!='') $this->Headers['From'] = $from;
			if ($to!='') $this->Headers['To'] = $to;
			if ($ctype!='') $this->Headers['Content-Type'] = $ctype;
			if ($this->Body=='') $this->PrepareBody();
			return $this->SMTP($emails);
		}
	}
}
?>