<?php
if (!defined('__MAIL_MIME__'))
{
	define('__MAIL_MIME__', true);

	define('MAIL_MIME_BASE64LINE', 55);

	class Mail_mime
	{
		public $parts;
		public $to;
		public $from;
		public $headers;
		public $subject;
		public $body;
		
		function Mail_mime() {
			$this->parts = array();
			$this->to = '';
			$this->from = '';
			$this->headers = '';
			$this->subject = '';
			$this->body = '';
		}

		function AddAttachment($message, $name='', $ctype='application/octet-stream', $encode='base64')
		{
			$this->parts[] = array(
						'type' => $ctype,
						'message' => $message,
						'encode' => $encode,
						'name' => $name
						);
		}

		function Base64($str, $line=0)
		{
			$ret = '';
			$str = convert_cyr_string($str, 'w', 'k');
			if ($line==0)
			{
				$ret = '=?koi8-r?B?'.base64_encode($str).'?=';
			}
			else
			{
				for ($i=0, $c=strlen($str); $i<$c; $i+=$line)
				{
					if ($i>0) $ret .= "==?=\r\n\t";
					$ret .= '=?koi8-r?B?'.base64_encode(substr($str, $i, $line));
				}
				if ($c>$line)	$ret .= '?=';
				else			$ret .= '==?=';
			}
			return $ret;
		}

		function Encode($type, $str)
		{
			switch ($type)
			{
				case 'base64':
					return chunk_split(base64_encode($str));
				case '8bit':
				default:
					return convert_cyr_string($str, 'w', 'k');
			}
		}

		function BuildPart(&$part)
		{
			$name = $part['name'] ? $this->Base64($part['name']) : false;
			return 'Content-Type: '. $part['type'] 
					.( $name ? ";\r\n\tname=\"". $name . '"' : '' )
					."\r\nContent-Transfer-Encoding: ". $part['encode'] 
					.( $name ? "\r\nContent-Disposition: attachment;\r\n\tfilename=\"". $name .'"' : '')
					."\r\n\r\n". $this->Encode($part['encode'], $part['message']) ."\r\n";
		}

		function BuildMultipart()
		{
			$boundary = 'b'. md5(uniqid(time()));
			$multipart = "Content-Type: multipart/mixed;\r\n\tboundary=" . $boundary . "\r\n\r\nThis is a Mime encoded message. \r\n\r\n--" . $boundary;
			for ($i=0, $c=count($this->parts); $i<$c; $i++)
			{
				$multipart.= "\r\n". $this->BuildPart($this->parts[$i]) . '--' . $boundary;
			}
			return $multipart."--\r\n";
		}

		function GetMailBody($complete=false)
		{
			$mime = '';
			if ($complete)
			{
/* ?			if (!empty($this->headers))
				{
					$mime.= 'From: '. $this->headers . "\r\n";
				}*/
				if (!empty($this->from))
				{
					$mime.= 'From: '. $this->from . "\r\n";
				}
				if (!empty($this->to))
				{
					$mime.= 'To: '. $this->to . "\r\n";
				}
				if (!empty($this->subject))
				{
					$mime.= 'Subject: '. $this->Base64($this->subject, MAIL_MIME_BASE64LINE) . "\r\n";
				}
			}
			if (!empty($this->body))
			{
				$this->AddAttachment($this->body, '', "text/plain;\r\n\tcharset=\"koi8-r\"", '8bit');
			}
			$mime .= "MIME-Version: 1.0\r\n" . $this->BuildMultipart();
			return $mime;
		}

/*		function Send()
		{
			mail($this->to, $this->subject, $this->body, '', '');
		}*/
	}
}
?>