<?php
if (!defined('__STORAGE__'))
{
	define('__STORAGE__', true);

	define('FILE_UPLOAD_MAX_SIZE', '16777215'); // in bytes
	class Storage
	{
		public $id = null;
		public $table = null;
		public $index = null;
		public $connection = null;
		public $lastallrows = null;
		public $countallrows = false;
		public $title = null;

		function Storage(&$connection, $table = null, $index = null)
		{
			$this->id = null;
			$this->title = null;
			$this->connection = &$connection;
			$this->table = $table;
			$this->index = $index;
			$this->aplite_file_store_db = (!isset($GLOBALS['aplite_file_store_db'])) ? FALSE : (bool)$GLOBALS['aplite_file_store_db'];
			$this->lastallrows = null;
			$this->CountAllRows(false);
		}

		function SetId($id)
		{
			if ($id != null)
				if ($this->CountRecs($this->table, $this->index.'='.(int)$id) > 0)
					$this->id = (int)$id;
		}
		
		function GetId()
		{
			return $this->id;
		}
		
		function SetProperties($id)
		{
			if ($id != null)
			{
				$data = $this->GetRec($this->table, '*', $this->index.'='.(int)$id);
				if ($data != false)
				{
					$this->id = $data[$this->index];
					foreach ($data as $key => $value)
					{
						$key = strtolower($key);
						$this->$key = $value;
					}
				}
			}
		}

		function CountAllRows($s = '')
		{
			if ($s === '')	$this->countallrows = !$this->countallrows;
			else			$this->countallrows = (bool)$s;
		}

		function GetConnection()
		{
			return $this->connection;
		}

		function RestoreConnection(&$connection)
		{
			$this->connection = &$connection;
		}

		function SetDebug($s = '')
		{
			$this->connection->SetDebug($s);
		}

		function GetTitle()
		{
			if ($this->id == null)	return false;
			if ($this->title == null) $this->title = $this->GetRec($this->table, 'Title', $this->index.'='.$this->id);
			return $this->title;
		}

		function _GetEntityProperties($table, $property = DB::PROPERTY_AUTO_INCREMENT)
		{
			return $this->connection->getTableProperties($table, $property);
		}

		function GetParam($param)
		{
			if (!isset($this->$param))	return false;
			else						return $this->$param;
		}

		function CountRecs($table, $cond = DB::WHERE_CLAUSE_NEUTRAL)
		{
			if ($table === null) $table = $this->table;
			return $this->connection->countTableRecs($table, $cond);
		}

		/**
		 * Storage::GetRec()
		 *
		 * @param $table	string tablename
		 * @param $fields	string commaseparatedlist
		 * @param $cond		string sqlcondition
		 * @return	string fieldvalue	if there's only 1 field
		 * 			array tablerow(fieldname1=>fieldvalue1,fieldname2=>fieldvalue2[,...])
		 */
		function GetRec($table, $fields, $cond = DB::WHERE_CLAUSE_NEUTRAL)
		{
			$sql = 'SELECT '.$fields.' FROM '.$table.' WHERE '.$cond;
			$res = $this->connection->exec($sql);
			$ret = false;
            if ($this->connection->getRowCount($res) == 0) return $ret;
			$fc = $this->connection->getFieldCount($res);
			if ($fc == 1)
				$ret = $this->connection->getField($res);
			else
				for($i = 0; $i < $fc; $i++)
					$ret[$this->connection->getFieldName($res, $i)] = $this->connection->getField($res, 0, $i);
			$this->lastallrows = 1;
            return $ret;
		}

		/**
		 * Storage::GetPairs()
		 *
		 * @param $table	string tablename
		 * @param $key		NULL
		 * 					string
		 * @param $value	string
		 * @param $order	string sqlorder
		 * @param $cond		string sqlcondition
		 * @return 	array rows(value1[,...])	if $key===NULL
		 * 			array rows(key1=>value1[,...])
		 */
		function GetPairs($table, $key, $value, $order = '1', $cond = DB::WHERE_CLAUSE_NEUTRAL, $limit = DB::LIMIT_CLAUSE_DEFAULT)
		{
			$sql = $this->connection->PrepareQuery($table, (($key!==null)?$key.',':'').$value, $cond, $order, $limit);
			$ret = array();
			if ($res = $this->connection->exec($sql))
			{
				$rc = $this->connection->getRowCount($res);
				if ($key===null)
					for($j = 0; $j < $rc; $j++)
						$ret[] = $this->connection->getField($res, $j, 0);
				else
					for($j = 0; $j < $rc; $j++)
						$ret[$this->connection->getField($res, $j, 0)] = $this->connection->getField($res, $j, 1);
			}
			if ($this->countallrows)
			{
				$this->lastallrows = $this->CountRecs($table, $cond);
			}
			return $ret;
		}

		/**
		 * Storage::GetAllRecs()
		 *
		 * @param $table	string tablename
		 * @param $fields	string commaseparatedlist
		 * @param $key		NULL
		 * 					string keyfieldname
		 * @param $order	string sqlorder
		 * @param $cond		string sqlcondition
		 * @param $limit	string
		 * @return	array rows(array row0(fieldname1=>fieldvalue1[,...])[,...])		if $key===NULL
		 * 			array rows(row0keyfieldvalue=>array row(row0fieldname1=>row0fieldvalue1,row0fieldname2=>row0fieldvalue2[,...])[,...])
		 */
		function GetAllRecs($table, $fields, $key = null, $order = "1", $cond = DB::WHERE_CLAUSE_NEUTRAL, $limit = "")
		{
			if ($fields!='*')
				$fields = (($key!==null)?$key.',':'').$fields;
			$sql = $this->connection->PrepareQuery($table, $fields, $cond, $order, $limit);
			$ret = array();
			if ($res = $this->connection->exec($sql))
			{
				$fc = $this->connection->getFieldCount($res);
				$rc = $this->connection->getRowCount($res);
				for($i = 0; $i < $fc; $i++)
					$filedNames[] = $this->connection->getFieldName($res, $i);
				if ($key===null)
					for($j = 0; $j < $rc; $j++)
						for($i = 0; $i < $fc; $i++)
							$ret[$j][$filedNames[$i]] = $this->connection->getField($res, $j, $i);
				else
				{
					$i_key = (int)array_search($key, $filedNames);
					for($j = 0; $j < $rc; $j++)
						for($i = 0; $i < $fc; $i++)
							$ret[$this->connection->getField($res, $j, $i_key)][$filedNames[$i]] = $this->connection->getField($res, $j, $i);
				}
			}
			if ($this->countallrows)
			{
				$this->lastallrows = $this->CountRecs($table, $cond);
			}
			return $ret;
		}
	}
}
?>