<?php
if (!defined("__XMLExchanger__"))
{
	define("__XMLExchanger__", true);
	
	include_once(dirname(__FILE__)."/storage.php");
		
	define("OPENFILE_ERROR", -1);
	define("XML_SYNTAX_ERROR", -2);

	class XMLExchanger extends Storage
	{
		public $connection = null;

		function XMLExchanger(&$connection)
		{
			$this->connection = $connection;
			$this->parser = xml_parser_create();
			$this->fileposition = Array(0,0);
			xml_parser_set_option ($this->parser, XML_OPTION_CASE_FOLDING, 0);
		}
		
		function Terminate()
		{
			xml_parser_free($this->parser);
		}
		
		function Parse($filename)
		{
			if ( !($fp = @fopen($filename, "r")) )
			{
				return OPENFILE_ERROR;
			}
			while($data = fread($fp, 4096))
			{
				if (!xml_parse($this->parser, $data, feof($fp)))
				{
					$this->fileposition[0] = xml_get_current_line_number($this->parser);
					$this->fileposition[1] = xml_get_current_column_number($this->parser);
					return XML_SYNTAX_ERROR;
				}
			}
			$this->fileposition[0] = xml_get_current_line_number($this->parser);
			$this->fileposition[1] = xml_get_current_column_number($this->parser);
			return true;
		}
		
		function UpdateData($filename)
		{
			function openTeg_UpdateData($parser, $curteg, $attribs)
			{
				global $xmlexchanger_listattribs, $xmlexchanger_this;
				switch($curteg)
				{
					case "itemlist": 
						 $xmlexchanger_listattribs = $attribs;
					break;
					case "item": 
						$count_with_cur_identif = $xmlexchanger_this->CountRecs($xmlexchanger_listattribs["table"], $xmlexchanger_listattribs["key"]."='".$attribs[$xmlexchanger_listattribs["key"]]."'");
						switch($count_with_cur_identif)
						{
							case 0:
								echo('<span style="color:#FF0000">    : '. $attribs[$xmlexchanger_listattribs["key"]].'</span><br>');
							break;
							
							case 1:
								$sql = "UPDATE ".$xmlexchanger_listattribs["table"]." SET ";
								$comma = "";
								foreach($attribs as $key => $value)
								{
									$sql .= $comma.$key."='".$value."'";
									$comma = ",";
								}
								$sql .=  " WHERE ".$xmlexchanger_listattribs["key"]."='".$attribs[$xmlexchanger_listattribs["key"]]."'";
								if ($xmlexchanger_this->connection->exec($sql))
								{
									echo('    : '.$attribs[$xmlexchanger_listattribs["key"]]."<br>");
								}
							break;
							
							default:
								echo('<span style="color:#FF0000">      : '. $attribs[$xmlexchanger_listattribs["key"]].'</span><br>');
							break;
						}
					break;
				}
			}
			
			function contentTegs_UpdateData($parser, $curteg)
			{
			}
			
			function closeTeg_UpdateData($parser, $curteg)
			{
			}
			
			xml_set_element_handler($this->parser, "openTeg_UpdateData", "closeTeg_UpdateData");
			xml_set_character_data_handler($this->parser, "contentTegs_UpdateData");
			global $xmlexchanger_this; 
			$xmlexchanger_this = $this;
			return $this->Parse($filename);
		}


	}
}
?>