<?php
if(!defined('__FILTERS__'))
{
	define('__FILTERS__', true);

	function unParseHtml($content, $code = false)
	{
		$content = str_replace("\\\\","\\", $content);
		$content = str_replace('&quot;', '"', $content);
		$content = str_replace('&#039;', "'", $content);
		if (!$code)
		{
			$content = str_replace(array('<br>', '<br /> ', '<br/>'), "\n", $content);
		}
		$content = str_replace('&gt;', '>', $content);
		$content = str_replace('&lt;', '<', $content);
		$content = str_replace('&amp;', '&amp;amp;', $content);
		return $content;
	}

	function parseHtml($content)
	{
		$content = stripslashes($content);
		$content = str_replace("\\","\\\\", $content);
		$content = htmlspecialchars($content, ENT_QUOTES);
		$content = nl2br($content);
		$content = preg_replace("/[\s]{2,}/", ' ', $content);
		return $content;
	}

	function delBr($content)
	{
		$content = str_replace("\r\n", '', $content);
		$content = str_replace("\n", '', $content);
		$content = str_replace('"', '\"', $content);
		return $content;
	}

	function trimArray($el, $arr = array('/'))
	{
		return trim($el, implode('', $arr));
	}

	function checkIdentifier($identificator, $class = '')
	{
		global $id_filters;
		if (strlen($class) && isset($id_filters[$class]))
		{
			if(($id_filters[$class]['filter'] & TOLOWER) == TOLOWER)
			{
				$identificator = strtolower($identificator);
			}
			if(($id_filters[$class]['filter'] & TOUPPER) == TOUPPER)
			{
				$identificator = strtoupper($identificator);
			}
			foreach($id_filters[$class]['mask'] as $mask)
			{
				if (!preg_match($mask, $identificator))
				{
					return false;
				}
			}
		}
		return $identificator;
	}

	function isMail($mail)
	{
		if ($mail == '') {
			return false;
		}
		$user = '[-!#$%&\'*+.\/\d=?A-Z^_`a-z{|}~]';
		$domain = '[-!#$%&\'*+\/\d=?A-Z^_`a-z{|}~]';
		return preg_match('/^'.$user.'+@'.$domain.'{2,}\.'.$domain.'{2,4}$/', $mail);
	}

	// -    
	function unregsession($var)
	{
		if (ini_get('register_globals'))
		{
			session_unregister($var);
			unset($GLOBALS[$var]);
		}
		else
		{
			unset($_SESSION[$var]);
		}
	}

	function pr(&$obj, $name = '')
	{
		echo '<pre>',($name!=''?'$'.$name.': 
':'');
		print_r($obj);
		echo '</pre>';
	}

	//       
	function cmp($a, $b)
	{
		global $sortc, $sortd;
		if (!isset($sortd)) $sortd = 1; // asc
		return (strnatcmp($a[$sortc], $b[$sortc]) * $sortd);
	}

	/*
	 *      
	*/
	function strcase($s, $case = 1)
	{
		if (strlen($s)==0) return $s;
		$s_lo = 'abcdefghigklmnopqrstuvwxyz';
		$s_up = 'ŨABCDEFGHIGKLMNOPQRSTUVWXYZ';
		switch ($case)
		{
			case 1: // to upper
			case 'upper':
				$s = strtr($s, $s_lo, $s_up);
				break;
			case 2: // to lower
			case 'lower':
				$s = strtr($s, $s_up, $s_lo);
				break;
		}
		return $s;
	}//*/
}
?>