<?php
/*
 * ie.php
 *       ,   -.
 * TODO:    ,    .
*/

/*
 * apl_ie_save -     ,   
 * 
 * @param $ie		-  , ID  Identifier
 * @param $non_empty-   ,     
 * @param $id		- ID  
 * @param $rub_id	- ID ,     
 * 
*/
function apl_ie_save($ie, $non_empty=array(), $id=null, $rub_id=null)
{
	global $DB;
	if (!$ie instanceof IE) $ie = new IE($DB, $ie);
	if (!$ie->GetId())
	{
		$_SESSION['error'] = Error_User::ERR_NUM_SYSTEM;
		return false;
	}
	else
	{
		if ($id != null)
		{
			$data = $ie->GetData($id);
		}
		$texts = Array();
		$textareas = Array();
		$htmls = Array();
		$checkboxs = Array();
		$regexps = Array();
		$files = Array();
		$dates = array();
		$selects = Array();
		$attaches = Array();
		
		$fields = $ie->GetFields();
		$_SESSION['field_errors'] = array();
		foreach($fields as $key => $field)
		{
			if (in_array($field['Identifier'], $non_empty) && empty($_POST[$field['Identifier']]))
			{
				$_SESSION['error'] = Error_User::ERR_NUM_EMPTY;
				$_SESSION['field_errors'][$field['Identifier']] = 1;
				//continue;
			}
			if (isset($_POST[$field['Identifier']]))// || isset($_FILES[$field['Identifier']]))
			  switch($field['Kind'])
			{
				case "date":
					$dates[$field['Identifier']] = $DB->EscapeString($_POST[$field['Identifier']]);
					break;
				case 'text':
					$_POST[$field['Identifier']] = parseHtml($_POST[$field['Identifier']]);
					$texts[$field['Identifier']] = $DB->EscapeString($_POST[$field['Identifier']]);
					break;
				case 'int':
				case 'float':
					$texts[$field['Identifier']] = $DB->EscapeString($_POST[$field['Identifier']]);
					break;
				case 'textarea':
					$textareas[$field['Identifier']] = $DB->EscapeString(parseHtml($_POST[$field['Identifier']]));
					//$_POST[$field['Identifier']] = $_POST[$field['Identifier']];
					break;
				case "html":
					$htmls[$field['Identifier']] = $DB->EscapeString(preg_replace(array("/<script.*>.*<\/script>/is","/^<P>&nbsp;<\/P>$/i","/^<P><\/P>$/i"), "", stripslashes($_POST[$field['Identifier']])));
					break;
				case 'select':
					$selects[$field['Identifier']] = $DB->EscapeString($_POST[$field['Identifier']]);
					break;
				case 'ie':
					$attaches[$field['Identifier']] = (int)$_POST[$field['Identifier']];
					break;
				case 'checkbox':
					$checkboxs[$field['Identifier']] = $_POST[$field['Identifier']]>0 ? 1 : 0;
					break;
				case 'regexp':
					if (!preg_match('/'.$field['Properties'].'/', $_POST[$field['Identifier']]))
					{
						if (empty($_SESSION['error'])) $_SESSION['error'] = Error_User::ERR_NUM_FORMAT;
						$_SESSION['field_errors'][$field['Identifier']] = 1;
//						return false;
					}
					$_POST[$field['Identifier']] = parseHtml($_POST[$field['Identifier']]);
					$regexps[$field['Identifier']] = $DB->EscapeString($_POST[$field['Identifier']]);
					break;
				case "password":
					if ($id == null || !empty($_POST[$field['Identifier'].'_old']))
					{
						if ($id != null)
						{
							if ($data[$field['Identifier']] != $_POST[$field['Identifier'].'_old'])
							{
								if (empty($_SESSION['error'])) $_SESSION['error'] = Error_User::ERR_NUM_BADPASS;
								$_SESSION['field_errors'][$field['Identifier'].'_old'] = 1;
								break;
							}
						}
						if ($_POST[$field['Identifier']] == $_POST[$field['Identifier'].'_confirm'] && $_POST[$field['Identifier']] != '')
						{
							$texts[$field['Identifier']] = $DB->EscapeString($_POST[$field['Identifier']]);
						}
						else
						{
							if (empty($_SESSION['error'])) $_SESSION['error'] = Error_User::ERR_NUM_PASSEQ;
							$_SESSION['field_errors'][$field['Identifier']] = 1;
						}
					}
					break;
/*				case 'file':
					$files[$field['Identifier']] = &$_FILES[$field['Identifier']];
					$_POST[$field['Identifier']] = $_FILES[$field['Identifier']]['name'];
					break;*/
			}
		}
		if (sizeof($_SESSION['field_errors']) > 0 || sizeof($texts)==0 && sizeof($textareas)==0 && sizeof($htmls)==0 && sizeof($checkboxs)==0 && sizeof($regexps)==0 && sizeof($files)==0 && sizeof($dates)==0 && sizeof($selects)==0 && sizeof($attaches)==0)
		{
			$_SESSION['post'] = $_POST;
			return false;
		}
		unregsession('field_errors');
		
		$id = $ie->SaveData($id, APL_ADMIN_GUESTID, $texts, $textareas, $htmls, $checkboxs, $regexps, $files, $dates, $selects, $attaches);
		
		if (!$id)
		{
			$_SESSION['error'] = Error_User::ERR_NUM_SYSTEM;
			return false;
		}
		else
		{
			//$_SESSION['Id'] = $id;
			// 
			if ($rub_id != null)
			{
				$rub = new Rub($DB, $rub_id);
				if ($rub->GetId())
				{
					$ie->PublishInRubs($id, array($rub_id), APL_ADMIN_GUESTID);
				}
			}
		}
	}
	return $id;
}

/*
 * apl_ie_show -    .        
 * 
 * @param $ie		-  , ID  Identifier
 * @param $template_container	-  
 * @param $template_key		-     
 * @param $id		- ID  
 * 
*/
function apl_ie_show($ie, $template_container = 'index.include.', $template_key=null, $id=null)
{
	global $DB, $xtpl;
	if (!$ie instanceof IE) $ie = new IE($DB, $ie);
	if (!$ie->GetId())
	{
		$_SESSION['error'] = Error_User::ERR_NUM_SYSTEM;
		return false;
	}
	else
	{
		if ($template_key == null) $template_key = $ie->identifier.'_';
		$data = array();
		if ($id != null)
		{
			$data = $ie->GetData($id);
		}
		else if (isset($_SESSION['post']))
		{
			$data = $_SESSION['post'];
		}
		$fields = $ie->GetFields();
		foreach($fields as $key => $field)
		{
			if (!empty($_SESSION['field_errors'][$field['Identifier']]))
			{
				$xtpl->parse($template_container.$template_key.$field['Identifier'].'_error');
			}
			if (isset($data[$field['Identifier']]))
			switch($field['Kind'])
			{
/*				case "date":
					$xtpl->assign($template_key.$field['Identifier'], $data[$field['Identifier']]);
					$dates[$field['Identifier']] = $DB->EscapeString($_POST[$field['Identifier']]);
					break;*/
				case 'text':
				case 'regexp':
				case 'textarea':
					$xtpl->assign($template_key.$field['Identifier'], $data[$field['Identifier']]);
					break;
				case 'int':
				case 'float':
					$xtpl->assign($template_key.$field['Identifier'], htmlspecialchars($data[$field['Identifier']]));
					break;
				case 'select':
					$objField = $ie->GetFieldObj($field['Identifier']);
					$select = $objField->GetSelect();
					foreach($select as $selvalue => $seltext)
					{
						$xtpl->assign('selected', isset($data[$field['Identifier']]) && $data[$field['Identifier']] == $selvalue ? ' selected' : '');
						$xtpl->assign('selvalue', $selvalue);
						$xtpl->assign('seltext', $seltext);
						$xtpl->parse($template_container.$template_key.$field['Identifier'].'_select');
					}
					break;
				case 'ie':
					$objAttachedIe = new IE($DB, $field['Properties_I']);
					$alldata = $objAttachedIe->GetAllData(0, -1, 2, 'TITLE');
					foreach($alldata as $att_id => $att_value)
					{
						$xtpl->assign('selected', isset($data[$field['Identifier']]) && $data[$field['Identifier']] == $att_id ? ' selected' : '');
						$xtpl->assign('selvalue', $att_id);
						$xtpl->assign('seltext', $att_value['TITLE']);
						$xtpl->parse($template_container.$template_key.$field['Identifier'].'_ie');
					}
					break;
				case 'checkbox':
					if ($data[$field['Identifier']] == 1) $xtpl->assign($field['Identifier'].'_checked', ' checked');
					break;
				case "password":
						if (!empty($_SESSION['field_errors'][$field['Identifier'].'_old']))
						{
							$xtpl->parse($template_container.$template_key.$field['Identifier'].'_o_error');
						}
						if (!empty($_SESSION['field_errors'][$field['Identifier']]))
						{
							$xtpl->parse($template_container.$template_key.$field['Identifier'].'_c_error');
						}
					break;
/*				case 'file':
					$files[$field['Identifier']] = &$_FILES[$field['Identifier']];
					$_POST[$field['Identifier']] = $_FILES[$field['Identifier']]['name'];
					break;*/
			}
		}
	}
	return true;
}
?>